///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:52 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_rcc.c                                             /
//    Command line =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_rcc.c -D USE_STDPERIPH_DRIVER -D STM32F10X_HD -D  /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\s /
//                    tm32f10x_rcc.s                                          /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME stm32f10x_rcc

        PUBLIC RCC_ADCCLKConfig
        PUBLIC RCC_AHBPeriphClockCmd
        PUBLIC RCC_APB1PeriphClockCmd
        PUBLIC RCC_APB1PeriphResetCmd
        PUBLIC RCC_APB2PeriphClockCmd
        PUBLIC RCC_APB2PeriphResetCmd
        PUBLIC RCC_AdjustHSICalibrationValue
        PUBLIC RCC_BackupResetCmd
        PUBLIC RCC_ClearFlag
        PUBLIC RCC_ClearITPendingBit
        PUBLIC RCC_ClockSecuritySystemCmd
        PUBLIC RCC_DeInit
        PUBLIC RCC_GetClocksFreq
        PUBLIC RCC_GetFlagStatus
        PUBLIC RCC_GetITStatus
        PUBLIC RCC_GetSYSCLKSource
        PUBLIC RCC_HCLKConfig
        PUBLIC RCC_HSEConfig
        PUBLIC RCC_HSICmd
        PUBLIC RCC_ITConfig
        PUBLIC RCC_LSEConfig
        PUBLIC RCC_LSICmd
        PUBLIC RCC_MCOConfig
        PUBLIC RCC_PCLK1Config
        PUBLIC RCC_PCLK2Config
        PUBLIC RCC_PLLCmd
        PUBLIC RCC_PLLConfig
        PUBLIC RCC_RTCCLKCmd
        PUBLIC RCC_RTCCLKConfig
        PUBLIC RCC_SYSCLKConfig
        PUBLIC RCC_USBCLKConfig
        PUBLIC RCC_WaitForHSEStartUp

// C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm32f10x_rcc.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file  stm32f10x_rcc.c
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  This file provides all the RCC firmware functions.
//    8   ******************************************************************************
//    9   * @copy
//   10   *
//   11   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   12   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   13   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   14   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   15   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   16   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   17   *
//   18   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   19   */ 
//   20 
//   21 /* Includes ------------------------------------------------------------------*/
//   22 #include "stm32f10x_rcc.h"
//   23 
//   24 /** @addtogroup StdPeriph_Driver
//   25   * @{
//   26   */
//   27 
//   28 /** @defgroup RCC 
//   29   * @brief RCC driver modules
//   30   * @{
//   31   */ 
//   32 
//   33 /** @defgroup RCC_Private_TypesDefinitions
//   34   * @{
//   35   */
//   36 
//   37 /**
//   38   * @}
//   39   */
//   40 
//   41 /** @defgroup RCC_Private_Defines
//   42   * @{
//   43   */
//   44 
//   45 /* ------------ RCC registers bit address in the alias region ----------- */
//   46 #define RCC_OFFSET                (RCC_BASE - PERIPH_BASE)
//   47 
//   48 /* --- CR Register ---*/
//   49 
//   50 /* Alias word address of HSION bit */
//   51 #define CR_OFFSET                 (RCC_OFFSET + 0x00)
//   52 #define HSION_BitNumber           0x00
//   53 #define CR_HSION_BB               (PERIPH_BB_BASE + (CR_OFFSET * 32) + (HSION_BitNumber * 4))
//   54 
//   55 /* Alias word address of PLLON bit */
//   56 #define PLLON_BitNumber           0x18
//   57 #define CR_PLLON_BB               (PERIPH_BB_BASE + (CR_OFFSET * 32) + (PLLON_BitNumber * 4))
//   58 
//   59 /* Alias word address of CSSON bit */
//   60 #define CSSON_BitNumber           0x13
//   61 #define CR_CSSON_BB               (PERIPH_BB_BASE + (CR_OFFSET * 32) + (CSSON_BitNumber * 4))
//   62 
//   63 /* --- CFGR Register ---*/
//   64 
//   65 /* Alias word address of USBPRE bit */
//   66 #define CFGR_OFFSET               (RCC_OFFSET + 0x04)
//   67 #define USBPRE_BitNumber          0x16
//   68 #define CFGR_USBPRE_BB            (PERIPH_BB_BASE + (CFGR_OFFSET * 32) + (USBPRE_BitNumber * 4))
//   69 
//   70 /* --- BDCR Register ---*/
//   71 
//   72 /* Alias word address of RTCEN bit */
//   73 #define BDCR_OFFSET               (RCC_OFFSET + 0x20)
//   74 #define RTCEN_BitNumber           0x0F
//   75 #define BDCR_RTCEN_BB             (PERIPH_BB_BASE + (BDCR_OFFSET * 32) + (RTCEN_BitNumber * 4))
//   76 
//   77 /* Alias word address of BDRST bit */
//   78 #define BDRST_BitNumber           0x10
//   79 #define BDCR_BDRST_BB             (PERIPH_BB_BASE + (BDCR_OFFSET * 32) + (BDRST_BitNumber * 4))
//   80 
//   81 /* --- CSR Register ---*/
//   82 
//   83 /* Alias word address of LSION bit */
//   84 #define CSR_OFFSET                (RCC_OFFSET + 0x24)
//   85 #define LSION_BitNumber           0x00
//   86 #define CSR_LSION_BB              (PERIPH_BB_BASE + (CSR_OFFSET * 32) + (LSION_BitNumber * 4))
//   87 
//   88 /* ---------------------- RCC registers bit mask ------------------------ */
//   89 
//   90 /* CR register bit mask */
//   91 #define CR_HSEBYP_Reset           ((uint32_t)0xFFFBFFFF)
//   92 #define CR_HSEBYP_Set             ((uint32_t)0x00040000)
//   93 #define CR_HSEON_Reset            ((uint32_t)0xFFFEFFFF)
//   94 #define CR_HSEON_Set              ((uint32_t)0x00010000)
//   95 #define CR_HSITRIM_Mask           ((uint32_t)0xFFFFFF07)
//   96 
//   97 /* CFGR register bit mask */
//   98 #define CFGR_PLL_Mask             ((uint32_t)0xFFC0FFFF)
//   99 #define CFGR_PLLMull_Mask         ((uint32_t)0x003C0000)
//  100 #define CFGR_PLLSRC_Mask          ((uint32_t)0x00010000)
//  101 #define CFGR_PLLXTPRE_Mask        ((uint32_t)0x00020000)
//  102 #define CFGR_SWS_Mask             ((uint32_t)0x0000000C)
//  103 #define CFGR_SW_Mask              ((uint32_t)0xFFFFFFFC)
//  104 #define CFGR_HPRE_Reset_Mask      ((uint32_t)0xFFFFFF0F)
//  105 #define CFGR_HPRE_Set_Mask        ((uint32_t)0x000000F0)
//  106 #define CFGR_PPRE1_Reset_Mask     ((uint32_t)0xFFFFF8FF)
//  107 #define CFGR_PPRE1_Set_Mask       ((uint32_t)0x00000700)
//  108 #define CFGR_PPRE2_Reset_Mask     ((uint32_t)0xFFFFC7FF)
//  109 #define CFGR_PPRE2_Set_Mask       ((uint32_t)0x00003800)
//  110 #define CFGR_ADCPRE_Reset_Mask    ((uint32_t)0xFFFF3FFF)
//  111 #define CFGR_ADCPRE_Set_Mask      ((uint32_t)0x0000C000)
//  112 
//  113 /* CSR register bit mask */
//  114 #define CSR_RMVF_Set              ((uint32_t)0x01000000)
//  115 
//  116 /* RCC Flag Mask */
//  117 #define FLAG_Mask                 ((uint8_t)0x1F)
//  118 
//  119 /* Typical Value of the HSI in Hz */
//  120 #define HSI_Value                 ((uint32_t)8000000)
//  121 
//  122 /* CIR register byte 2 (Bits[15:8]) base address */
//  123 #define CIR_BYTE2_ADDRESS         ((uint32_t)0x40021009)
//  124 
//  125 /* CIR register byte 3 (Bits[23:16]) base address */
//  126 #define CIR_BYTE3_ADDRESS         ((uint32_t)0x4002100A)
//  127 
//  128 /* CFGR register byte 4 (Bits[31:24]) base address */
//  129 #define CFGR_BYTE4_ADDRESS        ((uint32_t)0x40021007)
//  130 
//  131 /* BDCR register base address */
//  132 #define BDCR_ADDRESS              (PERIPH_BASE + BDCR_OFFSET)
//  133 
//  134 #ifndef HSEStartUp_TimeOut
//  135 /* Time out for HSE start up */
//  136 #define HSEStartUp_TimeOut        ((uint16_t)0x0500)
//  137 #endif
//  138 
//  139 /**
//  140   * @}
//  141   */ 
//  142 
//  143 /** @defgroup RCC_Private_Macros
//  144   * @{
//  145   */ 
//  146 
//  147 /**
//  148   * @}
//  149   */ 
//  150 
//  151 /** @defgroup RCC_Private_Variables
//  152   * @{
//  153   */ 
//  154 

        SECTION `.data`:DATA:NOROOT(2)
//  155 static __I uint8_t APBAHBPrescTable[16] = {0, 0, 0, 0, 1, 2, 3, 4, 1, 2, 3, 4, 6, 7, 8, 9};
APBAHBPrescTable:
        DATA
        DC8 0, 0, 0, 0, 1, 2, 3, 4, 1, 2, 3, 4, 6, 7, 8, 9
        DC8 2, 4, 6, 8
//  156 static __I uint8_t ADCPrescTable[4] = {2, 4, 6, 8};
//  157 
//  158 /**
//  159   * @}
//  160   */
//  161 
//  162 /** @defgroup RCC_Private_FunctionPrototypes
//  163   * @{
//  164   */
//  165 
//  166 /**
//  167   * @}
//  168   */
//  169 
//  170 /** @defgroup RCC_Private_Functions
//  171   * @{
//  172   */
//  173 
//  174 /**
//  175   * @brief  Resets the RCC clock configuration to the default reset state.
//  176   * @param  None
//  177   * @retval : None
//  178   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  179 void RCC_DeInit(void)
//  180 {
//  181   /* Set HSION bit */
//  182   RCC->CR |= (uint32_t)0x00000001;
RCC_DeInit:
        LDR.N    R0,??DataTable13  ;; 0x40021000
        LDR      R1,[R0, #+0]
        ORR      R1,R1,#0x1
        STR      R1,[R0, #+0]
//  183   /* Reset SW[1:0], HPRE[3:0], PPRE1[2:0], PPRE2[2:0], ADCPRE[1:0] and MCO[2:0] bits */
//  184   RCC->CFGR &= (uint32_t)0xF8FF0000;
        LDR      R1,[R0, #+4]
        LDR.N    R2,??RCC_DeInit_0  ;; 0xf8ff0000
        ANDS     R1,R2,R1
        STR      R1,[R0, #+4]
//  185   
//  186   /* Reset HSEON, CSSON and PLLON bits */
//  187   RCC->CR &= (uint32_t)0xFEF6FFFF;
        LDR      R1,[R0, #+0]
        LDR.N    R2,??RCC_DeInit_0+0x4  ;; 0xfef6ffff
        ANDS     R1,R2,R1
        STR      R1,[R0, #+0]
//  188   /* Reset HSEBYP bit */
//  189   RCC->CR &= (uint32_t)0xFFFBFFFF;
        LDR      R1,[R0, #+0]
        BIC      R1,R1,#0x40000
        STR      R1,[R0, #+0]
//  190   /* Reset PLLSRC, PLLXTPRE, PLLMUL[3:0] and USBPRE bits */
//  191   RCC->CFGR &= (uint32_t)0xFF80FFFF;
        LDR      R1,[R0, #+4]
        BIC      R1,R1,#0x7F0000
        STR      R1,[R0, #+4]
//  192   /* Disable all interrupts */
//  193   RCC->CIR = 0x00000000;
        MOVS     R1,#+0
        STR      R1,[R0, #+8]
//  194 }
        BX       LR               ;; return
        DATA
??RCC_DeInit_0:
        DC32     0xf8ff0000
        DC32     0xfef6ffff
//  195 
//  196 /**
//  197   * @brief  Configures the External High Speed oscillator (HSE).
//  198   *   HSE can not be stopped if it is used directly or through the 
//  199   *   PLL as system clock.
//  200   * @param RCC_HSE: specifies the new state of the HSE.
//  201   *   This parameter can be one of the following values:
//  202   * @arg RCC_HSE_OFF: HSE oscillator OFF
//  203   * @arg RCC_HSE_ON: HSE oscillator ON
//  204   * @arg RCC_HSE_Bypass: HSE oscillator bypassed with external
//  205   *   clock
//  206   * @retval : None
//  207   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  208 void RCC_HSEConfig(uint32_t RCC_HSE)
//  209 {
//  210   /* Check the parameters */
//  211   assert_param(IS_RCC_HSE(RCC_HSE));
//  212   /* Reset HSEON and HSEBYP bits before configuring the HSE ------------------*/
//  213   /* Reset HSEON bit */
//  214   RCC->CR &= CR_HSEON_Reset;
RCC_HSEConfig:
        LDR.N    R1,??DataTable13  ;; 0x40021000
        LDR      R2,[R1, #+0]
        BIC      R2,R2,#0x10000
        STR      R2,[R1, #+0]
//  215   /* Reset HSEBYP bit */
//  216   RCC->CR &= CR_HSEBYP_Reset;
        LDR      R2,[R1, #+0]
        BIC      R2,R2,#0x40000
        STR      R2,[R1, #+0]
//  217   /* Configure HSE (RCC_HSE_OFF is already covered by the code section above) */
//  218   switch(RCC_HSE)
        CMP      R0,#+65536
        BEQ.N    ??RCC_HSEConfig_0
        CMP      R0,#+262144
        BEQ.N    ??RCC_HSEConfig_1
        BX       LR
//  219   {
//  220     case RCC_HSE_ON:
//  221       /* Set HSEON bit */
//  222       RCC->CR |= CR_HSEON_Set;
??RCC_HSEConfig_0:
        LDR      R0,[R1, #+0]
        ORR      R0,R0,#0x10000
        B.N      ??RCC_HSEConfig_2
//  223       break;
//  224       
//  225     case RCC_HSE_Bypass:
//  226       /* Set HSEBYP and HSEON bits */
//  227       RCC->CR |= CR_HSEBYP_Set | CR_HSEON_Set;
??RCC_HSEConfig_1:
        LDR      R0,[R1, #+0]
        ORR      R0,R0,#0x50000
??RCC_HSEConfig_2:
        STR      R0,[R1, #+0]
//  228       break;
//  229       
//  230     default:
//  231       break;
//  232   }
//  233 }
        BX       LR               ;; return
//  234 
//  235 /**
//  236   * @brief  Waits for HSE start-up.
//  237   * @param  None
//  238   * @retval : An ErrorStatus enumuration value:
//  239   * - SUCCESS: HSE oscillator is stable and ready to use
//  240   * - ERROR: HSE oscillator not yet ready
//  241   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  242 ErrorStatus RCC_WaitForHSEStartUp(void)
//  243 {
RCC_WaitForHSEStartUp:
        PUSH     {R7,LR}
//  244   __IO uint32_t StartUpCounter = 0;
        MOVS     R0,#+0
        STR      R0,[SP, #+0]
//  245   ErrorStatus status = ERROR;
//  246   FlagStatus HSEStatus = RESET;
//  247   
//  248   /* Wait till HSE is ready and if Time out is reached exit */
//  249   do
//  250   {
//  251     HSEStatus = RCC_GetFlagStatus(RCC_FLAG_HSERDY);
??RCC_WaitForHSEStartUp_0:
        MOVS     R0,#+49
        BL       RCC_GetFlagStatus
//  252     StartUpCounter++;  
        LDR      R1,[SP, #+0]
        ADDS     R1,R1,#+1
        STR      R1,[SP, #+0]
//  253   } while((HSEStatus == RESET) && (StartUpCounter != HSEStartUp_TimeOut));
        CBNZ     R0,??RCC_WaitForHSEStartUp_1
        LDR      R0,[SP, #+0]
        CMP      R0,#+1280
        BNE.N    ??RCC_WaitForHSEStartUp_0
//  254   if (RCC_GetFlagStatus(RCC_FLAG_HSERDY) != RESET)
??RCC_WaitForHSEStartUp_1:
        MOVS     R0,#+49
        BL       RCC_GetFlagStatus
        CBZ      R0,??RCC_WaitForHSEStartUp_2
        MOVS     R0,#+1
//  255   {
//  256     status = SUCCESS;
//  257   }
//  258   else
//  259   {
//  260     status = ERROR;
//  261   }  
//  262   return (status);
??RCC_WaitForHSEStartUp_2:
        POP      {R1,PC}          ;; return
//  263 }
//  264 
//  265 /**
//  266   * @brief  Adjusts the Internal High Speed oscillator (HSI) calibration
//  267   *   value.
//  268   * @param HSICalibrationValue: specifies the calibration trimming value.
//  269   *   This parameter must be a number between 0 and 0x1F.
//  270   * @retval : None
//  271   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  272 void RCC_AdjustHSICalibrationValue(uint8_t HSICalibrationValue)
//  273 {
//  274   uint32_t tmpreg = 0;
//  275   /* Check the parameters */
//  276   assert_param(IS_RCC_CALIBRATION_VALUE(HSICalibrationValue));
//  277   tmpreg = RCC->CR;
RCC_AdjustHSICalibrationValue:
        LDR.N    R1,??DataTable13  ;; 0x40021000
        LDR      R2,[R1, #+0]
//  278   /* Clear HSITRIM[4:0] bits */
//  279   tmpreg &= CR_HSITRIM_Mask;
//  280   /* Set the HSITRIM[4:0] bits according to HSICalibrationValue value */
//  281   tmpreg |= (uint32_t)HSICalibrationValue << 3;
//  282   /* Store the new value */
//  283   RCC->CR = tmpreg;
        BIC      R2,R2,#0xF8
        B.N      ?Subroutine0
//  284 }
//  285 
//  286 /**
//  287   * @brief  Enables or disables the Internal High Speed oscillator (HSI).
//  288   *   HSI can not be stopped if it is used directly or through the 
//  289   *   PLL as system clock.
//  290   * @param NewState: new state of the HSI.
//  291   *   This parameter can be: ENABLE or DISABLE.
//  292   * @retval : None
//  293   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  294 void RCC_HSICmd(FunctionalState NewState)
//  295 {
//  296   /* Check the parameters */
//  297   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  298   *(__IO uint32_t *) CR_HSION_BB = (uint32_t)NewState;
RCC_HSICmd:
        LDR.N    R1,??RCC_HSICmd_0  ;; 0x42420000
        STR      R0,[R1, #+0]
//  299 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_HSICmd_0:
        DC32     0x42420000
//  300 
//  301 /**
//  302   * @brief  Configures the PLL clock source and multiplication factor.
//  303   *   This function must be used only when the PLL is disabled.
//  304   * @param RCC_PLLSource: specifies the PLL entry clock source.
//  305   *   This parameter can be one of the following values:
//  306   * @arg RCC_PLLSource_HSI_Div2: HSI oscillator clock divided
//  307   *   by 2 selected as PLL clock entry
//  308   * @arg RCC_PLLSource_HSE_Div1: HSE oscillator clock selected
//  309   *   as PLL clock entry
//  310   * @arg RCC_PLLSource_HSE_Div2: HSE oscillator clock divided
//  311   *   by 2 selected as PLL clock entry
//  312   * @param RCC_PLLMul: specifies the PLL multiplication factor.
//  313   *   This parameter can be RCC_PLLMul_x where x:[2,16]
//  314   * @retval : None
//  315   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  316 void RCC_PLLConfig(uint32_t RCC_PLLSource, uint32_t RCC_PLLMul)
//  317 {
//  318   uint32_t tmpreg = 0;
//  319   /* Check the parameters */
//  320   assert_param(IS_RCC_PLL_SOURCE(RCC_PLLSource));
//  321   assert_param(IS_RCC_PLL_MUL(RCC_PLLMul));
//  322   tmpreg = RCC->CFGR;
RCC_PLLConfig:
        LDR.N    R2,??DataTable12  ;; 0x40021004
        LDR      R3,[R2, #+0]
//  323   /* Clear PLLSRC, PLLXTPRE and PLLMUL[3:0] bits */
//  324   tmpreg &= CFGR_PLL_Mask;
//  325   /* Set the PLL configuration bits */
//  326   tmpreg |= RCC_PLLSource | RCC_PLLMul;
//  327   /* Store the new value */
//  328   RCC->CFGR = tmpreg;
        BIC      R3,R3,#0x3F0000
        ORRS     R0,R0,R3
        ORRS     R0,R1,R0
        STR      R0,[R2, #+0]
//  329 }
        BX       LR               ;; return
//  330 
//  331 /**
//  332   * @brief  Enables or disables the PLL.
//  333   *   The PLL can not be disabled if it is used as system clock.
//  334   * @param NewState: new state of the PLL.
//  335   *   This parameter can be: ENABLE or DISABLE.
//  336   * @retval : None
//  337   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  338 void RCC_PLLCmd(FunctionalState NewState)
//  339 {
//  340   /* Check the parameters */
//  341   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  342   *(__IO uint32_t *) CR_PLLON_BB = (uint32_t)NewState;
RCC_PLLCmd:
        LDR.N    R1,??RCC_PLLCmd_0  ;; 0x42420060
        STR      R0,[R1, #+0]
//  343 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_PLLCmd_0:
        DC32     0x42420060
//  344 
//  345 /**
//  346   * @brief  Configures the system clock (SYSCLK).
//  347   * @param RCC_SYSCLKSource: specifies the clock source used as system
//  348   *   clock. This parameter can be one of the following values:
//  349   * @arg RCC_SYSCLKSource_HSI: HSI selected as system clock
//  350   * @arg RCC_SYSCLKSource_HSE: HSE selected as system clock
//  351   * @arg RCC_SYSCLKSource_PLLCLK: PLL selected as system clock
//  352   * @retval : None
//  353   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  354 void RCC_SYSCLKConfig(uint32_t RCC_SYSCLKSource)
//  355 {
//  356   uint32_t tmpreg = 0;
//  357   /* Check the parameters */
//  358   assert_param(IS_RCC_SYSCLK_SOURCE(RCC_SYSCLKSource));
//  359   tmpreg = RCC->CFGR;
RCC_SYSCLKConfig:
        LDR.N    R1,??DataTable12  ;; 0x40021004
        LDR      R2,[R1, #+0]
//  360   /* Clear SW[1:0] bits */
//  361   tmpreg &= CFGR_SW_Mask;
//  362   /* Set SW[1:0] bits according to RCC_SYSCLKSource value */
//  363   tmpreg |= RCC_SYSCLKSource;
//  364   /* Store the new value */
//  365   RCC->CFGR = tmpreg;
        LSRS     R2,R2,#+2
        LSLS     R2,R2,#+2
        B.N      ?Subroutine1
//  366 }
//  367 
//  368 /**
//  369   * @brief  Returns the clock source used as system clock.
//  370   * @param  None
//  371   * @retval : The clock source used as system clock. The returned value can
//  372   *   be one of the following:
//  373   * - 0x00: HSI used as system clock
//  374   * - 0x04: HSE used as system clock
//  375   * - 0x08: PLL used as system clock
//  376   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  377 uint8_t RCC_GetSYSCLKSource(void)
//  378 {
//  379   return ((uint8_t)(RCC->CFGR & CFGR_SWS_Mask));
RCC_GetSYSCLKSource:
        LDR.N    R0,??DataTable12  ;; 0x40021004
        LDR      R0,[R0, #+0]
        AND      R0,R0,#0xC
        BX       LR               ;; return
//  380 }
//  381 
//  382 /**
//  383   * @brief  Configures the AHB clock (HCLK).
//  384   * @param RCC_SYSCLK: defines the AHB clock divider. This clock is derived from 
//  385   *                    the system clock (SYSCLK).
//  386   *   This parameter can be one of the following values:
//  387   * @arg RCC_SYSCLK_Div1: AHB clock = SYSCLK
//  388   * @arg RCC_SYSCLK_Div2: AHB clock = SYSCLK/2
//  389   * @arg RCC_SYSCLK_Div4: AHB clock = SYSCLK/4
//  390   * @arg RCC_SYSCLK_Div8: AHB clock = SYSCLK/8
//  391   * @arg RCC_SYSCLK_Div16: AHB clock = SYSCLK/16
//  392   * @arg RCC_SYSCLK_Div64: AHB clock = SYSCLK/64
//  393   * @arg RCC_SYSCLK_Div128: AHB clock = SYSCLK/128
//  394   * @arg RCC_SYSCLK_Div256: AHB clock = SYSCLK/256
//  395   * @arg RCC_SYSCLK_Div512: AHB clock = SYSCLK/512
//  396   * @retval : None
//  397   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  398 void RCC_HCLKConfig(uint32_t RCC_SYSCLK)
//  399 {
//  400   uint32_t tmpreg = 0;
//  401   /* Check the parameters */
//  402   assert_param(IS_RCC_HCLK(RCC_SYSCLK));
//  403   tmpreg = RCC->CFGR;
RCC_HCLKConfig:
        LDR.N    R1,??DataTable12  ;; 0x40021004
        LDR      R2,[R1, #+0]
//  404   /* Clear HPRE[3:0] bits */
//  405   tmpreg &= CFGR_HPRE_Reset_Mask;
//  406   /* Set HPRE[3:0] bits according to RCC_SYSCLK value */
//  407   tmpreg |= RCC_SYSCLK;
//  408   /* Store the new value */
//  409   RCC->CFGR = tmpreg;
        BIC      R2,R2,#0xF0
        REQUIRE ?Subroutine1
        ;; // Fall through to label ?Subroutine1
//  410 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine1:
        ORRS     R0,R0,R2
        STR      R0,[R1, #+0]
        BX       LR               ;; return
//  411 
//  412 /**
//  413   * @brief  Configures the Low Speed APB clock (PCLK1).
//  414   * @param RCC_HCLK: defines the APB1 clock divider. This clock is derived from 
//  415   *                  the AHB clock (HCLK).
//  416   *   This parameter can be one of the following values:
//  417   * @arg RCC_HCLK_Div1: APB1 clock = HCLK
//  418   * @arg RCC_HCLK_Div2: APB1 clock = HCLK/2
//  419   * @arg RCC_HCLK_Div4: APB1 clock = HCLK/4
//  420   * @arg RCC_HCLK_Div8: APB1 clock = HCLK/8
//  421   * @arg RCC_HCLK_Div16: APB1 clock = HCLK/16
//  422   * @retval : None
//  423   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  424 void RCC_PCLK1Config(uint32_t RCC_HCLK)
//  425 {
//  426   uint32_t tmpreg = 0;
//  427   /* Check the parameters */
//  428   assert_param(IS_RCC_PCLK(RCC_HCLK));
//  429   tmpreg = RCC->CFGR;
RCC_PCLK1Config:
        LDR.N    R1,??DataTable12  ;; 0x40021004
        LDR      R2,[R1, #+0]
//  430   /* Clear PPRE1[2:0] bits */
//  431   tmpreg &= CFGR_PPRE1_Reset_Mask;
//  432   /* Set PPRE1[2:0] bits according to RCC_HCLK value */
//  433   tmpreg |= RCC_HCLK;
//  434   /* Store the new value */
//  435   RCC->CFGR = tmpreg;
        BIC      R2,R2,#0x700
        B.N      ?Subroutine1
//  436 }
//  437 
//  438 /**
//  439   * @brief  Configures the High Speed APB clock (PCLK2).
//  440   * @param RCC_HCLK: defines the APB2 clock divider. This clock is derived from 
//  441   *                  the AHB clock (HCLK).
//  442   *   This parameter can be one of the following values:
//  443   * @arg RCC_HCLK_Div1: APB2 clock = HCLK
//  444   * @arg RCC_HCLK_Div2: APB2 clock = HCLK/2
//  445   * @arg RCC_HCLK_Div4: APB2 clock = HCLK/4
//  446   * @arg RCC_HCLK_Div8: APB2 clock = HCLK/8
//  447   * @arg RCC_HCLK_Div16: APB2 clock = HCLK/16
//  448   * @retval : None
//  449   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  450 void RCC_PCLK2Config(uint32_t RCC_HCLK)
//  451 {
//  452   uint32_t tmpreg = 0;
//  453   /* Check the parameters */
//  454   assert_param(IS_RCC_PCLK(RCC_HCLK));
//  455   tmpreg = RCC->CFGR;
RCC_PCLK2Config:
        LDR.N    R1,??DataTable12  ;; 0x40021004
        LDR      R2,[R1, #+0]
//  456   /* Clear PPRE2[2:0] bits */
//  457   tmpreg &= CFGR_PPRE2_Reset_Mask;
//  458   /* Set PPRE2[2:0] bits according to RCC_HCLK value */
//  459   tmpreg |= RCC_HCLK << 3;
//  460   /* Store the new value */
//  461   RCC->CFGR = tmpreg;
        BIC      R2,R2,#0x3800
        REQUIRE ?Subroutine0
        ;; // Fall through to label ?Subroutine0
//  462 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine0:
        ORR      R0,R2,R0, LSL #+3
        STR      R0,[R1, #+0]
        BX       LR               ;; return
//  463 
//  464 /**
//  465   * @brief  Enables or disables the specified RCC interrupts.
//  466   * @param RCC_IT: specifies the RCC interrupt sources to be enabled or disabled.
//  467   *   This parameter can be any combination of the following values:
//  468   * @arg RCC_IT_LSIRDY: LSI ready interrupt
//  469   * @arg RCC_IT_LSERDY: LSE ready interrupt
//  470   * @arg RCC_IT_HSIRDY: HSI ready interrupt
//  471   * @arg RCC_IT_HSERDY: HSE ready interrupt
//  472   * @arg RCC_IT_PLLRDY: PLL ready interrupt
//  473   * @param NewState: new state of the specified RCC interrupts.
//  474   *   This parameter can be: ENABLE or DISABLE.
//  475   * @retval : None
//  476   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  477 void RCC_ITConfig(uint8_t RCC_IT, FunctionalState NewState)
//  478 {
//  479   /* Check the parameters */
//  480   assert_param(IS_RCC_IT(RCC_IT));
//  481   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  482   if (NewState != DISABLE)
RCC_ITConfig:
        LDR.N    R2,??RCC_ITConfig_0  ;; 0x40021009
        CMP      R1,#+0
        LDRB     R1,[R2, #+0]
        ITE      NE 
        ORRNE    R0,R0,R1
        BICEQ    R0,R1,R0
//  483   {
//  484     /* Perform Byte access to RCC_CIR[12:8] bits to enable the selected interrupts */
//  485     *(__IO uint8_t *) CIR_BYTE2_ADDRESS |= RCC_IT;
//  486   }
//  487   else
//  488   {
//  489     /* Perform Byte access to RCC_CIR[12:8] bits to disable the selected interrupts */
//  490     *(__IO uint8_t *) CIR_BYTE2_ADDRESS &= (uint8_t)~RCC_IT;
        STRB     R0,[R2, #+0]
//  491   }
//  492 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_ITConfig_0:
        DC32     0x40021009
//  493 
//  494 /**
//  495   * @brief  Configures the USB clock (USBCLK).
//  496   * @param RCC_USBCLKSource: specifies the USB clock source. This clock is 
//  497   *                          derived from the PLL output.
//  498   *   This parameter can be one of the following values:
//  499   * @arg RCC_USBCLKSource_PLLCLK_1Div5: PLL clock divided by 1,5 selected as USB 
//  500   *                                     clock source
//  501   * @arg RCC_USBCLKSource_PLLCLK_Div1: PLL clock selected as USB clock source
//  502   * @retval : None
//  503   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  504 void RCC_USBCLKConfig(uint32_t RCC_USBCLKSource)
//  505 {
//  506   /* Check the parameters */
//  507   assert_param(IS_RCC_USBCLK_SOURCE(RCC_USBCLKSource));
//  508   *(__IO uint32_t *) CFGR_USBPRE_BB = RCC_USBCLKSource;
RCC_USBCLKConfig:
        LDR.N    R1,??RCC_USBCLKConfig_0  ;; 0x424200d8
        STR      R0,[R1, #+0]
//  509 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_USBCLKConfig_0:
        DC32     0x424200d8
//  510 
//  511 /**
//  512   * @brief  Configures the ADC clock (ADCCLK).
//  513   * @param RCC_PCLK2: defines the ADC clock divider. This clock is derived from 
//  514   *                   the APB2 clock (PCLK2).
//  515   *   This parameter can be one of the following values:
//  516   * @arg RCC_PCLK2_Div2: ADC clock = PCLK2/2
//  517   * @arg RCC_PCLK2_Div4: ADC clock = PCLK2/4
//  518   * @arg RCC_PCLK2_Div6: ADC clock = PCLK2/6
//  519   * @arg RCC_PCLK2_Div8: ADC clock = PCLK2/8
//  520   * @retval : None
//  521   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  522 void RCC_ADCCLKConfig(uint32_t RCC_PCLK2)
//  523 {
//  524   uint32_t tmpreg = 0;
//  525   /* Check the parameters */
//  526   assert_param(IS_RCC_ADCCLK(RCC_PCLK2));
//  527   tmpreg = RCC->CFGR;
RCC_ADCCLKConfig:
        LDR.N    R1,??DataTable12  ;; 0x40021004
        LDR      R2,[R1, #+0]
//  528   /* Clear ADCPRE[1:0] bits */
//  529   tmpreg &= CFGR_ADCPRE_Reset_Mask;
//  530   /* Set ADCPRE[1:0] bits according to RCC_PCLK2 value */
//  531   tmpreg |= RCC_PCLK2;
//  532   /* Store the new value */
//  533   RCC->CFGR = tmpreg;
        BIC      R2,R2,#0xC000
        B.N      ?Subroutine1
//  534 }
//  535 
//  536 /**
//  537   * @brief  Configures the External Low Speed oscillator (LSE).
//  538   * @param RCC_LSE: specifies the new state of the LSE.
//  539   *   This parameter can be one of the following values:
//  540   * @arg RCC_LSE_OFF: LSE oscillator OFF
//  541   * @arg RCC_LSE_ON: LSE oscillator ON
//  542   * @arg RCC_LSE_Bypass: LSE oscillator bypassed with external
//  543   *   clock
//  544   * @retval : None
//  545   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  546 void RCC_LSEConfig(uint8_t RCC_LSE)
//  547 {
//  548   /* Check the parameters */
//  549   assert_param(IS_RCC_LSE(RCC_LSE));
//  550   /* Reset LSEON and LSEBYP bits before configuring the LSE ------------------*/
//  551   /* Reset LSEON bit */
//  552   *(__IO uint8_t *) BDCR_ADDRESS = RCC_LSE_OFF;
RCC_LSEConfig:
        LDR.N    R1,??DataTable11  ;; 0x40021020
        MOVS     R2,#+0
        STRB     R2,[R1, #+0]
//  553   /* Reset LSEBYP bit */
//  554   *(__IO uint8_t *) BDCR_ADDRESS = RCC_LSE_OFF;
        STRB     R2,[R1, #+0]
//  555   /* Configure LSE (RCC_LSE_OFF is already covered by the code section above) */
//  556   switch(RCC_LSE)
        CMP      R0,#+1
        BEQ.N    ??RCC_LSEConfig_0
        CMP      R0,#+4
        BNE.N    ??RCC_LSEConfig_1
//  557   {
//  558     case RCC_LSE_ON:
//  559       /* Set LSEON bit */
//  560       *(__IO uint8_t *) BDCR_ADDRESS = RCC_LSE_ON;
//  561       break;
//  562       
//  563     case RCC_LSE_Bypass:
//  564       /* Set LSEBYP and LSEON bits */
//  565       *(__IO uint8_t *) BDCR_ADDRESS = RCC_LSE_Bypass | RCC_LSE_ON;
        MOVS     R0,#+5
??RCC_LSEConfig_0:
        STRB     R0,[R1, #+0]
//  566       break;            
//  567       
//  568     default:
//  569       break;      
//  570   }
//  571 }
??RCC_LSEConfig_1:
        BX       LR               ;; return
//  572 
//  573 /**
//  574   * @brief  Enables or disables the Internal Low Speed oscillator (LSI).
//  575   *   LSI can not be disabled if the IWDG is running.
//  576   * @param NewState: new state of the LSI.
//  577   *   This parameter can be: ENABLE or DISABLE.
//  578   * @retval : None
//  579   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  580 void RCC_LSICmd(FunctionalState NewState)
//  581 {
//  582   /* Check the parameters */
//  583   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  584   *(__IO uint32_t *) CSR_LSION_BB = (uint32_t)NewState;
RCC_LSICmd:
        LDR.N    R1,??RCC_LSICmd_0  ;; 0x42420480
        STR      R0,[R1, #+0]
//  585 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_LSICmd_0:
        DC32     0x42420480
//  586 
//  587 /**
//  588   * @brief  Configures the RTC clock (RTCCLK).
//  589   *   Once the RTC clock is selected it cant be changed unless the
//  590   *   Backup domain is reset.
//  591   * @param RCC_RTCCLKSource: specifies the RTC clock source.
//  592   *   This parameter can be one of the following values:
//  593   * @arg RCC_RTCCLKSource_LSE: LSE selected as RTC clock
//  594   * @arg RCC_RTCCLKSource_LSI: LSI selected as RTC clock
//  595   * @arg RCC_RTCCLKSource_HSE_Div128: HSE clock divided by 128
//  596   *   selected as RTC clock
//  597   * @retval : None
//  598   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  599 void RCC_RTCCLKConfig(uint32_t RCC_RTCCLKSource)
//  600 {
//  601   /* Check the parameters */
//  602   assert_param(IS_RCC_RTCCLK_SOURCE(RCC_RTCCLKSource));
//  603   /* Select the RTC clock source */
//  604   RCC->BDCR |= RCC_RTCCLKSource;
RCC_RTCCLKConfig:
        LDR.N    R1,??DataTable11  ;; 0x40021020
        LDR      R2,[R1, #+0]
        B.N      ?Subroutine1
//  605 }

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable11:
        DC32     0x40021020
//  606 
//  607 /**
//  608   * @brief  Enables or disables the RTC clock.
//  609   *   This function must be used only after the RTC clock was
//  610   *   selected using the RCC_RTCCLKConfig function.
//  611   * @param NewState: new state of the RTC clock.
//  612   *   This parameter can be: ENABLE or DISABLE.
//  613   * @retval : None
//  614   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  615 void RCC_RTCCLKCmd(FunctionalState NewState)
//  616 {
//  617   /* Check the parameters */
//  618   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  619   *(__IO uint32_t *) BDCR_RTCEN_BB = (uint32_t)NewState;
RCC_RTCCLKCmd:
        LDR.N    R1,??RCC_RTCCLKCmd_0  ;; 0x4242043c
        STR      R0,[R1, #+0]
//  620 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_RTCCLKCmd_0:
        DC32     0x4242043c
//  621 
//  622 /**
//  623   * @brief  Returns the frequencies of different on chip clocks.
//  624   * @param RCC_Clocks: pointer to a RCC_ClocksTypeDef structure which
//  625   *   will hold the clocks frequencies.
//  626   * @retval : None
//  627   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  628 void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks)
//  629 {
RCC_GetClocksFreq:
        PUSH     {R4,R5,LR}
//  630   uint32_t tmp = 0, pllmull = 0, pllsource = 0, presc = 0;
//  631   /* Get SYSCLK source -------------------------------------------------------*/
//  632   tmp = RCC->CFGR & CFGR_SWS_Mask;
        LDR.N    R1,??DataTable12  ;; 0x40021004
        LDR      R3,[R1, #+0]
//  633   switch (tmp)
        LDR.N    R2,??RCC_GetClocksFreq_0  ;; 0x7a1200
        AND      R3,R3,#0xC
        CMP      R3,#+8
        BNE.N    ??RCC_GetClocksFreq_1
//  634   {
//  635     case 0x00:  /* HSI used as system clock */
//  636       RCC_Clocks->SYSCLK_Frequency = HSI_Value;
//  637       break;
//  638     case 0x04:  /* HSE used as system clock */
//  639       RCC_Clocks->SYSCLK_Frequency = HSE_Value;
//  640       break;
//  641     case 0x08:  /* PLL used as system clock */
//  642       /* Get PLL clock source and multiplication factor ----------------------*/
//  643       pllmull = RCC->CFGR & CFGR_PLLMull_Mask;
        LDR      R3,[R1, #+0]
//  644       pllmull = ( pllmull >> 18) + 2;
        AND      R3,R3,#0x3C0000
        LSRS     R3,R3,#+18
        ADDS     R3,R3,#+2
//  645       pllsource = RCC->CFGR & CFGR_PLLSRC_Mask;
        LDR      R4,[R1, #+0]
//  646       if (pllsource == 0x00)
        LDR.N    R5,??RCC_GetClocksFreq_0+0x4  ;; 0x3d0900
        MULS     R5,R5,R3
        LSLS     R4,R4,#+15
        BMI.N    ??RCC_GetClocksFreq_2
//  647       {/* HSI oscillator clock divided by 2 selected as PLL clock entry */
//  648         RCC_Clocks->SYSCLK_Frequency = (HSI_Value >> 1) * pllmull;
??RCC_GetClocksFreq_3:
        MOV      R2,R5
        B.N      ??RCC_GetClocksFreq_1
//  649       }
//  650       else
//  651       {/* HSE selected as PLL clock entry */
//  652         if ((RCC->CFGR & CFGR_PLLXTPRE_Mask) != (uint32_t)RESET)
??RCC_GetClocksFreq_2:
        LDR      R4,[R1, #+0]
        LSLS     R4,R4,#+14
        BMI.N    ??RCC_GetClocksFreq_3
//  653         {/* HSE oscillator clock divided by 2 */
//  654           RCC_Clocks->SYSCLK_Frequency = (HSE_Value >> 1) * pllmull;
//  655         }
//  656         else
//  657         {
//  658           RCC_Clocks->SYSCLK_Frequency = HSE_Value * pllmull;
        MULS     R2,R2,R3
??RCC_GetClocksFreq_1:
        STR      R2,[R0, #+0]
//  659         }
//  660       }
//  661       break;
//  662     default:
//  663       RCC_Clocks->SYSCLK_Frequency = HSI_Value;
//  664       break;
//  665   }
//  666   /* Compute HCLK, PCLK1, PCLK2 and ADCCLK clocks frequencies ----------------*/
//  667   /* Get HCLK prescaler */
//  668   tmp = RCC->CFGR & CFGR_HPRE_Set_Mask;
        LDR      R3,[R1, #+0]
//  669   tmp = tmp >> 4;
//  670   presc = APBAHBPrescTable[tmp];
//  671   /* HCLK clock frequency */
//  672   RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency >> presc;
        LDR.N    R2,??RCC_GetClocksFreq_0+0x8  ;; APBAHBPrescTable
        LDR      R4,[R0, #+0]
        AND      R3,R3,#0xF0
        LSRS     R3,R3,#+4
        LDRB     R3,[R3, R2]
        LSR      R3,R4,R3
        STR      R3,[R0, #+4]
//  673   /* Get PCLK1 prescaler */
//  674   tmp = RCC->CFGR & CFGR_PPRE1_Set_Mask;
        LDR      R4,[R1, #+0]
//  675   tmp = tmp >> 8;
//  676   presc = APBAHBPrescTable[tmp];
//  677   /* PCLK1 clock frequency */
//  678   RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency >> presc;
        AND      R4,R4,#0x700
        LSRS     R4,R4,#+8
        LDRB     R4,[R4, R2]
        LSRS     R3,R3,R4
        STR      R3,[R0, #+8]
//  679   /* Get PCLK2 prescaler */
//  680   tmp = RCC->CFGR & CFGR_PPRE2_Set_Mask;
        LDR      R3,[R1, #+0]
//  681   tmp = tmp >> 11;
//  682   presc = APBAHBPrescTable[tmp];
//  683   /* PCLK2 clock frequency */
//  684   RCC_Clocks->PCLK2_Frequency = RCC_Clocks->HCLK_Frequency >> presc;
        LDR      R4,[R0, #+4]
        AND      R3,R3,#0x3800
        LSRS     R3,R3,#+11
        LDRB     R3,[R3, R2]
        LSR      R3,R4,R3
        STR      R3,[R0, #+12]
//  685   /* Get ADCCLK prescaler */
//  686   tmp = RCC->CFGR & CFGR_ADCPRE_Set_Mask;
        LDR      R1,[R1, #+0]
//  687   tmp = tmp >> 14;
//  688   presc = ADCPrescTable[tmp];
//  689   /* ADCCLK clock frequency */
//  690   RCC_Clocks->ADCCLK_Frequency = RCC_Clocks->PCLK2_Frequency / presc;
        AND      R1,R1,#0xC000
        ADD      R1,R2,R1, LSR #+14
        LDRB     R1,[R1, #+16]
        UDIV     R1,R3,R1
        STR      R1,[R0, #+16]
//  691 }
        POP      {R4,R5,PC}       ;; return
        Nop      
        DATA
??RCC_GetClocksFreq_0:
        DC32     0x7a1200
        DC32     0x3d0900
        DC32     APBAHBPrescTable

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable12:
        DC32     0x40021004
//  692 
//  693 /**
//  694   * @brief  Enables or disables the AHB peripheral clock.
//  695   * @param RCC_AHBPeriph: specifies the AHB peripheral to gates its clock.
//  696   *   This parameter can be any combination of the following values:
//  697   * @arg RCC_AHBPeriph_DMA1
//  698   * @arg RCC_AHBPeriph_DMA2
//  699   * @arg RCC_AHBPeriph_SRAM
//  700   * @arg RCC_AHBPeriph_FLITF
//  701   * @arg RCC_AHBPeriph_CRC
//  702   * @arg RCC_AHBPeriph_FSMC
//  703   * @arg RCC_AHBPeriph_SDIO
//  704   *   SRAM and FLITF clock can be disabled only during sleep mode.
//  705   * @param NewState: new state of the specified peripheral clock.
//  706   *   This parameter can be: ENABLE or DISABLE.
//  707   * @retval : None
//  708   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  709 void RCC_AHBPeriphClockCmd(uint32_t RCC_AHBPeriph, FunctionalState NewState)
//  710 {
//  711   /* Check the parameters */
//  712   assert_param(IS_RCC_AHB_PERIPH(RCC_AHBPeriph));
//  713   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  714   if (NewState != DISABLE)
RCC_AHBPeriphClockCmd:
        LDR.N    R2,??RCC_AHBPeriphClockCmd_0  ;; 0x40021014
        CMP      R1,#+0
        LDR      R1,[R2, #+0]
        ITE      NE 
        ORRNE    R0,R0,R1
        BICEQ    R0,R1,R0
//  715   {
//  716     RCC->AHBENR |= RCC_AHBPeriph;
//  717   }
//  718   else
//  719   {
//  720     RCC->AHBENR &= ~RCC_AHBPeriph;
        STR      R0,[R2, #+0]
//  721   }
//  722 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_AHBPeriphClockCmd_0:
        DC32     0x40021014
//  723 
//  724 /**
//  725   * @brief  Enables or disables the High Speed APB (APB2) peripheral clock.
//  726   * @param RCC_APB2Periph: specifies the APB2 peripheral to gates its
//  727   *   clock.
//  728   *   This parameter can be any combination of the following values:
//  729   * @arg RCC_APB2Periph_AFIO, RCC_APB2Periph_GPIOA, RCC_APB2Periph_GPIOB,
//  730   *   RCC_APB2Periph_GPIOC, RCC_APB2Periph_GPIOD, RCC_APB2Periph_GPIOE,
//  731   *   RCC_APB2Periph_GPIOF, RCC_APB2Periph_GPIOG, RCC_APB2Periph_ADC1,
//  732   *   RCC_APB2Periph_ADC2, RCC_APB2Periph_TIM1, RCC_APB2Periph_SPI1,
//  733   *   RCC_APB2Periph_TIM8, RCC_APB2Periph_USART1, RCC_APB2Periph_ADC3,
//  734   *   RCC_APB2Periph_ALL
//  735   * @param NewState: new state of the specified peripheral clock.
//  736   *   This parameter can be: ENABLE or DISABLE.
//  737   * @retval : None
//  738   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  739 void RCC_APB2PeriphClockCmd(uint32_t RCC_APB2Periph, FunctionalState NewState)
//  740 {
//  741   /* Check the parameters */
//  742   assert_param(IS_RCC_APB2_PERIPH(RCC_APB2Periph));
//  743   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  744   if (NewState != DISABLE)
RCC_APB2PeriphClockCmd:
        LDR.N    R2,??RCC_APB2PeriphClockCmd_0  ;; 0x40021018
        CMP      R1,#+0
        LDR      R1,[R2, #+0]
        ITE      NE 
        ORRNE    R0,R0,R1
        BICEQ    R0,R1,R0
//  745   {
//  746     RCC->APB2ENR |= RCC_APB2Periph;
//  747   }
//  748   else
//  749   {
//  750     RCC->APB2ENR &= ~RCC_APB2Periph;
        STR      R0,[R2, #+0]
//  751   }
//  752 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_APB2PeriphClockCmd_0:
        DC32     0x40021018
//  753 
//  754 /**
//  755   * @brief  Enables or disables the Low Speed APB (APB1) peripheral clock.
//  756   * @param RCC_APB1Periph: specifies the APB1 peripheral to gates its
//  757   *   clock.
//  758   *   This parameter can be any combination of the following values:
//  759   * @arg RCC_APB1Periph_TIM2, RCC_APB1Periph_TIM3, RCC_APB1Periph_TIM4,
//  760   *   RCC_APB1Periph_TIM5, RCC_APB1Periph_TIM6, RCC_APB1Periph_TIM7,
//  761   *   RCC_APB1Periph_WWDG, RCC_APB1Periph_SPI2, RCC_APB1Periph_SPI3,
//  762   *   RCC_APB1Periph_USART2, RCC_APB1Periph_USART3, RCC_APB1Periph_USART4, 
//  763   *   RCC_APB1Periph_USART5, RCC_APB1Periph_I2C1, RCC_APB1Periph_I2C2,
//  764   *   RCC_APB1Periph_USB, RCC_APB1Periph_CAN1, RCC_APB1Periph_BKP,
//  765   *   RCC_APB1Periph_PWR, RCC_APB1Periph_DAC, RCC_APB1Periph_ALL
//  766   * @param NewState: new state of the specified peripheral clock.
//  767   *   This parameter can be: ENABLE or DISABLE.
//  768   * @retval : None
//  769   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  770 void RCC_APB1PeriphClockCmd(uint32_t RCC_APB1Periph, FunctionalState NewState)
//  771 {
//  772   /* Check the parameters */
//  773   assert_param(IS_RCC_APB1_PERIPH(RCC_APB1Periph));
//  774   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  775   if (NewState != DISABLE)
RCC_APB1PeriphClockCmd:
        LDR.N    R2,??RCC_APB1PeriphClockCmd_0  ;; 0x4002101c
        CMP      R1,#+0
        LDR      R1,[R2, #+0]
        ITE      NE 
        ORRNE    R0,R0,R1
        BICEQ    R0,R1,R0
//  776   {
//  777     RCC->APB1ENR |= RCC_APB1Periph;
//  778   }
//  779   else
//  780   {
//  781     RCC->APB1ENR &= ~RCC_APB1Periph;
        STR      R0,[R2, #+0]
//  782   }
//  783 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_APB1PeriphClockCmd_0:
        DC32     0x4002101c
//  784 
//  785 /**
//  786   * @brief  Forces or releases High Speed APB (APB2) peripheral reset.
//  787   * @param RCC_APB2Periph: specifies the APB2 peripheral to reset.
//  788   *   This parameter can be any combination of the following values:
//  789   * @arg RCC_APB2Periph_AFIO, RCC_APB2Periph_GPIOA, RCC_APB2Periph_GPIOB,
//  790   *   RCC_APB2Periph_GPIOC, RCC_APB2Periph_GPIOD, RCC_APB2Periph_GPIOE,
//  791   *   RCC_APB2Periph_GPIOF, RCC_APB2Periph_GPIOG, RCC_APB2Periph_ADC1,
//  792   *   RCC_APB2Periph_ADC2, RCC_APB2Periph_TIM1, RCC_APB2Periph_SPI1,
//  793   *   RCC_APB2Periph_TIM8, RCC_APB2Periph_USART1, RCC_APB2Periph_ADC3,
//  794   *   RCC_APB2Periph_ALL
//  795   * @param NewState: new state of the specified peripheral reset.
//  796   *   This parameter can be: ENABLE or DISABLE.
//  797   * @retval : None
//  798   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  799 void RCC_APB2PeriphResetCmd(uint32_t RCC_APB2Periph, FunctionalState NewState)
//  800 {
//  801   /* Check the parameters */
//  802   assert_param(IS_RCC_APB2_PERIPH(RCC_APB2Periph));
//  803   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  804   if (NewState != DISABLE)
RCC_APB2PeriphResetCmd:
        LDR.N    R2,??RCC_APB2PeriphResetCmd_0  ;; 0x4002100c
        CMP      R1,#+0
        LDR      R1,[R2, #+0]
        ITE      NE 
        ORRNE    R0,R0,R1
        BICEQ    R0,R1,R0
//  805   {
//  806     RCC->APB2RSTR |= RCC_APB2Periph;
//  807   }
//  808   else
//  809   {
//  810     RCC->APB2RSTR &= ~RCC_APB2Periph;
        STR      R0,[R2, #+0]
//  811   }
//  812 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_APB2PeriphResetCmd_0:
        DC32     0x4002100c
//  813 
//  814 /**
//  815   * @brief  Forces or releases Low Speed APB (APB1) peripheral reset.
//  816   * @param RCC_APB1Periph: specifies the APB1 peripheral to reset.
//  817   *   This parameter can be any combination of the following values:
//  818   * @arg RCC_APB1Periph_TIM2, RCC_APB1Periph_TIM3, RCC_APB1Periph_TIM4,
//  819   *   RCC_APB1Periph_TIM5, RCC_APB1Periph_TIM6, RCC_APB1Periph_TIM7,
//  820   *   RCC_APB1Periph_WWDG, RCC_APB1Periph_SPI2, RCC_APB1Periph_SPI3,
//  821   *   RCC_APB1Periph_USART2, RCC_APB1Periph_USART3, RCC_APB1Periph_USART4, 
//  822   *   RCC_APB1Periph_USART5, RCC_APB1Periph_I2C1, RCC_APB1Periph_I2C2,
//  823   *   RCC_APB1Periph_USB, RCC_APB1Periph_CAN1, RCC_APB1Periph_BKP,
//  824   *   RCC_APB1Periph_PWR, RCC_APB1Periph_DAC, RCC_APB1Periph_ALL
//  825   * @param NewState: new state of the specified peripheral clock.
//  826   *   This parameter can be: ENABLE or DISABLE.
//  827   * @retval : None
//  828   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  829 void RCC_APB1PeriphResetCmd(uint32_t RCC_APB1Periph, FunctionalState NewState)
//  830 {
//  831   /* Check the parameters */
//  832   assert_param(IS_RCC_APB1_PERIPH(RCC_APB1Periph));
//  833   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  834   if (NewState != DISABLE)
RCC_APB1PeriphResetCmd:
        LDR.N    R2,??RCC_APB1PeriphResetCmd_0  ;; 0x40021010
        CMP      R1,#+0
        LDR      R1,[R2, #+0]
        ITE      NE 
        ORRNE    R0,R0,R1
        BICEQ    R0,R1,R0
//  835   {
//  836     RCC->APB1RSTR |= RCC_APB1Periph;
//  837   }
//  838   else
//  839   {
//  840     RCC->APB1RSTR &= ~RCC_APB1Periph;
        STR      R0,[R2, #+0]
//  841   }
//  842 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_APB1PeriphResetCmd_0:
        DC32     0x40021010
//  843 
//  844 /**
//  845   * @brief  Forces or releases the Backup domain reset.
//  846   * @param NewState: new state of the Backup domain reset.
//  847   *   This parameter can be: ENABLE or DISABLE.
//  848   * @retval : None
//  849   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  850 void RCC_BackupResetCmd(FunctionalState NewState)
//  851 {
//  852   /* Check the parameters */
//  853   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  854   *(__IO uint32_t *) BDCR_BDRST_BB = (uint32_t)NewState;
RCC_BackupResetCmd:
        LDR.N    R1,??RCC_BackupResetCmd_0  ;; 0x42420440
        STR      R0,[R1, #+0]
//  855 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_BackupResetCmd_0:
        DC32     0x42420440
//  856 
//  857 /**
//  858   * @brief  Enables or disables the Clock Security System.
//  859   * @param NewState: new state of the Clock Security System..
//  860   *   This parameter can be: ENABLE or DISABLE.
//  861   * @retval : None
//  862   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  863 void RCC_ClockSecuritySystemCmd(FunctionalState NewState)
//  864 {
//  865   /* Check the parameters */
//  866   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  867   *(__IO uint32_t *) CR_CSSON_BB = (uint32_t)NewState;
RCC_ClockSecuritySystemCmd:
        LDR.N    R1,??RCC_ClockSecuritySystemCmd_0  ;; 0x4242004c
        STR      R0,[R1, #+0]
//  868 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_ClockSecuritySystemCmd_0:
        DC32     0x4242004c
//  869 
//  870 /**
//  871   * @brief  Selects the clock source to output on MCO pin.
//  872   * @param RCC_MCO: specifies the clock source to output.
//  873   *   This parameter can be one of the following values:
//  874   * @arg RCC_MCO_NoClock: No clock selected
//  875   * @arg RCC_MCO_SYSCLK: System clock selected
//  876   * @arg RCC_MCO_HSI: HSI oscillator clock selected
//  877   * @arg RCC_MCO_HSE: HSE oscillator clock selected
//  878   * @arg RCC_MCO_PLLCLK_Div2: PLL clock divided by 2 selected
//  879   * @retval : None
//  880   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  881 void RCC_MCOConfig(uint8_t RCC_MCO)
//  882 {
//  883   /* Check the parameters */
//  884   assert_param(IS_RCC_MCO(RCC_MCO));
//  885   /* Perform Byte access to MCO[2:0] bits to select the MCO source */
//  886   *(__IO uint8_t *) CFGR_BYTE4_ADDRESS = RCC_MCO;
RCC_MCOConfig:
        LDR.N    R1,??RCC_MCOConfig_0  ;; 0x40021007
        STRB     R0,[R1, #+0]
//  887 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_MCOConfig_0:
        DC32     0x40021007
//  888 
//  889 /**
//  890   * @brief  Checks whether the specified RCC flag is set or not.
//  891   * @param RCC_FLAG: specifies the flag to check.
//  892   *   This parameter can be one of the following values:
//  893   * @arg RCC_FLAG_HSIRDY: HSI oscillator clock ready
//  894   * @arg RCC_FLAG_HSERDY: HSE oscillator clock ready
//  895   * @arg RCC_FLAG_PLLRDY: PLL clock ready
//  896   * @arg RCC_FLAG_LSERDY: LSE oscillator clock ready
//  897   * @arg RCC_FLAG_LSIRDY: LSI oscillator clock ready
//  898   * @arg RCC_FLAG_PINRST: Pin reset
//  899   * @arg RCC_FLAG_PORRST: POR/PDR reset
//  900   * @arg RCC_FLAG_SFTRST: Software reset
//  901   * @arg RCC_FLAG_IWDGRST: Independent Watchdog reset
//  902   * @arg RCC_FLAG_WWDGRST: Window Watchdog reset
//  903   * @arg RCC_FLAG_LPWRRST: Low Power reset
//  904   * @retval : The new state of RCC_FLAG (SET or RESET).
//  905   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  906 FlagStatus RCC_GetFlagStatus(uint8_t RCC_FLAG)
//  907 {
//  908   uint32_t tmp = 0;
//  909   uint32_t statusreg = 0;
//  910   FlagStatus bitstatus = RESET;
//  911   /* Check the parameters */
//  912   assert_param(IS_RCC_FLAG(RCC_FLAG));
//  913   /* Get the RCC register index */
//  914   tmp = RCC_FLAG >> 5;
RCC_GetFlagStatus:
        LSRS     R1,R0,#+5
//  915   if (tmp == 1)               /* The flag to check is in CR register */
        LDR.N    R2,??DataTable13  ;; 0x40021000
        CMP      R1,#+1
        BNE.N    ??RCC_GetFlagStatus_0
//  916   {
//  917     statusreg = RCC->CR;
        LDR      R1,[R2, #+0]
        B.N      ??RCC_GetFlagStatus_1
//  918   }
//  919   else if (tmp == 2)          /* The flag to check is in BDCR register */
??RCC_GetFlagStatus_0:
        CMP      R1,#+2
        ITE      EQ 
        LDREQ    R1,[R2, #+32]
        LDRNE    R1,[R2, #+36]
//  920   {
//  921     statusreg = RCC->BDCR;
//  922   }
//  923   else                       /* The flag to check is in CSR register */
//  924   {
//  925     statusreg = RCC->CSR;
//  926   }
//  927   /* Get the flag position */
//  928   tmp = RCC_FLAG & FLAG_Mask;
//  929   if ((statusreg & ((uint32_t)1 << tmp)) != (uint32_t)RESET)
??RCC_GetFlagStatus_1:
        MOVS     R2,#+1
        AND      R0,R0,#0x1F
        LSL      R0,R2,R0
        ANDS     R0,R0,R1
        BEQ.N    ??RCC_GetFlagStatus_2
        MOVS     R0,#+1
//  930   {
//  931     bitstatus = SET;
//  932   }
//  933   else
//  934   {
//  935     bitstatus = RESET;
//  936   }
//  937   /* Return the flag status */
//  938   return bitstatus;
??RCC_GetFlagStatus_2:
        UXTB     R0,R0
        BX       LR               ;; return
//  939 }

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable13:
        DC32     0x40021000
//  940 
//  941 /**
//  942   * @brief  Clears the RCC reset flags.
//  943   *   The reset flags are: RCC_FLAG_PINRST, RCC_FLAG_PORRST,
//  944   *   RCC_FLAG_SFTRST, RCC_FLAG_IWDGRST, RCC_FLAG_WWDGRST,
//  945   *   RCC_FLAG_LPWRRST
//  946   * @param  None
//  947   * @retval : None
//  948   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  949 void RCC_ClearFlag(void)
//  950 {
//  951   /* Set RMVF bit to clear the reset flags */
//  952   RCC->CSR |= CSR_RMVF_Set;
RCC_ClearFlag:
        LDR.N    R0,??RCC_ClearFlag_0  ;; 0x40021024
        LDR      R1,[R0, #+0]
        ORR      R1,R1,#0x1000000
        STR      R1,[R0, #+0]
//  953 }
        BX       LR               ;; return
        DATA
??RCC_ClearFlag_0:
        DC32     0x40021024
//  954 
//  955 /**
//  956   * @brief  Checks whether the specified RCC interrupt has occurred or not.
//  957   * @param RCC_IT: specifies the RCC interrupt source to check.
//  958   *   This parameter can be one of the following values:
//  959   * @arg RCC_IT_LSIRDY: LSI ready interrupt
//  960   * @arg RCC_IT_LSERDY: LSE ready interrupt
//  961   * @arg RCC_IT_HSIRDY: HSI ready interrupt
//  962   * @arg RCC_IT_HSERDY: HSE ready interrupt
//  963   * @arg RCC_IT_PLLRDY: PLL ready interrupt
//  964   * @arg RCC_IT_CSS: Clock Security System interrupt
//  965   * @retval : The new state of RCC_IT (SET or RESET).
//  966   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  967 ITStatus RCC_GetITStatus(uint8_t RCC_IT)
//  968 {
//  969   ITStatus bitstatus = RESET;
//  970   /* Check the parameters */
//  971   assert_param(IS_RCC_GET_IT(RCC_IT));
//  972   /* Check the status of the specified RCC interrupt */
//  973   if ((RCC->CIR & RCC_IT) != (uint32_t)RESET)
RCC_GetITStatus:
        LDR.N    R1,??RCC_GetITStatus_0  ;; 0x40021008
        LDR      R1,[R1, #+0]
        ANDS     R1,R0,R1
        MOVS     R0,R1
        BEQ.N    ??RCC_GetITStatus_1
        MOVS     R0,#+1
//  974   {
//  975     bitstatus = SET;
//  976   }
//  977   else
//  978   {
//  979     bitstatus = RESET;
//  980   }
//  981   /* Return the RCC_IT status */
//  982   return  bitstatus;
??RCC_GetITStatus_1:
        BX       LR               ;; return
        Nop      
        DATA
??RCC_GetITStatus_0:
        DC32     0x40021008
//  983 }
//  984 
//  985 /**
//  986   * @brief  Clears the RCCs interrupt pending bits.
//  987   * @param RCC_IT: specifies the interrupt pending bit to clear.
//  988   *   This parameter can be any combination of the following values:
//  989   * @arg RCC_IT_LSIRDY: LSI ready interrupt
//  990   * @arg RCC_IT_LSERDY: LSE ready interrupt
//  991   * @arg RCC_IT_HSIRDY: HSI ready interrupt
//  992   * @arg RCC_IT_HSERDY: HSE ready interrupt
//  993   * @arg RCC_IT_PLLRDY: PLL ready interrupt
//  994   * @arg RCC_IT_CSS: Clock Security System interrupt
//  995   * @retval : None
//  996   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  997 void RCC_ClearITPendingBit(uint8_t RCC_IT)
//  998 {
//  999   /* Check the parameters */
// 1000   assert_param(IS_RCC_CLEAR_IT(RCC_IT));
// 1001   /* Perform Byte access to RCC_CIR[23:16] bits to clear the selected interrupt
// 1002      pending bits */
// 1003   *(__IO uint8_t *) CIR_BYTE3_ADDRESS = RCC_IT;
RCC_ClearITPendingBit:
        LDR.N    R1,??RCC_ClearITPendingBit_0  ;; 0x4002100a
        STRB     R0,[R1, #+0]
// 1004 }
        BX       LR               ;; return
        Nop      
        DATA
??RCC_ClearITPendingBit_0:
        DC32     0x4002100a

        END
// 1005 
// 1006 /**
// 1007   * @}
// 1008   */
// 1009 
// 1010 /**
// 1011   * @}
// 1012   */
// 1013 
// 1014 /**
// 1015   * @}
// 1016   */
// 1017 
// 1018 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
//  20 bytes in section .data
// 746 bytes in section .text
// 
// 746 bytes of CODE memory
//  20 bytes of DATA memory
//
//Errors: none
//Warnings: none
