///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:47 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_usart.c                                           /
//    Command line =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_usart.c -D USE_STDPERIPH_DRIVER -D STM32F10X_HD   /
//                    -D USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EW /
//                    ARMv5\STM3210E-EVAL\List\ -lB                           /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\s /
//                    tm32f10x_usart.s                                        /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME stm32f10x_usart

        EXTERN RCC_APB1PeriphResetCmd
        EXTERN RCC_APB2PeriphResetCmd
        EXTERN RCC_GetClocksFreq

        PUBLIC USART_ClearFlag
        PUBLIC USART_ClearITPendingBit
        PUBLIC USART_ClockInit
        PUBLIC USART_ClockStructInit
        PUBLIC USART_Cmd
        PUBLIC USART_DMACmd
        PUBLIC USART_DeInit
        PUBLIC USART_GetFlagStatus
        PUBLIC USART_GetITStatus
        PUBLIC USART_HalfDuplexCmd
        PUBLIC USART_ITConfig
        PUBLIC USART_Init
        PUBLIC USART_IrDACmd
        PUBLIC USART_IrDAConfig
        PUBLIC USART_LINBreakDetectLengthConfig
        PUBLIC USART_LINCmd
        PUBLIC USART_ReceiveData
        PUBLIC USART_ReceiverWakeUpCmd
        PUBLIC USART_SendBreak
        PUBLIC USART_SendData
        PUBLIC USART_SetAddress
        PUBLIC USART_SetGuardTime
        PUBLIC USART_SetPrescaler
        PUBLIC USART_SmartCardCmd
        PUBLIC USART_SmartCardNACKCmd
        PUBLIC USART_StructInit
        PUBLIC USART_WakeUpConfig

// C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm32f10x_usart.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file  stm32f10x_usart.c
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  This file provides all the USART firmware functions.
//    8   ******************************************************************************
//    9   * @copy
//   10   *
//   11   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   12   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   13   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   14   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   15   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   16   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   17   *
//   18   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   19   */ 
//   20 
//   21 /* Includes ------------------------------------------------------------------*/
//   22 #include "stm32f10x_usart.h"
//   23 #include "stm32f10x_rcc.h"
//   24 
//   25 /** @addtogroup StdPeriph_Driver
//   26   * @{
//   27   */
//   28 
//   29 /** @defgroup USART 
//   30   * @brief USART driver modules
//   31   * @{
//   32   */
//   33 
//   34 /** @defgroup USART_Private_TypesDefinitions
//   35   * @{
//   36   */
//   37 
//   38 /**
//   39   * @}
//   40   */
//   41 
//   42 /** @defgroup USART_Private_Defines
//   43   * @{
//   44   */
//   45 
//   46 /* USART UE Mask */
//   47 #define CR1_UE_Set                ((uint16_t)0x2000)  /* USART Enable Mask */
//   48 #define CR1_UE_Reset              ((uint16_t)0xDFFF)  /* USART Disable Mask */
//   49 
//   50 /* USART WakeUp Method  */
//   51 #define CR1_WAKE_Mask             ((uint16_t)0xF7FF)  /* USART WakeUp Method Mask */
//   52 
//   53 /* USART RWU Mask */
//   54 #define CR1_RWU_Set               ((uint16_t)0x0002)  /* USART mute mode Enable Mask */
//   55 #define CR1_RWU_Reset             ((uint16_t)0xFFFD)  /* USART mute mode Enable Mask */
//   56 #define CR1_SBK_Set               ((uint16_t)0x0001)  /* USART Break Character send Mask */
//   57 #define CR1_CLEAR_Mask            ((uint16_t)0xE9F3)  /* USART CR1 Mask */
//   58 #define CR2_Address_Mask          ((uint16_t)0xFFF0)  /* USART address Mask */
//   59 
//   60 /* USART LIN Mask */
//   61 #define CR2_LINEN_Set              ((uint16_t)0x4000)  /* USART LIN Enable Mask */
//   62 #define CR2_LINEN_Reset            ((uint16_t)0xBFFF)  /* USART LIN Disable Mask */
//   63 
//   64 /* USART LIN Break detection */
//   65 #define CR2_LBDL_Mask             ((uint16_t)0xFFDF)  /* USART LIN Break detection Mask */
//   66 #define CR2_STOP_CLEAR_Mask       ((uint16_t)0xCFFF)  /* USART CR2 STOP Bits Mask */
//   67 #define CR2_CLOCK_CLEAR_Mask      ((uint16_t)0xF0FF)  /* USART CR2 Clock Mask */
//   68 
//   69 /* USART SC Mask */
//   70 #define CR3_SCEN_Set              ((uint16_t)0x0020)  /* USART SC Enable Mask */
//   71 #define CR3_SCEN_Reset            ((uint16_t)0xFFDF)  /* USART SC Disable Mask */
//   72 
//   73 /* USART SC NACK Mask */
//   74 #define CR3_NACK_Set              ((uint16_t)0x0010)  /* USART SC NACK Enable Mask */
//   75 #define CR3_NACK_Reset            ((uint16_t)0xFFEF)  /* USART SC NACK Disable Mask */
//   76 
//   77 /* USART Half-Duplex Mask */
//   78 #define CR3_HDSEL_Set             ((uint16_t)0x0008)  /* USART Half-Duplex Enable Mask */
//   79 #define CR3_HDSEL_Reset           ((uint16_t)0xFFF7)  /* USART Half-Duplex Disable Mask */
//   80 
//   81 /* USART IrDA Mask */
//   82 #define CR3_IRLP_Mask             ((uint16_t)0xFFFB)  /* USART IrDA LowPower mode Mask */
//   83 #define CR3_CLEAR_Mask            ((uint16_t)0xFCFF)  /* USART CR3 Mask */
//   84 
//   85 /* USART IrDA Mask */
//   86 #define CR3_IREN_Set              ((uint16_t)0x0002)  /* USART IrDA Enable Mask */
//   87 #define CR3_IREN_Reset            ((uint16_t)0xFFFD)  /* USART IrDA Disable Mask */
//   88 #define GTPR_LSB_Mask             ((uint16_t)0x00FF)  /* Guard Time Register LSB Mask */
//   89 #define GTPR_MSB_Mask             ((uint16_t)0xFF00)  /* Guard Time Register MSB Mask */
//   90 #define IT_Mask                   ((uint16_t)0x001F)  /* USART Interrupt Mask */
//   91 
//   92 /**
//   93   * @}
//   94   */
//   95 
//   96 /** @defgroup USART_Private_Macros
//   97   * @{
//   98   */
//   99 
//  100 /**
//  101   * @}
//  102   */
//  103 
//  104 /** @defgroup USART_Private_Variables
//  105   * @{
//  106   */
//  107 
//  108 /**
//  109   * @}
//  110   */
//  111 
//  112 /** @defgroup USART_Private_FunctionPrototypes
//  113   * @{
//  114   */
//  115 
//  116 /**
//  117   * @}
//  118   */
//  119 
//  120 /** @defgroup USART_Private_Functions
//  121   * @{
//  122   */
//  123 
//  124 /**
//  125   * @brief  Deinitializes the USARTx peripheral registers to their
//  126   *   default reset values.
//  127   * @param USARTx: Select the USART or the UART peripheral. 
//  128   *   This parameter can be one of the following values:
//  129   *   USART1, USART2, USART3, UART4 or UART5.
//  130   * @retval : None
//  131   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  132 void USART_DeInit(USART_TypeDef* USARTx)
//  133 {
USART_DeInit:
        PUSH     {R7,LR}
//  134   /* Check the parameters */
//  135   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  136   switch (*(uint32_t*)&USARTx)
        LDR.N    R1,??USART_DeInit_0  ;; 0x40004400
        SUBS     R0,R0,R1
        BEQ.N    ??USART_DeInit_1
        MOV      R1,#+1024
        SUBS     R0,R0,R1
        BEQ.N    ??USART_DeInit_2
        SUBS     R0,R0,R1
        BEQ.N    ??USART_DeInit_3
        SUBS     R0,R0,R1
        BEQ.N    ??USART_DeInit_4
        MOV      R1,#+59392
        SUBS     R0,R0,R1
        BNE.N    ??USART_DeInit_5
//  137   {
//  138     case USART1_BASE:
//  139       RCC_APB2PeriphResetCmd(RCC_APB2Periph_USART1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,#+16384
        BL       RCC_APB2PeriphResetCmd
//  140       RCC_APB2PeriphResetCmd(RCC_APB2Periph_USART1, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+16384
        POP      {R2,LR}
        B.W      RCC_APB2PeriphResetCmd
//  141       break;
//  142     case USART2_BASE:
//  143       RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART2, ENABLE);
??USART_DeInit_1:
        MOVS     R1,#+1
        MOV      R0,#+131072
        BL       RCC_APB1PeriphResetCmd
//  144       RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART2, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+131072
        B.N      ??USART_DeInit_6
//  145       break;
//  146     case USART3_BASE:
//  147       RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART3, ENABLE);
??USART_DeInit_2:
        MOVS     R1,#+1
        MOV      R0,#+262144
        BL       RCC_APB1PeriphResetCmd
//  148       RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART3, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+262144
        B.N      ??USART_DeInit_6
//  149       break;
//  150     
//  151     case UART4_BASE:
//  152       RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART4, ENABLE);
??USART_DeInit_3:
        MOVS     R1,#+1
        MOV      R0,#+524288
        BL       RCC_APB1PeriphResetCmd
//  153       RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART4, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+524288
        B.N      ??USART_DeInit_6
//  154       break;
//  155     
//  156     case UART5_BASE:
//  157       RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART5, ENABLE);
??USART_DeInit_4:
        MOVS     R1,#+1
        MOV      R0,#+1048576
        BL       RCC_APB1PeriphResetCmd
//  158       RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART5, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+1048576
??USART_DeInit_6:
        BL       RCC_APB1PeriphResetCmd
//  159       break;            
//  160     default:
//  161       break;
//  162   }
//  163 }
??USART_DeInit_5:
        POP      {R0,PC}          ;; return
        DATA
??USART_DeInit_0:
        DC32     0x40004400
//  164 
//  165 /**
//  166   * @brief  Initializes the USARTx peripheral according to the specified
//  167   *   parameters in the USART_InitStruct .
//  168   * @param USARTx: Select the USART or the UART peripheral. 
//  169   *   This parameter can be one of the following values:
//  170   *   USART1, USART2, USART3, UART4 or UART5.
//  171   * @param USART_InitStruct: pointer to a USART_InitTypeDef structure
//  172   *   that contains the configuration information for the
//  173   *   specified USART peripheral.
//  174   * @retval : None
//  175   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  176 void USART_Init(USART_TypeDef* USARTx, USART_InitTypeDef* USART_InitStruct)
//  177 {
USART_Init:
        PUSH     {R4,R5,LR}
        SUB      SP,SP,#+20
        MOV      R5,R0
        MOV      R4,R1
//  178   uint32_t tmpreg = 0x00, apbclock = 0x00;
//  179   uint32_t integerdivider = 0x00;
//  180   uint32_t fractionaldivider = 0x00;
//  181   uint32_t usartxbase = 0;
//  182   RCC_ClocksTypeDef RCC_ClocksStatus;
//  183   /* Check the parameters */
//  184   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  185   assert_param(IS_USART_BAUDRATE(USART_InitStruct->USART_BaudRate));  
//  186   assert_param(IS_USART_WORD_LENGTH(USART_InitStruct->USART_WordLength));
//  187   assert_param(IS_USART_STOPBITS(USART_InitStruct->USART_StopBits));
//  188   assert_param(IS_USART_PARITY(USART_InitStruct->USART_Parity));
//  189   assert_param(IS_USART_MODE(USART_InitStruct->USART_Mode));
//  190   assert_param(IS_USART_HARDWARE_FLOW_CONTROL(USART_InitStruct->USART_HardwareFlowControl));
//  191   /* The hardware flow control is available only for USART1, USART2 and USART3 */
//  192   assert_param(IS_USART_PERIPH_HFC(USARTx, USART_InitStruct->USART_HardwareFlowControl));
//  193 
//  194   usartxbase = (*(uint32_t*)&USARTx);
//  195 /*---------------------------- USART CR2 Configuration -----------------------*/
//  196   tmpreg = USARTx->CR2;
//  197   /* Clear STOP[13:12] bits */
//  198   tmpreg &= CR2_STOP_CLEAR_Mask;
//  199   /* Configure the USART Stop Bits, Clock, CPOL, CPHA and LastBit ------------*/
//  200   /* Set STOP[13:12] bits according to USART_StopBits value */
//  201   tmpreg |= (uint32_t)USART_InitStruct->USART_StopBits;
//  202   
//  203   /* Write to USART CR2 */
//  204   USARTx->CR2 = (uint16_t)tmpreg;
        LDRH     R0,[R5, #+16]
        MOVW     R1,#+53247
        ANDS     R0,R1,R0
        LDRH     R1,[R4, #+6]
        ORRS     R0,R1,R0
        STRH     R0,[R5, #+16]
//  205 /*---------------------------- USART CR1 Configuration -----------------------*/
//  206   tmpreg = USARTx->CR1;
//  207   /* Clear M, PCE, PS, TE and RE bits */
//  208   tmpreg &= CR1_CLEAR_Mask;
//  209   /* Configure the USART Word Length, Parity and mode ----------------------- */
//  210   /* Set the M bits according to USART_WordLength value */
//  211   /* Set PCE and PS bits according to USART_Parity value */
//  212   /* Set TE and RE bits according to USART_Mode value */
//  213   tmpreg |= (uint32_t)USART_InitStruct->USART_WordLength | USART_InitStruct->USART_Parity |
//  214             USART_InitStruct->USART_Mode;
//  215   /* Write to USART CR1 */
//  216   USARTx->CR1 = (uint16_t)tmpreg;
        LDRH     R0,[R5, #+12]
        MOVW     R1,#+59891
        ANDS     R0,R1,R0
        LDRH     R1,[R4, #+4]
        ORRS     R0,R1,R0
        LDRH     R1,[R4, #+8]
        ORRS     R0,R1,R0
        LDRH     R1,[R4, #+10]
        ORRS     R0,R1,R0
        STRH     R0,[R5, #+12]
//  217 /*---------------------------- USART CR3 Configuration -----------------------*/  
//  218   tmpreg = USARTx->CR3;
//  219   /* Clear CTSE and RTSE bits */
//  220   tmpreg &= CR3_CLEAR_Mask;
//  221   /* Configure the USART HFC -------------------------------------------------*/
//  222   /* Set CTSE and RTSE bits according to USART_HardwareFlowControl value */
//  223   tmpreg |= USART_InitStruct->USART_HardwareFlowControl;
//  224   /* Write to USART CR3 */
//  225   USARTx->CR3 = (uint16_t)tmpreg;
        LDRH     R0,[R5, #+20]
        MOVW     R1,#+64767
        ANDS     R0,R1,R0
        LDRH     R1,[R4, #+12]
        ORRS     R0,R1,R0
        STRH     R0,[R5, #+20]
//  226 /*---------------------------- USART BRR Configuration -----------------------*/
//  227   /* Configure the USART Baud Rate -------------------------------------------*/
//  228   RCC_GetClocksFreq(&RCC_ClocksStatus);
        ADD      R0,SP,#+0
        BL       RCC_GetClocksFreq
//  229   if (usartxbase == USART1_BASE)
        LDR.N    R0,??USART_Init_0  ;; 0x40013800
        CMP      R5,R0
        ITE      EQ 
        LDREQ    R0,[SP, #+12]
        LDRNE    R0,[SP, #+8]
//  230   {
//  231     apbclock = RCC_ClocksStatus.PCLK2_Frequency;
//  232   }
//  233   else
//  234   {
//  235     apbclock = RCC_ClocksStatus.PCLK1_Frequency;
//  236   }
//  237   /* Determine the integer part */
//  238   integerdivider = ((0x19 * apbclock) / (0x04 * (USART_InitStruct->USART_BaudRate)));
        MOVS     R1,#+25
        MULS     R0,R1,R0
        LDR      R1,[R4, #+0]
        LSLS     R1,R1,#+2
        UDIV     R0,R0,R1
//  239   tmpreg = (integerdivider / 0x64) << 0x04;
        MOVS     R1,#+100
        UDIV     R2,R0,R1
        LSLS     R2,R2,#+4
//  240   /* Determine the fractional part */
//  241   fractionaldivider = integerdivider - (0x64 * (tmpreg >> 0x04));
//  242   tmpreg |= ((((fractionaldivider * 0x10) + 0x32) / 0x64)) & ((uint8_t)0x0F);
//  243   /* Write to USART BRR */
//  244   USARTx->BRR = (uint16_t)tmpreg;
        LSRS     R3,R2,#+4
        MLS      R0,R1,R3,R0
        LSLS     R0,R0,#+4
        ADDS     R0,R0,#+50
        UDIV     R0,R0,R1
        AND      R0,R0,#0xF
        ORRS     R0,R0,R2
        STRH     R0,[R5, #+8]
//  245 }
        ADD      SP,SP,#+20
        POP      {R4,R5,PC}       ;; return
        DATA
??USART_Init_0:
        DC32     0x40013800
//  246 
//  247 /**
//  248   * @brief  Fills each USART_InitStruct member with its default value.
//  249   * @param USART_InitStruct: pointer to a USART_InitTypeDef structure
//  250   *   which will be initialized.
//  251   * @retval : None
//  252   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  253 void USART_StructInit(USART_InitTypeDef* USART_InitStruct)
//  254 {
//  255   /* USART_InitStruct members default value */
//  256   USART_InitStruct->USART_BaudRate = 9600;
USART_StructInit:
        MOV      R1,#+9600
        STR      R1,[R0, #+0]
//  257   USART_InitStruct->USART_WordLength = USART_WordLength_8b;
        MOVS     R1,#+0
        STRH     R1,[R0, #+4]
//  258   USART_InitStruct->USART_StopBits = USART_StopBits_1;
        STRH     R1,[R0, #+6]
//  259   USART_InitStruct->USART_Parity = USART_Parity_No ;
        STRH     R1,[R0, #+8]
//  260   USART_InitStruct->USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
        MOVS     R1,#+12
        STRH     R1,[R0, #+10]
//  261   USART_InitStruct->USART_HardwareFlowControl = USART_HardwareFlowControl_None;  
        MOVS     R1,#+0
        STRH     R1,[R0, #+12]
//  262 }
        BX       LR               ;; return
//  263 
//  264 /**
//  265   * @brief  Initializes the USARTx peripheral Clock according to the 
//  266   *   specified parameters in the USART_ClockInitStruct .
//  267   * @param USARTx: where x can be 1, 2, 3 to select the USART peripheral.
//  268   * @param USART_ClockInitStruct: pointer to a USART_ClockInitTypeDef
//  269   *   structure that contains the configuration information for the specified 
//  270   *   USART peripheral.  
//  271   * @note The Smart Card mode is not available for UART4 and UART5.
//  272   * @retval : None
//  273   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  274 void USART_ClockInit(USART_TypeDef* USARTx, USART_ClockInitTypeDef* USART_ClockInitStruct)
//  275 {
//  276   uint32_t tmpreg = 0x00;
//  277   /* Check the parameters */
//  278   assert_param(IS_USART_123_PERIPH(USARTx));
//  279   assert_param(IS_USART_CLOCK(USART_ClockInitStruct->USART_Clock));
//  280   assert_param(IS_USART_CPOL(USART_ClockInitStruct->USART_CPOL));
//  281   assert_param(IS_USART_CPHA(USART_ClockInitStruct->USART_CPHA));
//  282   assert_param(IS_USART_LASTBIT(USART_ClockInitStruct->USART_LastBit));
//  283   
//  284 /*---------------------------- USART CR2 Configuration -----------------------*/
//  285   tmpreg = USARTx->CR2;
//  286   /* Clear CLKEN, CPOL, CPHA and LBCL bits */
//  287   tmpreg &= CR2_CLOCK_CLEAR_Mask;
//  288   /* Configure the USART Clock, CPOL, CPHA and LastBit ------------*/
//  289   /* Set CLKEN bit according to USART_Clock value */
//  290   /* Set CPOL bit according to USART_CPOL value */
//  291   /* Set CPHA bit according to USART_CPHA value */
//  292   /* Set LBCL bit according to USART_LastBit value */
//  293   tmpreg |= (uint32_t)USART_ClockInitStruct->USART_Clock | USART_ClockInitStruct->USART_CPOL | 
//  294                  USART_ClockInitStruct->USART_CPHA | USART_ClockInitStruct->USART_LastBit;
//  295   /* Write to USART CR2 */
//  296   USARTx->CR2 = (uint16_t)tmpreg;
USART_ClockInit:
        LDRH     R2,[R0, #+16]
        MOVW     R3,#+61695
        ANDS     R2,R3,R2
        LDRH     R3,[R1, #+0]
        ORRS     R2,R3,R2
        LDRH     R3,[R1, #+2]
        ORRS     R2,R3,R2
        LDRH     R3,[R1, #+4]
        ORRS     R2,R3,R2
        LDRH     R1,[R1, #+6]
        B.N      ??Subroutine0_0
//  297 }
//  298 
//  299 /**
//  300   * @brief  Fills each USART_ClockInitStruct member with its default value.
//  301   * @param USART_ClockInitStruct: pointer to a USART_ClockInitTypeDef
//  302   *   structure which will be initialized.
//  303   * @retval : None
//  304   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  305 void USART_ClockStructInit(USART_ClockInitTypeDef* USART_ClockInitStruct)
//  306 {
//  307   /* USART_ClockInitStruct members default value */
//  308   USART_ClockInitStruct->USART_Clock = USART_Clock_Disable;
USART_ClockStructInit:
        MOVS     R1,#+0
        STRH     R1,[R0, #+0]
//  309   USART_ClockInitStruct->USART_CPOL = USART_CPOL_Low;
        STRH     R1,[R0, #+2]
//  310   USART_ClockInitStruct->USART_CPHA = USART_CPHA_1Edge;
        STRH     R1,[R0, #+4]
//  311   USART_ClockInitStruct->USART_LastBit = USART_LastBit_Disable;
        STRH     R1,[R0, #+6]
//  312 }
        BX       LR               ;; return
//  313 
//  314 /**
//  315   * @brief  Enables or disables the specified USART peripheral.
//  316   * @param USARTx: Select the USART or the UART peripheral. 
//  317   *   This parameter can be one of the following values:
//  318   *   USART1, USART2, USART3, UART4 or UART5.
//  319   * @param NewState: new state of the USARTx peripheral.
//  320   *   This parameter can be: ENABLE or DISABLE.
//  321   * @retval : None
//  322   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  323 void USART_Cmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  324 {
//  325   /* Check the parameters */
//  326   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  327   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  328   
//  329   if (NewState != DISABLE)
USART_Cmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+12]
        ITEE     NE 
        ORRNE    R1,R1,#0x2000
        MOVWEQ   R2,#+57343
        ANDEQ    R1,R2,R1
//  330   {
//  331     /* Enable the selected USART by setting the UE bit in the CR1 register */
//  332     USARTx->CR1 |= CR1_UE_Set;
//  333   }
//  334   else
//  335   {
//  336     /* Disable the selected USART by clearing the UE bit in the CR1 register */
//  337     USARTx->CR1 &= CR1_UE_Reset;
        STRH     R1,[R0, #+12]
//  338   }
//  339 }
        BX       LR               ;; return
//  340 
//  341 /**
//  342   * @brief  Enables or disables the specified USART interrupts.
//  343   * @param USARTx: Select the USART or the UART peripheral. 
//  344   *   This parameter can be one of the following values:
//  345   *   USART1, USART2, USART3, UART4 or UART5.
//  346   * @param USART_IT: specifies the USART interrupt sources to be
//  347   *   enabled or disabled.
//  348   *   This parameter can be one of the following values:
//  349   * @arg USART_IT_CTS:  CTS change interrupt (not available for
//  350   *   UART4 and UART5)
//  351   * @arg USART_IT_LBD:  LIN Break detection interrupt
//  352   * @arg USART_IT_TXE:  Tansmit Data Register empty interrupt
//  353   * @arg USART_IT_TC:   Transmission complete interrupt
//  354   * @arg USART_IT_RXNE: Receive Data register not empty 
//  355   *   interrupt
//  356   * @arg USART_IT_IDLE: Idle line detection interrupt
//  357   * @arg USART_IT_PE:   Parity Error interrupt
//  358   * @arg USART_IT_ERR:  Error interrupt(Frame error, noise
//  359   *   error, overrun error)
//  360   * @param NewState: new state of the specified USARTx interrupts.
//  361   *   This parameter can be: ENABLE or DISABLE.
//  362   * @retval : None
//  363   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  364 void USART_ITConfig(USART_TypeDef* USARTx, uint16_t USART_IT, FunctionalState NewState)
//  365 {
USART_ITConfig:
        PUSH     {R4,LR}
//  366   uint32_t usartreg = 0x00, itpos = 0x00, itmask = 0x00;
//  367   uint32_t usartxbase = 0x00;
//  368   /* Check the parameters */
//  369   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  370   assert_param(IS_USART_CONFIG_IT(USART_IT));
//  371   assert_param(IS_USART_PERIPH_IT(USARTx, USART_IT)); /* The CTS interrupt is not available for UART4 and UART5 */
//  372   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  373   usartxbase = (*(uint32_t*)&(USARTx));
//  374   /* Get the USART register index */
//  375   usartreg = (((uint8_t)USART_IT) >> 0x05);
        LSLS     R3,R1,#+24
        LSRS     R3,R3,#+29
//  376   /* Get the interrupt position */
//  377   itpos = USART_IT & IT_Mask;
//  378   itmask = (((uint32_t)0x01) << itpos);
        MOVS     R4,#+1
        AND      R1,R1,#0x1F
        LSL      R1,R4,R1
//  379     
//  380   if (usartreg == 0x01) /* The IT is in CR1 register */
        CMP      R3,#+1
        BNE.N    ??USART_ITConfig_0
//  381   {
//  382     usartxbase += 0x0C;
        ADDS     R0,R0,#+12
        B.N      ??USART_ITConfig_1
//  383   }
//  384   else if (usartreg == 0x02) /* The IT is in CR2 register */
??USART_ITConfig_0:
        CMP      R3,#+2
        ITE      EQ 
        ADDEQ    R0,R0,#+16
        ADDNE    R0,R0,#+20
//  385   {
//  386     usartxbase += 0x10;
//  387   }
//  388   else /* The IT is in CR3 register */
//  389   {
//  390     usartxbase += 0x14; 
//  391   }
//  392   if (NewState != DISABLE)
??USART_ITConfig_1:
        CMP      R2,#+0
        LDR      R2,[R0, #+0]
        ITE      NE 
        ORRNE    R1,R1,R2
        BICEQ    R1,R2,R1
//  393   {
//  394     *(__IO uint32_t*)usartxbase  |= itmask;
//  395   }
//  396   else
//  397   {
//  398     *(__IO uint32_t*)usartxbase &= ~itmask;
        STR      R1,[R0, #+0]
//  399   }
//  400 }
        POP      {R4,PC}          ;; return
//  401 
//  402 /**
//  403   * @brief  Enables or disables the USARTs DMA interface.
//  404   * @param USARTx: Select the USART or the UART peripheral. 
//  405   *   This parameter can be one of the following values:
//  406   *   USART1, USART2, USART3 or UART4.  
//  407   * @param USART_DMAReq: specifies the DMA request.
//  408   *   This parameter can be any combination of the following values:
//  409   * @arg USART_DMAReq_Tx: USART DMA transmit request
//  410   * @arg USART_DMAReq_Rx: USART DMA receive request
//  411   * @param NewState: new state of the DMA Request sources.
//  412   *   This parameter can be: ENABLE or DISABLE.
//  413   * @note The DMA mode is not available for UART5.  
//  414   * @retval : None
//  415   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  416 void USART_DMACmd(USART_TypeDef* USARTx, uint16_t USART_DMAReq, FunctionalState NewState)
//  417 {
//  418   /* Check the parameters */
//  419   assert_param(IS_USART_1234_PERIPH(USARTx));
//  420   assert_param(IS_USART_DMAREQ(USART_DMAReq));  
//  421   assert_param(IS_FUNCTIONAL_STATE(NewState)); 
//  422   if (NewState != DISABLE)
USART_DMACmd:
        CMP      R2,#+0
        LDRH     R2,[R0, #+20]
        ITE      NE 
        ORRNE    R1,R1,R2
        BICEQ    R1,R2,R1
//  423   {
//  424     /* Enable the DMA transfer for selected requests by setting the DMAT and/or
//  425        DMAR bits in the USART CR3 register */
//  426     USARTx->CR3 |= USART_DMAReq;
//  427   }
//  428   else
//  429   {
//  430     /* Disable the DMA transfer for selected requests by clearing the DMAT and/or
//  431        DMAR bits in the USART CR3 register */
//  432     USARTx->CR3 &= (uint16_t)~USART_DMAReq;
        STRH     R1,[R0, #+20]
//  433   }
//  434 }
        BX       LR               ;; return
//  435 
//  436 /**
//  437   * @brief  Sets the address of the USART node.
//  438   * @param USARTx: Select the USART or the UART peripheral. 
//  439   *   This parameter can be one of the following values:
//  440   *   USART1, USART2, USART3, UART4 or UART5.
//  441   * @param USART_Address: Indicates the address of the USART node.
//  442   * @retval : None
//  443   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  444 void USART_SetAddress(USART_TypeDef* USARTx, uint8_t USART_Address)
//  445 {
//  446   /* Check the parameters */
//  447   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  448   assert_param(IS_USART_ADDRESS(USART_Address)); 
//  449     
//  450   /* Clear the USART address */
//  451   USARTx->CR2 &= CR2_Address_Mask;
USART_SetAddress:
        LDRH     R2,[R0, #+16]
        MOVW     R3,#+65520
        B.N      ?Subroutine0
//  452   /* Set the USART address node */
//  453   USARTx->CR2 |= USART_Address;
//  454 }
//  455 
//  456 /**
//  457   * @brief  Selects the USART WakeUp method.
//  458   * @param USARTx: Select the USART or the UART peripheral. 
//  459   *   This parameter can be one of the following values:
//  460   *   USART1, USART2, USART3, UART4 or UART5.
//  461   * @param USART_WakeUp: specifies the USART wakeup method.
//  462   *   This parameter can be one of the following values:
//  463   * @arg USART_WakeUp_IdleLine: WakeUp by an idle line detection
//  464   * @arg USART_WakeUp_AddressMark: WakeUp by an address mark
//  465   * @retval : None
//  466   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  467 void USART_WakeUpConfig(USART_TypeDef* USARTx, uint16_t USART_WakeUp)
//  468 {
//  469   /* Check the parameters */
//  470   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  471   assert_param(IS_USART_WAKEUP(USART_WakeUp));
//  472   
//  473   USARTx->CR1 &= CR1_WAKE_Mask;
USART_WakeUpConfig:
        LDRH     R2,[R0, #+12]
        MOVW     R3,#+63487
        ANDS     R2,R3,R2
        STRH     R2,[R0, #+12]
//  474   USARTx->CR1 |= USART_WakeUp;
        LDRH     R2,[R0, #+12]
        ORRS     R1,R1,R2
        STRH     R1,[R0, #+12]
//  475 }
        BX       LR               ;; return
//  476 
//  477 /**
//  478   * @brief  Determines if the USART is in mute mode or not.
//  479   * @param USARTx: Select the USART or the UART peripheral. 
//  480   *   This parameter can be one of the following values:
//  481   *   USART1, USART2, USART3, UART4 or UART5.
//  482   * @param NewState: new state of the USART mute mode.
//  483   *   This parameter can be: ENABLE or DISABLE.
//  484   * @retval : None
//  485   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  486 void USART_ReceiverWakeUpCmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  487 {
//  488   /* Check the parameters */
//  489   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  490   assert_param(IS_FUNCTIONAL_STATE(NewState)); 
//  491   
//  492   if (NewState != DISABLE)
USART_ReceiverWakeUpCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+12]
        ITEE     NE 
        ORRNE    R1,R1,#0x2
        MOVWEQ   R2,#+65533
        ANDEQ    R1,R2,R1
//  493   {
//  494     /* Enable the USART mute mode  by setting the RWU bit in the CR1 register */
//  495     USARTx->CR1 |= CR1_RWU_Set;
//  496   }
//  497   else
//  498   {
//  499     /* Disable the USART mute mode by clearing the RWU bit in the CR1 register */
//  500     USARTx->CR1 &= CR1_RWU_Reset;
        STRH     R1,[R0, #+12]
//  501   }
//  502 }
        BX       LR               ;; return
//  503 
//  504 /**
//  505   * @brief  Sets the USART LIN Break detection length.
//  506   * @param USARTx: Select the USART or the UART peripheral. 
//  507   *   This parameter can be one of the following values:
//  508   *   USART1, USART2, USART3, UART4 or UART5.
//  509   * @param USART_LINBreakDetectLength: specifies the LIN break
//  510   *   detection length.
//  511   *   This parameter can be one of the following values:
//  512   * @arg USART_LINBreakDetectLength_10b: 10-bit break detection
//  513   * @arg USART_LINBreakDetectLength_11b: 11-bit break detection
//  514   * @retval : None
//  515   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  516 void USART_LINBreakDetectLengthConfig(USART_TypeDef* USARTx, uint16_t USART_LINBreakDetectLength)
//  517 {
//  518   /* Check the parameters */
//  519   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  520   assert_param(IS_USART_LIN_BREAK_DETECT_LENGTH(USART_LINBreakDetectLength));
//  521   
//  522   USARTx->CR2 &= CR2_LBDL_Mask;
USART_LINBreakDetectLengthConfig:
        LDRH     R2,[R0, #+16]
        MOVW     R3,#+65503
        REQUIRE ?Subroutine0
        ;; // Fall through to label ?Subroutine0
//  523   USARTx->CR2 |= USART_LINBreakDetectLength;  
//  524 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine0:
        ANDS     R2,R3,R2
        STRH     R2,[R0, #+16]
        LDRH     R2,[R0, #+16]
??Subroutine0_0:
        ORRS     R1,R1,R2
        STRH     R1,[R0, #+16]
        BX       LR               ;; return
//  525 
//  526 /**
//  527   * @brief  Enables or disables the USARTs LIN mode.
//  528   * @param USARTx: Select the USART or the UART peripheral. 
//  529   *   This parameter can be one of the following values:
//  530   *   USART1, USART2, USART3, UART4 or UART5.
//  531   * @param NewState: new state of the USART LIN mode.
//  532   *   This parameter can be: ENABLE or DISABLE.
//  533   * @retval : None
//  534   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  535 void USART_LINCmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  536 {
//  537   /* Check the parameters */
//  538   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  539   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  540   
//  541   if (NewState != DISABLE)
USART_LINCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+16]
        ITEE     NE 
        ORRNE    R1,R1,#0x4000
        MOVWEQ   R2,#+49151
        ANDEQ    R1,R2,R1
//  542   {
//  543     /* Enable the LIN mode by setting the LINEN bit in the CR2 register */
//  544     USARTx->CR2 |= CR2_LINEN_Set;
//  545   }
//  546   else
//  547   {
//  548     /* Disable the LIN mode by clearing the LINEN bit in the CR2 register */
//  549     USARTx->CR2 &= CR2_LINEN_Reset;
        STRH     R1,[R0, #+16]
//  550   }
//  551 }
        BX       LR               ;; return
//  552 
//  553 /**
//  554   * @brief  Transmits single data through the USARTx peripheral.
//  555   * @param USARTx: Select the USART or the UART peripheral. 
//  556   *   This parameter can be one of the following values:
//  557   *   USART1, USART2, USART3, UART4 or UART5.
//  558   * @param Data: the data to transmit.
//  559   * @retval : None
//  560   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  561 void USART_SendData(USART_TypeDef* USARTx, uint16_t Data)
//  562 {
//  563   /* Check the parameters */
//  564   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  565   assert_param(IS_USART_DATA(Data)); 
//  566     
//  567   /* Transmit Data */
//  568   USARTx->DR = (Data & (uint16_t)0x01FF);
USART_SendData:
        LSLS     R1,R1,#+23
        LSRS     R1,R1,#+23
        STRH     R1,[R0, #+4]
//  569 }
        BX       LR               ;; return
//  570 
//  571 /**
//  572   * @brief  Returns the most recent received data by the USARTx peripheral.
//  573   * @param USARTx: Select the USART or the UART peripheral. 
//  574   *   This parameter can be one of the following values:
//  575   *   USART1, USART2, USART3, UART4 or UART5.
//  576   * @retval : The received data.
//  577   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  578 uint16_t USART_ReceiveData(USART_TypeDef* USARTx)
//  579 {
//  580   /* Check the parameters */
//  581   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  582   
//  583   /* Receive Data */
//  584   return (uint16_t)(USARTx->DR & (uint16_t)0x01FF);
USART_ReceiveData:
        LDRH     R0,[R0, #+4]
        LSLS     R0,R0,#+23
        LSRS     R0,R0,#+23
        BX       LR               ;; return
//  585 }
//  586 
//  587 /**
//  588   * @brief  Transmits break characters.
//  589   * @param USARTx: Select the USART or the UART peripheral. 
//  590   *   This parameter can be one of the following values:
//  591   *   USART1, USART2, USART3, UART4 or UART5.
//  592   * @retval : None
//  593   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  594 void USART_SendBreak(USART_TypeDef* USARTx)
//  595 {
//  596   /* Check the parameters */
//  597   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  598   
//  599   /* Send break characters */
//  600   USARTx->CR1 |= CR1_SBK_Set;
USART_SendBreak:
        LDRH     R1,[R0, #+12]
        ORR      R1,R1,#0x1
        STRH     R1,[R0, #+12]
//  601 }
        BX       LR               ;; return
//  602 
//  603 /**
//  604   * @brief  Sets the specified USART guard time.
//  605   * @param USARTx: where x can be 1, 2 or 3 to select the USART
//  606   *   peripheral.
//  607   * @param USART_GuardTime: specifies the guard time.
//  608   * @note The guard time bits are not available for UART4 and UART5.   
//  609   * @retval : None
//  610   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  611 void USART_SetGuardTime(USART_TypeDef* USARTx, uint8_t USART_GuardTime)
//  612 {    
//  613   /* Check the parameters */
//  614   assert_param(IS_USART_123_PERIPH(USARTx));
//  615   
//  616   /* Clear the USART Guard time */
//  617   USARTx->GTPR &= GTPR_LSB_Mask;
USART_SetGuardTime:
        LDRH     R2,[R0, #+24]
        UXTB     R2,R2
        STRH     R2,[R0, #+24]
//  618   /* Set the USART guard time */
//  619   USARTx->GTPR |= (uint16_t)((uint16_t)USART_GuardTime << 0x08);
        LDRH     R2,[R0, #+24]
        ORR      R1,R2,R1, LSL #+8
        STRH     R1,[R0, #+24]
//  620 }
        BX       LR               ;; return
//  621 
//  622 /**
//  623   * @brief  Sets the system clock prescaler.
//  624   * @param USARTx: Select the USART or the UART peripheral. 
//  625   *   This parameter can be one of the following values:
//  626   *   USART1, USART2, USART3, UART4 or UART5.
//  627   * @param USART_Prescaler: specifies the prescaler clock.  
//  628   * @note The function is used for IrDA mode with UART4 and UART5.
//  629    * @retval : None
//  630   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  631 void USART_SetPrescaler(USART_TypeDef* USARTx, uint8_t USART_Prescaler)
//  632 { 
//  633   /* Check the parameters */
//  634   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  635   
//  636   /* Clear the USART prescaler */
//  637   USARTx->GTPR &= GTPR_MSB_Mask;
USART_SetPrescaler:
        LDRH     R2,[R0, #+24]
        AND      R2,R2,#0xFF00
        STRH     R2,[R0, #+24]
//  638   /* Set the USART prescaler */
//  639   USARTx->GTPR |= USART_Prescaler;
        LDRH     R2,[R0, #+24]
        ORRS     R1,R1,R2
        STRH     R1,[R0, #+24]
//  640 }
        BX       LR               ;; return
//  641 
//  642 /**
//  643   * @brief  Enables or disables the USARTs Smart Card mode.
//  644   * @param USARTx: where x can be 1, 2 or 3 to select the USART
//  645   *   peripheral.
//  646   * @param NewState: new state of the Smart Card mode.
//  647   *   This parameter can be: ENABLE or DISABLE.     
//  648   * @note The Smart Card mode is not available for UART4 and UART5. 
//  649   * @retval : None
//  650   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  651 void USART_SmartCardCmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  652 {
//  653   /* Check the parameters */
//  654   assert_param(IS_USART_123_PERIPH(USARTx));
//  655   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  656   if (NewState != DISABLE)
USART_SmartCardCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+20]
        ITEE     NE 
        ORRNE    R1,R1,#0x20
        MOVWEQ   R2,#+65503
        ANDEQ    R1,R2,R1
//  657   {
//  658     /* Enable the SC mode by setting the SCEN bit in the CR3 register */
//  659     USARTx->CR3 |= CR3_SCEN_Set;
//  660   }
//  661   else
//  662   {
//  663     /* Disable the SC mode by clearing the SCEN bit in the CR3 register */
//  664     USARTx->CR3 &= CR3_SCEN_Reset;
        STRH     R1,[R0, #+20]
//  665   }
//  666 }
        BX       LR               ;; return
//  667 
//  668 /**
//  669   * @brief  Enables or disables NACK transmission.
//  670   * @param USARTx: where x can be 1, 2 or 3 to select the USART
//  671   *   peripheral. 
//  672   * @param NewState: new state of the NACK transmission.
//  673   *   This parameter can be: ENABLE or DISABLE.  
//  674   * @note The Smart Card mode is not available for UART4 and UART5.
//  675   * @retval : None
//  676   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  677 void USART_SmartCardNACKCmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  678 {
//  679   /* Check the parameters */
//  680   assert_param(IS_USART_123_PERIPH(USARTx));  
//  681   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  682   if (NewState != DISABLE)
USART_SmartCardNACKCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+20]
        ITEE     NE 
        ORRNE    R1,R1,#0x10
        MOVWEQ   R2,#+65519
        ANDEQ    R1,R2,R1
//  683   {
//  684     /* Enable the NACK transmission by setting the NACK bit in the CR3 register */
//  685     USARTx->CR3 |= CR3_NACK_Set;
//  686   }
//  687   else
//  688   {
//  689     /* Disable the NACK transmission by clearing the NACK bit in the CR3 register */
//  690     USARTx->CR3 &= CR3_NACK_Reset;
        STRH     R1,[R0, #+20]
//  691   }
//  692 }
        BX       LR               ;; return
//  693 
//  694 /**
//  695   * @brief  Enables or disables the USARTs Half Duplex communication.
//  696   * @param USARTx: Select the USART or the UART peripheral. 
//  697   *   This parameter can be one of the following values:
//  698   *   USART1, USART2, USART3, UART4 or UART5.
//  699   * @param NewState: new state of the USART Communication.
//  700   *   This parameter can be: ENABLE or DISABLE.
//  701   * @retval : None
//  702   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  703 void USART_HalfDuplexCmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  704 {
//  705   /* Check the parameters */
//  706   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  707   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  708   
//  709   if (NewState != DISABLE)
USART_HalfDuplexCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+20]
        ITEE     NE 
        ORRNE    R1,R1,#0x8
        MOVWEQ   R2,#+65527
        ANDEQ    R1,R2,R1
//  710   {
//  711     /* Enable the Half-Duplex mode by setting the HDSEL bit in the CR3 register */
//  712     USARTx->CR3 |= CR3_HDSEL_Set;
//  713   }
//  714   else
//  715   {
//  716     /* Disable the Half-Duplex mode by clearing the HDSEL bit in the CR3 register */
//  717     USARTx->CR3 &= CR3_HDSEL_Reset;
        STRH     R1,[R0, #+20]
//  718   }
//  719 }
        BX       LR               ;; return
//  720 
//  721 /**
//  722   * @brief  Configures the USARTs IrDA interface.
//  723   * @param USARTx: Select the USART or the UART peripheral. 
//  724   *   This parameter can be one of the following values:
//  725   *   USART1, USART2, USART3, UART4 or UART5.
//  726   * @param USART_IrDAMode: specifies the IrDA mode.
//  727   *   This parameter can be one of the following values:
//  728   * @arg USART_IrDAMode_LowPower
//  729   * @arg USART_IrDAMode_Normal
//  730   * @retval : None
//  731   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  732 void USART_IrDAConfig(USART_TypeDef* USARTx, uint16_t USART_IrDAMode)
//  733 {
//  734   /* Check the parameters */
//  735   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  736   assert_param(IS_USART_IRDA_MODE(USART_IrDAMode));
//  737     
//  738   USARTx->CR3 &= CR3_IRLP_Mask;
USART_IrDAConfig:
        LDRH     R2,[R0, #+20]
        MOVW     R3,#+65531
        ANDS     R2,R3,R2
        STRH     R2,[R0, #+20]
//  739   USARTx->CR3 |= USART_IrDAMode;
        LDRH     R2,[R0, #+20]
        ORRS     R1,R1,R2
        STRH     R1,[R0, #+20]
//  740 }
        BX       LR               ;; return
//  741 
//  742 /**
//  743   * @brief  Enables or disables the USARTs IrDA interface.
//  744   * @param USARTx: Select the USART or the UART peripheral. 
//  745   *   This parameter can be one of the following values:
//  746   *   USART1, USART2, USART3, UART4 or UART5.
//  747   * @param NewState: new state of the IrDA mode.
//  748   *   This parameter can be: ENABLE or DISABLE.
//  749   * @retval : None
//  750   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  751 void USART_IrDACmd(USART_TypeDef* USARTx, FunctionalState NewState)
//  752 {
//  753   /* Check the parameters */
//  754   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  755   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  756     
//  757   if (NewState != DISABLE)
USART_IrDACmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+20]
        ITEE     NE 
        ORRNE    R1,R1,#0x2
        MOVWEQ   R2,#+65533
        ANDEQ    R1,R2,R1
//  758   {
//  759     /* Enable the IrDA mode by setting the IREN bit in the CR3 register */
//  760     USARTx->CR3 |= CR3_IREN_Set;
//  761   }
//  762   else
//  763   {
//  764     /* Disable the IrDA mode by clearing the IREN bit in the CR3 register */
//  765     USARTx->CR3 &= CR3_IREN_Reset;
        STRH     R1,[R0, #+20]
//  766   }
//  767 }
        BX       LR               ;; return
//  768 
//  769 /**
//  770   * @brief  Checks whether the specified USART flag is set or not.
//  771   * @param USARTx: Select the USART or the UART peripheral. 
//  772   *   This parameter can be one of the following values:
//  773   *   USART1, USART2, USART3, UART4 or UART5.
//  774   * @param USART_FLAG: specifies the flag to check.
//  775   *   This parameter can be one of the following values:
//  776   * @arg USART_FLAG_CTS:  CTS Change flag (not available for UART4 and UART5)
//  777   * @arg USART_FLAG_LBD:  LIN Break detection flag
//  778   * @arg USART_FLAG_TXE:  Transmit data register empty flag
//  779   * @arg USART_FLAG_TC:   Transmission Complete flag
//  780   * @arg USART_FLAG_RXNE: Receive data register not empty flag
//  781   * @arg USART_FLAG_IDLE: Idle Line detection flag
//  782   * @arg USART_FLAG_ORE:  OverRun Error flag
//  783   * @arg USART_FLAG_NE:   Noise Error flag
//  784   * @arg USART_FLAG_FE:   Framing Error flag
//  785   * @arg USART_FLAG_PE:   Parity Error flag
//  786   * @retval : The new state of USART_FLAG (SET or RESET).
//  787   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  788 FlagStatus USART_GetFlagStatus(USART_TypeDef* USARTx, uint16_t USART_FLAG)
//  789 {
//  790   FlagStatus bitstatus = RESET;
//  791   /* Check the parameters */
//  792   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  793   assert_param(IS_USART_FLAG(USART_FLAG));
//  794   assert_param(IS_USART_PERIPH_FLAG(USARTx, USART_FLAG)); /* The CTS flag is not available for UART4 and UART5 */   
//  795   if ((USARTx->SR & USART_FLAG) != (uint16_t)RESET)
USART_GetFlagStatus:
        LDRH     R0,[R0, #+0]
        ANDS     R1,R1,R0
        MOVS     R0,R1
        BEQ.N    ??USART_GetFlagStatus_0
        MOVS     R0,#+1
//  796   {
//  797     bitstatus = SET;
//  798   }
//  799   else
//  800   {
//  801     bitstatus = RESET;
//  802   }
//  803   return bitstatus;
??USART_GetFlagStatus_0:
        UXTB     R0,R0
        BX       LR               ;; return
//  804 }
//  805 
//  806 /**
//  807   * @brief  Clears the USARTx's pending flags.
//  808   * @param USARTx: Select the USART or the UART peripheral. 
//  809   *   This parameter can be one of the following values:
//  810   *   USART1, USART2, USART3, UART4 or UART5.
//  811   * @param USART_FLAG: specifies the flag to clear.
//  812   *   This parameter can be any combination of the following values:
//  813   * @arg USART_FLAG_CTS:  CTS Change flag (not available for UART4 and UART5).
//  814   * @arg USART_FLAG_LBD:  LIN Break detection flag.
//  815   * @arg USART_FLAG_TC:   Transmission Complete flag.
//  816   * @arg USART_FLAG_RXNE: Receive data register not empty flag.
//  817   *   
//  818   * @note
//  819   *   - PE (Parity error), FE (Framing error), NE (Noise error), ORE (OverRun 
//  820   *     error) and IDLE (Idle line detected) flags are cleared by software 
//  821   *     sequence: a read operation to USART_SR register (USART_GetFlagStatus()) 
//  822   *     followed by a read operation to USART_DR register (USART_ReceiveData()).
//  823   *   - RXNE flag can be also cleared by a read to the USART_DR register 
//  824   *     (USART_ReceiveData()).
//  825   *   - TC flag can be also cleared by software sequence: a read operation to 
//  826   *     USART_SR register (USART_GetFlagStatus()) followed by a write operation
//  827   *     to USART_DR register (USART_SendData()).
//  828   *   - TXE flag is cleared only by a write to the USART_DR register 
//  829   *     (USART_SendData()).
//  830   * @retval : None
//  831   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  832 void USART_ClearFlag(USART_TypeDef* USARTx, uint16_t USART_FLAG)
//  833 {
//  834   /* Check the parameters */
//  835   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  836   assert_param(IS_USART_CLEAR_FLAG(USART_FLAG));
//  837   assert_param(IS_USART_PERIPH_FLAG(USARTx, USART_FLAG)); /* The CTS flag is not available for UART4 and UART5 */   
//  838    
//  839   USARTx->SR = (uint16_t)~USART_FLAG;
USART_ClearFlag:
        B.N      ?Subroutine1
//  840 }
//  841 
//  842 /**
//  843   * @brief  Checks whether the specified USART interrupt has occurred or not.
//  844   * @param USARTx: Select the USART or the UART peripheral. 
//  845   *   This parameter can be one of the following values:
//  846   *   USART1, USART2, USART3, UART4 or UART5.
//  847   * @param USART_IT: specifies the USART interrupt source to check.
//  848   *   This parameter can be one of the following values:
//  849   * @arg USART_IT_CTS:  CTS change interrupt (not available for UART4 and UART5)
//  850   * @arg USART_IT_LBD:  LIN Break detection interrupt
//  851   * @arg USART_IT_TXE:  Tansmit Data Register empty interrupt
//  852   * @arg USART_IT_TC:   Transmission complete interrupt
//  853   * @arg USART_IT_RXNE: Receive Data register not empty interrupt
//  854   * @arg USART_IT_IDLE: Idle line detection interrupt
//  855   * @arg USART_IT_ORE:  OverRun Error interrupt
//  856   * @arg USART_IT_NE:   Noise Error interrupt
//  857   * @arg USART_IT_FE:   Framing Error interrupt
//  858   * @arg USART_IT_PE:   Parity Error interrupt
//  859   * @retval : The new state of USART_IT (SET or RESET).
//  860   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  861 ITStatus USART_GetITStatus(USART_TypeDef* USARTx, uint16_t USART_IT)
//  862 {
USART_GetITStatus:
        PUSH     {R4,LR}
//  863   uint32_t bitpos = 0x00, itmask = 0x00, usartreg = 0x00;
//  864   ITStatus bitstatus = RESET;
//  865   /* Check the parameters */
//  866   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  867   assert_param(IS_USART_GET_IT(USART_IT));
//  868   assert_param(IS_USART_PERIPH_IT(USARTx, USART_IT)); /* The CTS interrupt is not available for UART4 and UART5 */  
//  869   
//  870   /* Get the USART register index */
//  871   usartreg = (((uint8_t)USART_IT) >> 0x05);
        LSLS     R2,R1,#+24
        LSRS     R2,R2,#+29
//  872   /* Get the interrupt position */
//  873   itmask = USART_IT & IT_Mask;
//  874   itmask = (uint32_t)0x01 << itmask;
        MOVS     R3,#+1
        AND      R4,R1,#0x1F
        LSL      R4,R3,R4
//  875   
//  876   if (usartreg == 0x01) /* The IT  is in CR1 register */
        CMP      R2,#+1
        BNE.N    ??USART_GetITStatus_0
//  877   {
//  878     itmask &= USARTx->CR1;
        LDRH     R2,[R0, #+12]
        B.N      ??USART_GetITStatus_1
//  879   }
//  880   else if (usartreg == 0x02) /* The IT  is in CR2 register */
??USART_GetITStatus_0:
        CMP      R2,#+2
        ITE      EQ 
        LDRHEQ   R2,[R0, #+16]
        LDRHNE   R2,[R0, #+20]
//  881   {
//  882     itmask &= USARTx->CR2;
//  883   }
//  884   else /* The IT  is in CR3 register */
//  885   {
//  886     itmask &= USARTx->CR3;
??USART_GetITStatus_1:
        ANDS     R2,R2,R4
//  887   }
//  888   
//  889   bitpos = USART_IT >> 0x08;
//  890   bitpos = (uint32_t)0x01 << bitpos;
//  891   bitpos &= USARTx->SR;
        LSRS     R1,R1,#+8
        LSL      R1,R3,R1
        LDRH     R0,[R0, #+0]
        ANDS     R0,R0,R1
//  892   if ((itmask != (uint16_t)RESET)&&(bitpos != (uint16_t)RESET))
        CBZ      R2,??USART_GetITStatus_2
        CBZ      R0,??USART_GetITStatus_3
        MOVS     R0,#+1
        B.N      ??USART_GetITStatus_3
//  893   {
//  894     bitstatus = SET;
//  895   }
//  896   else
//  897   {
//  898     bitstatus = RESET;
??USART_GetITStatus_2:
        MOVS     R0,#+0
//  899   }
//  900   
//  901   return bitstatus;  
??USART_GetITStatus_3:
        UXTB     R0,R0
        POP      {R4,PC}          ;; return
//  902 }
//  903 
//  904 /**
//  905   * @brief  Clears the USARTxs interrupt pending bits.
//  906   * @param USARTx: Select the USART or the UART peripheral. 
//  907   *   This parameter can be one of the following values:
//  908   *   USART1, USART2, USART3, UART4 or UART5.
//  909   * @param USART_IT: specifies the interrupt pending bit to clear.
//  910   *   This parameter can be one of the following values:
//  911   * @arg USART_IT_CTS:  CTS change interrupt (not available for UART4 and UART5)
//  912   * @arg USART_IT_LBD:  LIN Break detection interrupt
//  913   * @arg USART_IT_TC:   Transmission complete interrupt. 
//  914   * @arg USART_IT_RXNE: Receive Data register not empty interrupt.
//  915   *   
//  916   * @note
//  917   *   - PE (Parity error), FE (Framing error), NE (Noise error), ORE (OverRun 
//  918   *     error) and IDLE (Idle line detected) pending bits are cleared by 
//  919   *     software sequence: a read operation to USART_SR register 
//  920   *     (USART_GetITStatus()) followed by a read operation to USART_DR register 
//  921   *     (USART_ReceiveData()).
//  922   *   - RXNE pending bit can be also cleared by a read to the USART_DR register 
//  923   *     (USART_ReceiveData()).
//  924   *   - TC pending bit can be also cleared by software sequence: a read 
//  925   *     operation to USART_SR register (USART_GetITStatus()) followed by a write 
//  926   *     operation to USART_DR register (USART_SendData()).
//  927   *   - TXE pending bit is cleared only by a write to the USART_DR register 
//  928   *     (USART_SendData()).
//  929   * @retval : None
//  930   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  931 void USART_ClearITPendingBit(USART_TypeDef* USARTx, uint16_t USART_IT)
//  932 {
//  933   uint16_t bitpos = 0x00, itmask = 0x00;
//  934   /* Check the parameters */
//  935   assert_param(IS_USART_ALL_PERIPH(USARTx));
//  936   assert_param(IS_USART_CLEAR_IT(USART_IT));
//  937   assert_param(IS_USART_PERIPH_IT(USARTx, USART_IT)); /* The CTS interrupt is not available for UART4 and UART5 */
//  938   
//  939   bitpos = USART_IT >> 0x08;
//  940   itmask = (uint16_t)((uint16_t)0x01 << bitpos);
//  941   USARTx->SR = (uint16_t)~itmask;
USART_ClearITPendingBit:
        MOVS     R2,#+1
        LSRS     R1,R1,#+8
        LSL      R1,R2,R1
        UXTH     R1,R1
        REQUIRE ?Subroutine1
        ;; // Fall through to label ?Subroutine1
//  942 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine1:
        MVNS     R1,R1
        STRH     R1,[R0, #+0]
        BX       LR               ;; return

        END
//  943 /**
//  944   * @}
//  945   */
//  946 
//  947 /**
//  948   * @}
//  949   */
//  950 
//  951 /**
//  952   * @}
//  953   */
//  954 
//  955 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
// 734 bytes in section .text
// 
// 734 bytes of CODE memory
//
//Errors: none
//Warnings: none
