///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:50 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Project\Template\main.c                       /
//    Command line =  C:\My_App\Project\Template\main.c -D                    /
//                    USE_STDPERIPH_DRIVER -D STM32F10X_HD -D                 /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\m /
//                    ain.s                                                   /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME main

        EXTERN GPIO_Init
        EXTERN I2C_EE_BufferRead
        EXTERN I2C_EE_BufferWrite
        EXTERN I2C_EE_Init
        EXTERN RCC_APB1PeriphClockCmd
        EXTERN RCC_APB2PeriphClockCmd
        EXTERN SystemInit
        EXTERN USART_Cmd
        EXTERN USART_Init
        EXTERN getline
        EXTERN printf
        EXTERN sscanf
        EXTERN toupper

        PUBLIC Buffercmp
        PUBLIC ERROR_STR
        PUBLIC GPIOUTx_Configuration
        PUBLIC RCC_Configuration
        PUBLIC Rx1_Buffer
        PUBLIC TransferStatus1
        PUBLIC Tx1_Buffer
        PUBLIC USART_InitStructure
        PUBLIC USARTx_configuration
        PUBLIC main
        PUBLIC menu
        PUBLIC read_eeprom
        PUBLIC write_eeprom

// C:\My_App\Project\Template\main.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file I2C/M24C08_EEPROM/main.c 
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  Main program body
//    8   ******************************************************************************
//    9   * @copy
//   10   *
//   11   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   12   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   13   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   14   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   15   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   16   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   17   *
//   18   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   19   */ 
//   20 
//   21 /* Includes ------------------------------------------------------------------*/
//   22 #include <stdio.h>                          /* standard I/O .h-file           */
//   23 #include <ctype.h>                          /* character functions            */
//   24 #include "stm32f10x.h"
//   25 #include "platform_config.h"
//   26 #include "i2c_ee.h"
//   27 #include "measure.h"
//   28 
//   29 /** @addtogroup StdPeriph_Examples
//   30   * @{
//   31   */
//   32 
//   33 /** @addtogroup I2C_M24C08_EEPROM
//   34   * @{
//   35   */ 
//   36 
//   37 /* Private typedef -----------------------------------------------------------*/
//   38 typedef enum {FAILED = 0, PASSED = !FAILED} TestStatus;
//   39 
//   40 /* Private define ------------------------------------------------------------*/
//   41 
//   42 /* Private variables ---------------------------------------------------------*/
//   43 uint8_t Tx1_Buffer[256];

        SECTION `.bss`:DATA:NOROOT(2)
//   44 uint8_t Rx1_Buffer[256];
Rx1_Buffer:
        DS8 256

        SECTION `.bss`:DATA:NOROOT(0)
//   45 volatile TestStatus TransferStatus1 = FAILED;
TransferStatus1:
        DS8 1

        SECTION `.bss`:DATA:NOROOT(2)
//   46 USART_InitTypeDef USART_InitStructure;
USART_InitStructure:
        DS8 16

        SECTION `.data`:DATA:NOROOT(2)
Tx1_Buffer:
        DATA
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        DC8 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
//   47 char ERROR_STR [] = "\n: %s\n";    /* ERROR message string in code   */
ERROR_STR:
        DC8 "\012\312\344\310\353\264\355\316\363: %s\012"
        DC8 0

        SECTION `.rodata`:CONST:NOROOT(2)
`?<Constant "\\n\\303\\374\\301\\356: ">`:
        DATA
        DC8 "\012\303\374\301\356: "
        DC8 "\316\264\326\252\303\374\301\356\241\243"
        DC8 0
//   48 const char menu[] =
menu:
        DC8 0AH, 2BH, 2AH, 2AH, 2AH, 2AH, 2AH, 2AH
        DC8 2AH, 2AH, 2AH, 2AH, 2AH, 2AH, 20H, 0BAH
        DC8 0ECH, 0C5H, 0A3H, 0BFH, 0AAH, 0B7H, 0A2H, 0B0H
        DC8 0E5H, 20H, 32H, 34H, 43H, 30H, 32H, 0B6H
        DC8 0C1H, 0D0H, 0B4H, 0B2H, 0E2H, 0CAH, 0D4H, 0B3H
        DC8 0CCH, 0D0H, 0F2H, 20H, 2AH, 2AH, 2AH, 2AH
        DC8 2AH, 2AH, 2AH, 2AH, 2AH, 2AH, 2AH, 2AH
        DC8 2BH, 0AH, 7CH, 20H, 20H, 20H, 20H, 20H
        DC8 0D5H, 0E2H, 0B8H, 0F6H, 0B3H, 0CCH, 0D0H, 0F2H
        DC8 0CAH, 0B5H, 0CFH, 0D6H, 0C1H, 0CBH, 0B6H, 0D4H
        DC8 32H, 34H, 43H, 30H, 32H, 0D0H, 0BEH, 0C6H
        DC8 0ACH, 0B5H, 0C4H, 0CDH, 0EAH, 0D5H, 0FBH, 0B6H
        DC8 0C1H, 0D0H, 0B4H, 0B2H, 0E2H, 0CAH, 0D4H, 0A1H
        DC8 0A3H, 32H, 34H, 43H, 30H, 32H, 0B9H, 0B2H
        DC8 20H, 7CH, 0AH, 7CH, 20H, 32H, 35H, 36H
        DC8 0D7H, 0D6H, 0BDH, 0DAH, 0B5H, 0C4H, 0B4H, 0E6H
        DC8 0B4H, 0A2H, 0BFH, 0D5H, 0BCH, 0E4H, 0A3H, 0ACH
        DC8 0D2H, 0B3H, 0B4H, 0F3H, 0D0H, 0A1H, 0CEH, 0AAH
        DC8 38H, 0D7H, 0D6H, 0BDH, 0DAH, 0A3H, 0ACH, 0BFH
        DC8 0C9H, 0D2H, 0D4H, 0B0H, 0B4H, 0D7H, 0D6H, 0BDH
        DC8 0DAH, 0BBH, 0F2H, 0D2H, 0B3H, 0BDH, 0F8H, 0D0H
        DC8 0D0H, 20H, 7CH, 0AH, 7CH, 20H, 0B6H, 0C1H
        DC8 0D0H, 0B4H, 0A1H, 0A3H, 0B1H, 0BEH, 0B3H, 0CCH
        DC8 0D0H, 0F2H, 0D4H, 0DAH, 49H, 41H, 52H, 35H
        DC8 2EH, 34H, 0BAH, 0CDH, 4BH, 65H, 69H, 6CH
        DC8 20H, 4DH, 44H, 4BH, 20H, 33H, 2EH, 38H
        DC8 0CFH, 0C2H, 0C8H, 0ABH, 0B2H, 0BFH, 0B2H, 0E2H
        DC8 0CAH, 0D4H, 0CDH, 0A8H, 0B9H, 0FDH, 0A1H, 0A3H
        DC8 20H, 20H, 20H, 7CH, 0AH, 7CH, 20H, 20H
        DC8 20H, 20H, 20H, 0CAH, 0B9H, 0D3H, 0C3H, 0BEH
        DC8 0D9H, 0C0H, 0FDH, 0A3H, 0BAH, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 7CH, 0AH, 7CH, 20H
        DC8 20H, 20H, 20H, 20H, 72H, 20H, 35H, 30H
        DC8 3AH, 32H, 30H, 20H, 0B4H, 0D3H, 30H, 78H
        DC8 35H, 30H, 0B5H, 0D8H, 0D6H, 0B7H, 0B6H, 0C1H
        DC8 30H, 78H, 32H, 30H, 28H, 33H, 32H, 29H
        DC8 0B8H, 0F6H, 0D7H, 0D6H, 0BDH, 0DAH, 0CAH, 0FDH
        DC8 0BEH, 0DDH, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 7CH, 0AH, 7CH
        DC8 20H, 20H, 20H, 20H, 20H, 77H, 20H, 35H
        DC8 30H, 3AH, 30H, 32H, 20H, 0D4H, 0DAH, 30H
        DC8 78H, 35H, 30H, 0B5H, 0D8H, 0D6H, 0B7H, 0B4H
        DC8 0A6H, 0D0H, 0B4H, 0C8H, 0EBH, 30H, 78H, 30H
        DC8 32H, 28H, 32H, 29H, 0B8H, 0F6H, 0D7H, 0D6H
        DC8 0BDH, 0DAH, 0CAH, 0FDH, 0BEH, 0DDH, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 7CH, 0AH
        DC8 7CH, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 0C8H, 0BBH
        DC8 0BAH, 0F3H, 0CAH, 0E4H, 0C8H, 0EBH, 0D2H, 0AAH
        DC8 0D0H, 0B4H, 0C8H, 0EBH, 0B5H, 0C4H, 0CAH, 0FDH
        DC8 0BEH, 0DDH, 0C8H, 0E7H, 0A3H, 0BAH, 35H, 35H
        DC8 20H, 41H, 41H, 28H, 0D2H, 0D4H, 0BFH, 0D5H
        DC8 0B8H, 0F1H, 0B7H, 0D6H, 0B8H, 0F4H, 29H, 7CH
        DC8 0AH, 7CH, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 7CH, 0AH, 7CH, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 0C9H, 0E8H
        DC8 0BCH, 0C6H, 0C8H, 0CBH, 0A3H, 0BAH, 0D4H, 0B1H
        DC8 0BAH, 0E9H, 0C7H, 0BFH, 20H, 20H, 20H, 20H
        DC8 20H, 7CH, 0AH, 7CH, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 0CCH
        DC8 0D4H, 0B1H, 0A6H, 49H, 44H, 3AH, 20H, 53H
        DC8 54H, 4DH, 33H, 32H, 30H, 20H, 20H, 20H
        DC8 20H, 20H, 7CH, 0AH, 7CH, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 51H, 51H, 0BAH, 0C5H, 3AH, 20H, 33H, 37H
        DC8 31H, 33H, 31H, 37H, 38H, 37H, 35H, 20H
        DC8 20H, 20H, 20H, 7CH, 0AH, 7CH, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 20H, 20H, 20H, 20H, 20H, 20H, 20H
        DC8 20H, 0CAH, 0B1H, 0BCH, 0E4H, 0A3H, 0BAH, 32H
        DC8 30H, 30H, 39H, 2EH, 30H, 39H, 2EH, 30H
        DC8 37H, 20H, 20H, 20H, 7CH, 0AH, 2BH, 20H
        DC8 0CBH, 0B5H, 0C3H, 0F7H, 20H, 2DH, 2DH, 2BH
        DC8 20H, 0D3H, 0EFH, 0B7H, 0A8H, 20H, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2BH, 0AH, 7CH
        DC8 20H, 0B6H, 0C1H, 20H, 20H, 20H, 20H, 20H
        DC8 7CH, 20H, 52H, 28H, 72H, 29H, 64H, 64H
        DC8 3AH, 74H, 74H, 20H, 0B5H, 0D8H, 0D6H, 0B7H
        DC8 28H, 30H, 78H, 30H, 30H, 2DH, 2DH, 30H
        DC8 78H, 46H, 46H, 29H, 3AH, 0B3H, 0A4H, 0B6H
        DC8 0C8H, 28H, 30H, 78H, 30H, 31H, 2DH, 2DH
        DC8 30H, 78H, 31H, 30H, 30H, 29H, 7CH, 0AH
        DC8 7CH, 20H, 0D0H, 0B4H, 20H, 20H, 20H, 20H
        DC8 20H, 7CH, 20H, 57H, 28H, 77H, 29H, 64H
        DC8 64H, 3AH, 74H, 74H, 20H, 0B5H, 0D8H, 0D6H
        DC8 0B7H, 28H, 30H, 78H, 30H, 30H, 2DH, 2DH
        DC8 30H, 78H, 46H, 46H, 29H, 3AH, 0B3H, 0A4H
        DC8 0B6H, 0C8H, 28H, 30H, 78H, 30H, 31H, 2DH
        DC8 2DH, 30H, 78H, 31H, 30H, 30H, 29H, 7CH
        DC8 0AH, 2BH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2BH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH, 2DH
        DC8 2BH, 0AH, 0
        DC8 0

        SECTION `.rodata`:CONST:NOROOT(2)
`?<Constant "%x:%x">`:
        DATA
        DC8 "%x:%x"
        DC8 0, 0
        DC8 "\267\307\267\250\265\304\265\330\326\267\272\315\312\375\276\335\270\366\312\375"
        DC8 0, 0, 0
        DC8 "0x%2X "
        DC8 0
        DC8 "%2X "
        DC8 0, 0, 0

        SECTION `.rodata`:CONST:NOROOT(2)
        DATA
        DC8 "%c"
        DC8 0

        SECTION `.rodata`:CONST:NOROOT(1)
        DATA
        DC8 "\012"

        SECTION `.rodata`:CONST:NOROOT(2)
        DATA
        DC8 "%x "
//   49    "\n"
//   50    "+************ ţ 24C02дԳ ************+\n"
//   51    "|     ʵ˶24C02оƬдԡ24C02 |\n"
//   52    "| 256ֽڵĴ洢ռ䣬ҳСΪ8ֽڣ԰ֽڻҳ |\n"
//   53    "| дIAR5.4Keil MDK 3.8ȫͨ   |\n"
//   54    "|     ʹþ                                       |\n"
//   55    "|     r 50:20 0x50ַ0x20(32)ֽ           |\n"
//   56    "|     w 50:02 0x50ַд0x02(2)ֽ        |\n"
//   57    "|             ȻҪд磺55 AA(Կոָ)|\n"
//   58    "|                                                      |\n"
//   59    "|                                   ˣԱǿ     |\n"
//   60    "|                                   ԱID: STM320     |\n"
//   61    "|                                   QQ: 371317875    |\n"
//   62    "|                                   ʱ䣺2009.09.07   |\n"
//   63    "+ ˵ --+ ﷨ ---------------------------------------+\n"
//   64    "|      | R(r)dd:tt ַ(0x00--0xFF):(0x01--0x100)|\n"
//   65    "| д     | W(w)dd:tt ַ(0x00--0xFF):(0x01--0x100)|\n"
//   66    "+--------+---------------------------------------------+\n";
//   67     
//   68 /* Private functions ---------------------------------------------------------*/
//   69 void RCC_Configuration(void);
//   70 void GPIOUTx_Configuration(void);
//   71 void USARTx_configuration(void);
//   72 TestStatus Buffercmp(uint8_t* pBuffer1, uint8_t* pBuffer2, uint16_t BufferLength);
//   73 void read_eeprom (char * buffer);
//   74 void write_eeprom (char * buffer);
//   75 
//   76 /**
//   77   * @brief  Main program
//   78   * @param  None
//   79   * @retval : None
//   80   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   81 int main(void)
//   82 {
main:
        PUSH     {R0-R6,LR}
//   83   char cmdbuf [15];                            /* command input buffer        */
//   84 
//   85   int i;                                       /* index for command buffer    */
//   86 
//   87   /* System clocks configuration ---------------------------------------------*/
//   88   RCC_Configuration();
        BL       RCC_Configuration
//   89 
//   90   /* GPIOUTx configuration ------------------------------------------------------*/
//   91   GPIOUTx_Configuration();
        BL       GPIOUTx_Configuration
//   92 
//   93   /* USARTx configuration ----------------------------------------------------*/
//   94   USARTx_configuration();
        BL       USARTx_configuration
//   95 
//   96   /* Initialize the I2C EEPROM driver ----------------------------------------*/
//   97   I2C_EE_Init();  
        BL       I2C_EE_Init
//   98 
//   99   printf ( menu );                             /* display command menu        */
        LDR.N    R4,??main_0      ;; `?<Constant "\\n\\303\\374\\301\\356: ">`
        ADD      R0,R4,#+20
        BL       printf
        ADD      R5,SP,#+0
        B.N      ??main_1
//  100   while (1)
//  101   {	     
//  102     printf ("\n: ");
//  103     getline (&cmdbuf[0], sizeof (cmdbuf));     /* input command line          */
//  104 
//  105     for (i = 0; cmdbuf[i] != 0; i++)  {        /* convert to upper characters */
//  106       cmdbuf[i] = toupper(cmdbuf[i]);
//  107     }
//  108 
//  109     for (i = 0; cmdbuf[i] == ' '; i++);        /* skip blanks                 */
//  110 	switch (cmdbuf[i])  {                      /* proceed to command function */
//  111 
//  112       case 'R':                                /* Read circular Buffer        */
//  113 	    read_eeprom(&cmdbuf[i+1]);
??main_2:
        ADDS     R0,R0,#+1
        BL       read_eeprom
??main_1:
        MOV      R0,R4
        BL       printf
        MOVS     R1,#+15
        ADD      R0,SP,#+0
        BL       getline
        MOVS     R6,#+0
        B.N      ??main_3
??main_4:
        BL       toupper
        STRB     R0,[R6, R5]
        ADDS     R6,R6,#+1
??main_3:
        LDRB     R0,[R6, R5]
        CMP      R0,#+0
        BNE.N    ??main_4
        B.N      ??main_5
??main_6:
        ADDS     R0,R0,#+1
??main_5:
        LDRB     R1,[R0, R5]
        CMP      R1,#+32
        BEQ.N    ??main_6
        ADD      R2,SP,#+0
        ADDS     R0,R0,R2
        CMP      R1,#+82
        BEQ.N    ??main_2
        CMP      R1,#+87
        BNE.N    ??main_7
//  114         break;
//  115 
//  116       case 'W':                                /* Write circular Buffer       */
//  117 		write_eeprom(&cmdbuf[i+1]);
        ADDS     R0,R0,#+1
        BL       write_eeprom
        B.N      ??main_1
//  118         break;
//  119 
//  120       default:                                 /* Error Handling              */
//  121         printf (ERROR_STR, "δ֪");
??main_7:
        ADD      R1,R4,#+8
        LDR.N    R0,??DataTable2  ;; Tx1_Buffer + 256
        BL       printf
//  122         printf (menu);                         /* display command menu        */
        ADD      R0,R4,#+20
        BL       printf
        B.N      ??main_1
        DATA
??main_0:
        DC32     `?<Constant "\\n\\303\\374\\301\\356: ">`
//  123         break;
//  124     }
//  125   }
//  126 }
//  127 
//  128 /**
//  129   * @brief  Configures the different system clocks.
//  130   * @param  None
//  131   * @retval : None
//  132   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  133 void RCC_Configuration(void)
//  134 {
RCC_Configuration:
        PUSH     {R7,LR}
//  135   /* Setup the microcontroller system. Initialize the Embedded Flash Interface,  
//  136      initialize the PLL and update the SystemFrequency variable. */
//  137   SystemInit();
        BL       SystemInit
//  138 
//  139 /* Enable peripheral clocks --------------------------------------------------*/
//  140   /* GPIOB Periph clock enable */
//  141   RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
        MOVS     R1,#+1
        MOVS     R0,#+8
        BL       RCC_APB2PeriphClockCmd
//  142   /* I2C1 Periph clock enable */
//  143   RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,#+2097152
        BL       RCC_APB1PeriphClockCmd
//  144 
//  145   /* Enable GPIOx clock */
//  146   RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOx, ENABLE);
        MOVS     R1,#+1
        MOVS     R0,#+4
        BL       RCC_APB2PeriphClockCmd
//  147 
//  148 /* Enable USARTx clocks */
//  149 #ifdef USE_USART1  
//  150   RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,#+16384
        POP      {R2,LR}
        B.W      RCC_APB2PeriphClockCmd
//  151 #else
//  152   RCC_APB1PeriphClockCmd(RCC_APB1Periph_USARTx, ENABLE);
//  153 #endif
//  154 }
//  155 
//  156 /**
//  157   * @brief  Configures the different GPIOUTx ports.
//  158   * @param  None
//  159   * @retval : None
//  160   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  161 void GPIOUTx_Configuration(void)
//  162 {
GPIOUTx_Configuration:
        PUSH     {R4,LR}
        SUB      SP,SP,#+8
//  163   GPIO_InitTypeDef GPIO_InitStructure;
//  164 
//  165 #if defined USE_USART2	&& defined USE_STM3210B_EVAL
//  166   /* Enable AFIO clock */
//  167   RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
//  168 
//  169   /* Enable the USART2 Pins Software Remapping */
//  170   GPIO_PinRemapConfig(GPIO_Remap_USART2, ENABLE);
//  171 #endif
//  172 
//  173   /* Configure USARTx_Tx as alternate function push-pull */
//  174   GPIO_InitStructure.GPIO_Pin = GPIO_TxPin;
        MOV      R0,#+512
        STRH     R0,[SP, #+0]
//  175   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        MOVS     R0,#+3
        STRB     R0,[SP, #+2]
//  176   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
        MOVS     R0,#+24
        STRB     R0,[SP, #+3]
//  177   GPIO_Init(GPIOx, &GPIO_InitStructure);
        LDR.N    R4,??GPIOUTx_Configuration_0  ;; 0x40010800
        ADD      R1,SP,#+0
        MOV      R0,R4
        BL       GPIO_Init
//  178 
//  179   /* Configure USARTx_Rx as input floating */
//  180   GPIO_InitStructure.GPIO_Pin = GPIO_RxPin;
        MOV      R0,#+1024
        STRH     R0,[SP, #+0]
//  181   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
        MOVS     R0,#+4
        STRB     R0,[SP, #+3]
//  182   GPIO_Init(GPIOx, &GPIO_InitStructure);
        ADD      R1,SP,#+0
        MOV      R0,R4
        BL       GPIO_Init
//  183 }
        POP      {R0,R1,R4,PC}    ;; return
        Nop      
        DATA
??GPIOUTx_Configuration_0:
        DC32     0x40010800
//  184 
//  185 /**
//  186   * @brief  Configures the USARTx.
//  187   * @param  None
//  188   * @retval : None
//  189   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  190 void USARTx_configuration(void)
//  191 {
USARTx_configuration:
        PUSH     {R4,LR}
//  192 /* USARTx configuration ------------------------------------------------------*/
//  193   /* USARTx configured as follow:
//  194         - BaudRate = 115200 baud  
//  195         - Word Length = 8 Bits
//  196         - One Stop Bit
//  197         - No parity
//  198         - Hardware flow control disabled (RTS and CTS signals)
//  199         - Receive and transmit enabled
//  200   */
//  201   USART_InitStructure.USART_BaudRate = 115200;
        LDR.N    R1,??USARTx_configuration_0  ;; USART_InitStructure
        MOV      R0,#+115200
        STR      R0,[R1, #+0]
//  202   USART_InitStructure.USART_WordLength = USART_WordLength_8b;
        MOVS     R0,#+0
        STR      R0,[R1, #+4]
//  203   USART_InitStructure.USART_StopBits = USART_StopBits_1;
//  204   USART_InitStructure.USART_Parity = USART_Parity_No ;
        STRH     R0,[R1, #+8]
//  205   USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
        STRH     R0,[R1, #+12]
//  206   USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
        MOVS     R0,#+12
        STRH     R0,[R1, #+10]
//  207   
//  208   /* Configure the USARTx */ 
//  209   USART_Init(USARTx, &USART_InitStructure);
        LDR.N    R4,??USARTx_configuration_0+0x4  ;; 0x40013800
        MOV      R0,R4
        BL       USART_Init
//  210   /* Enable the USARTx */
//  211   USART_Cmd(USARTx, ENABLE);
        MOVS     R1,#+1
        MOV      R0,R4
        POP      {R4,LR}
        B.W      USART_Cmd
        Nop      
        DATA
??USARTx_configuration_0:
        DC32     USART_InitStructure
        DC32     0x40013800
//  212 }
//  213 
//  214 /**
//  215   * @brief  Compares two buffers.
//  216   * @param pBuffer1, pBuffer2: buffers to be compared.
//  217   * @param BufferLength: buffer's length
//  218   * @retval : PASSED: pBuffer1 identical to pBuffer2
//  219   *   FAILED: pBuffer1 differs from pBuffer2
//  220   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  221 TestStatus Buffercmp(uint8_t* pBuffer1, uint8_t* pBuffer2, uint16_t BufferLength)
//  222 {
Buffercmp:
        PUSH     {R4,LR}
//  223   while(BufferLength--)
??Buffercmp_0:
        MOV      R3,R2
        SUBS     R2,R3,#+1
        UXTH     R3,R3
        CMP      R3,#+0
        BEQ.N    ??Buffercmp_1
//  224   {
//  225     if(*pBuffer1 != *pBuffer2)
        LDRB     R3,[R0], #+1
        LDRB     R4,[R1], #+1
        CMP      R3,R4
        BEQ.N    ??Buffercmp_0
//  226     {
//  227       return FAILED;
        MOVS     R0,#+0
        POP      {R4,PC}
//  228     }
//  229     
//  230     pBuffer1++;
//  231     pBuffer2++;
//  232   }
//  233 
//  234   return PASSED;  
??Buffercmp_1:
        MOVS     R0,#+1
        POP      {R4,PC}          ;; return
//  235 }
//  236 
//  237 /*------------------------------------------------------------------------------
//  238   Read EEPROM
//  239 *------------------------------------------------------------------------------*/

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  240 void read_eeprom (char * buffer)
//  241 {
read_eeprom:
        PUSH     {R2-R10,LR}
//  242   int adr, num;                          /* temporary time values             */
//  243   int args;                              /* number of arguments               */
//  244   int i, j;
//  245 
//  246   args = sscanf (buffer, "%x:%x",        /* scan input line for               */
//  247                  &adr,                   /* adr, num                          */
//  248                  &num);
        LDR.W    R8,??DataTable3  ;; `?<Constant "%x:%x">`
        ADD      R3,SP,#+0
        ADD      R2,SP,#+4
        MOV      R1,R8
        BL       sscanf
//  249   if (adr > 255  ||  num > 256 ||        /* check for valid inputs            */
//  250       args < 1   ||  args == EOF)  {
        LDR      R1,[SP, #+4]
        CMP      R1,#+255
        BGT.N    ??read_eeprom_0
        LDR      R1,[SP, #+0]
        CMP      R1,#+256
        BGT.N    ??read_eeprom_0
        CMP      R0,#+1
        BGE.N    ??read_eeprom_1
//  251     printf (ERROR_STR, "Ƿĵַݸ");
??read_eeprom_0:
        ADD      R1,R8,#+8
        LDR.N    R0,??DataTable2  ;; Tx1_Buffer + 256
        BL       printf
        B.N      ??read_eeprom_2
//  252   }
//  253   else  {                                /* if inputs valid then              */
//  254  	/* Read from I2C EEPROM from EEPROM_ReadAddress1 */
//  255     I2C_EE_BufferRead(Rx1_Buffer, adr, num);
??read_eeprom_1:
        LDR.N    R5,??read_eeprom_3+0x8  ;; Rx1_Buffer
        UXTH     R2,R1
        LDR      R1,[SP, #+4]
        UXTB     R1,R1
        MOV      R0,R5
        BL       I2C_EE_BufferRead
//  256 	for(i=0; i<(num/16); i++)
        MOVS     R6,#+0
        ADR.W    R10,??read_eeprom_3  ;; "\n"
        ADR.W    R9,??read_eeprom_3+0x4  ;; 0x25, 0x63, 0x00, 0x00
        B.N      ??read_eeprom_4
//  257 	{
//  258 	    printf("0x%2X ",adr+i*16);
??read_eeprom_5:
        LSLS     R4,R6,#+4
        LDR      R0,[SP, #+4]
        ADDS     R1,R4,R0
        ADD      R0,R8,#+32
        BL       printf
//  259 		for(j=0; j<16; j++)  
        MOVS     R7,#+0
//  260 		  printf("%2X ",Rx1_Buffer[i*16+j]);
??read_eeprom_6:
        ADDS     R0,R7,R4
        LDRB     R1,[R0, R5]
        ADD      R0,R8,#+40
        BL       printf
        ADDS     R7,R7,#+1
        CMP      R7,#+16
        BLT.N    ??read_eeprom_6
//  261 		for(j=0; j<16; j++)
        MOVS     R7,#+0
//  262 		  printf("%c",Rx1_Buffer[i*16+j]);
??read_eeprom_7:
        ADDS     R0,R7,R4
        LDRB     R1,[R0, R5]
        MOV      R0,R9
        BL       printf
        ADDS     R7,R7,#+1
        CMP      R7,#+16
        BLT.N    ??read_eeprom_7
//  263 	    printf("\n");
        MOV      R0,R10
        BL       printf
//  264 	}
        ADDS     R6,R6,#+1
??read_eeprom_4:
        LDR      R0,[SP, #+0]
        ASRS     R0,R0,#+3
        LDR      R1,[SP, #+0]
        ADD      R0,R1,R0, LSR #+28
        CMP      R6,R0, ASR #+4
        BLT.N    ??read_eeprom_5
//  265   }
//  266 }
??read_eeprom_2:
        POP      {R0,R1,R4-R10,PC}  ;; return
        Nop      
        DATA
??read_eeprom_3:
        DC8      "\n",0x0,0x0
        DC8      0x25, 0x63, 0x00, 0x00
        DC32     Rx1_Buffer

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable2:
        DC32     Tx1_Buffer + 256
//  267 /*------------------------------------------------------------------------------
//  268   Write EEPROM
//  269 *------------------------------------------------------------------------------*/

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  270 void write_eeprom (char * buffer)
//  271 {
write_eeprom:
        PUSH     {R4-R6,LR}
        SUB      SP,SP,#+272
//  272   int adr, num;                          /* temporary time values             */
//  273   int args;                              /* number of arguments               */
//  274   int i;
//  275   char buf[256];
//  276   int tmp;
//  277 
//  278   args = sscanf (buffer, "%x:%x",        /* scan input line for               */
//  279                  &adr,                   /* adr, num                          */
//  280                  &num);
        LDR.N    R4,??DataTable3  ;; `?<Constant "%x:%x">`
        ADD      R3,SP,#+0
        ADD      R2,SP,#+4
        MOV      R1,R4
        BL       sscanf
//  281   if (adr > 255  ||  num > 256 ||        /* check for valid inputs            */
//  282       args < 1   ||  args == EOF)  {
        LDR.N    R5,??write_eeprom_0+0x4  ;; Tx1_Buffer
        LDR      R1,[SP, #+4]
        CMP      R1,#+255
        BGT.N    ??write_eeprom_1
        LDR      R1,[SP, #+0]
        CMP      R1,#+256
        BGT.N    ??write_eeprom_1
        CMP      R0,#+1
        BGE.N    ??write_eeprom_2
//  283     printf (ERROR_STR, "Ƿĵַݸ");
??write_eeprom_1:
        ADD      R1,R4,#+8
        ADDW     R0,R5,#+256
        BL       printf
        B.N      ??write_eeprom_3
//  284   }
//  285   else  {                                /* if inputs valid then              */
//  286     getline (&buf[0], sizeof (buf));     /* input command line          */
??write_eeprom_2:
        MOV      R1,#+256
        ADD      R0,SP,#+12
        BL       getline
//  287 
//  288     for (i = 0; buf[i] != 0; i++)  {     /* convert to upper characters */
        MOVS     R4,#+0
        ADD      R6,SP,#+12
        B.N      ??write_eeprom_4
//  289       buf[i] = toupper(buf[i]);
??write_eeprom_5:
        BL       toupper
        STRB     R0,[R4, R6]
//  290     }
        ADDS     R4,R4,#+1
??write_eeprom_4:
        LDRB     R0,[R4, R6]
        CMP      R0,#+0
        BNE.N    ??write_eeprom_5
//  291 
//  292     for (i = 0; buf[i] == ' '; i++);     /* skip blanks                 */
        B.N      ??write_eeprom_6
??write_eeprom_7:
        ADDS     R0,R0,#+1
??write_eeprom_6:
        LDRB     R1,[R0, R6]
        CMP      R1,#+32
        BEQ.N    ??write_eeprom_7
//  293 
//  294 	for(i=0; i<num; i++)
        MOVS     R6,#+0
        ADR.N    R4,??write_eeprom_0  ;; "%x "
        B.N      ??write_eeprom_8
//  295 	{
//  296       args = sscanf (&buf[i*3], "%x ",
//  297                      &tmp);
??write_eeprom_9:
        ADD      R2,SP,#+8
        MOV      R1,R4
        ADD      R0,R6,R6, LSL #+1
        ADD      R3,SP,#+12
        ADDS     R0,R0,R3
        BL       sscanf
//  298 	  Tx1_Buffer[i] = tmp;
        LDR      R0,[SP, #+8]
        STRB     R0,[R6, R5]
//  299 	}
        ADDS     R6,R6,#+1
??write_eeprom_8:
        LDR      R0,[SP, #+0]
        CMP      R6,R0
        BLT.N    ??write_eeprom_9
//  300  
//  301     /* Write on I2C EEPROM from EEPROM_WriteAddress1 */
//  302     I2C_EE_BufferWrite(Tx1_Buffer, adr, num); 
        UXTH     R2,R0
        LDR      R1,[SP, #+4]
        UXTB     R1,R1
        MOV      R0,R5
        BL       I2C_EE_BufferWrite
//  303   }
//  304 }
??write_eeprom_3:
        ADD      SP,SP,#+272
        POP      {R4-R6,PC}       ;; return
        DATA
??write_eeprom_0:
        DC8      "%x "
        DC32     Tx1_Buffer

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable3:
        DC32     `?<Constant "%x:%x">`

        END
//  305 
//  306 #ifdef  USE_FULL_ASSERT
//  307 
//  308 /**
//  309   * @brief  Reports the name of the source file and the source line number
//  310   *   where the assert_param error has occurred.
//  311   * @param file: pointer to the source file name
//  312   * @param line: assert_param error line source number
//  313   * @retval : None
//  314   */
//  315 void assert_failed(uint8_t* file, uint32_t line)
//  316 { 
//  317   /* User can add his own implementation to report the file name and line number,
//  318      ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
//  319 
//  320   /* Infinite loop */
//  321   while (1)
//  322   {
//  323   }
//  324 }
//  325 #endif
//  326 
//  327 /**
//  328   * @}
//  329   */ 
//  330 
//  331 /**
//  332   * @}
//  333   */ 
//  334 
//  335 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
//   273 bytes in section .bss
//   272 bytes in section .data
// 1 050 bytes in section .rodata
//   642 bytes in section .text
// 
//   642 bytes of CODE  memory
// 1 050 bytes of CONST memory
//   545 bytes of DATA  memory
//
//Errors: none
//Warnings: none
