///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:51 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_i2c.c                                             /
//    Command line =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_i2c.c -D USE_STDPERIPH_DRIVER -D STM32F10X_HD -D  /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\s /
//                    tm32f10x_i2c.s                                          /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME stm32f10x_i2c

        EXTERN RCC_APB1PeriphResetCmd
        EXTERN RCC_GetClocksFreq

        PUBLIC I2C_ARPCmd
        PUBLIC I2C_AcknowledgeConfig
        PUBLIC I2C_CalculatePEC
        PUBLIC I2C_CheckEvent
        PUBLIC I2C_ClearFlag
        PUBLIC I2C_ClearITPendingBit
        PUBLIC I2C_Cmd
        PUBLIC I2C_DMACmd
        PUBLIC I2C_DMALastTransferCmd
        PUBLIC I2C_DeInit
        PUBLIC I2C_DualAddressCmd
        PUBLIC I2C_FastModeDutyCycleConfig
        PUBLIC I2C_GeneralCallCmd
        PUBLIC I2C_GenerateSTART
        PUBLIC I2C_GenerateSTOP
        PUBLIC I2C_GetFlagStatus
        PUBLIC I2C_GetITStatus
        PUBLIC I2C_GetLastEvent
        PUBLIC I2C_GetPEC
        PUBLIC I2C_ITConfig
        PUBLIC I2C_Init
        PUBLIC I2C_OwnAddress2Config
        PUBLIC I2C_PECPositionConfig
        PUBLIC I2C_ReadRegister
        PUBLIC I2C_ReceiveData
        PUBLIC I2C_SMBusAlertConfig
        PUBLIC I2C_Send7bitAddress
        PUBLIC I2C_SendData
        PUBLIC I2C_SoftwareResetCmd
        PUBLIC I2C_StretchClockCmd
        PUBLIC I2C_StructInit
        PUBLIC I2C_TransmitPEC

// C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm32f10x_i2c.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file  stm32f10x_i2c.c
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  This file provides all the I2C firmware functions.
//    8   ******************************************************************************
//    9   * @copy
//   10   *
//   11   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   12   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   13   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   14   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   15   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   16   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   17   *
//   18   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   19   */ 
//   20 
//   21 /* Includes ------------------------------------------------------------------*/
//   22 #include "stm32f10x_i2c.h"
//   23 #include "stm32f10x_rcc.h"
//   24 
//   25 
//   26 /** @addtogroup StdPeriph_Driver
//   27   * @{
//   28   */
//   29 
//   30 /** @defgroup I2C 
//   31   * @brief I2C driver modules
//   32   * @{
//   33   */ 
//   34 
//   35 /** @defgroup I2C_Private_TypesDefinitions
//   36   * @{
//   37   */
//   38 
//   39 /**
//   40   * @}
//   41   */
//   42 
//   43 /** @defgroup I2C_Private_Defines
//   44   * @{
//   45   */
//   46 
//   47 /* I2C SPE mask */
//   48 #define CR1_PE_Set              ((uint16_t)0x0001)
//   49 #define CR1_PE_Reset            ((uint16_t)0xFFFE)
//   50 
//   51 /* I2C START mask */
//   52 #define CR1_START_Set           ((uint16_t)0x0100)
//   53 #define CR1_START_Reset         ((uint16_t)0xFEFF)
//   54 
//   55 /* I2C STOP mask */
//   56 #define CR1_STOP_Set            ((uint16_t)0x0200)
//   57 #define CR1_STOP_Reset          ((uint16_t)0xFDFF)
//   58 
//   59 /* I2C ACK mask */
//   60 #define CR1_ACK_Set             ((uint16_t)0x0400)
//   61 #define CR1_ACK_Reset           ((uint16_t)0xFBFF)
//   62 
//   63 /* I2C ENGC mask */
//   64 #define CR1_ENGC_Set            ((uint16_t)0x0040)
//   65 #define CR1_ENGC_Reset          ((uint16_t)0xFFBF)
//   66 
//   67 /* I2C SWRST mask */
//   68 #define CR1_SWRST_Set           ((uint16_t)0x8000)
//   69 #define CR1_SWRST_Reset         ((uint16_t)0x7FFF)
//   70 
//   71 /* I2C PEC mask */
//   72 #define CR1_PEC_Set             ((uint16_t)0x1000)
//   73 #define CR1_PEC_Reset           ((uint16_t)0xEFFF)
//   74 
//   75 /* I2C ENPEC mask */
//   76 #define CR1_ENPEC_Set           ((uint16_t)0x0020)
//   77 #define CR1_ENPEC_Reset         ((uint16_t)0xFFDF)
//   78 
//   79 /* I2C ENARP mask */
//   80 #define CR1_ENARP_Set           ((uint16_t)0x0010)
//   81 #define CR1_ENARP_Reset         ((uint16_t)0xFFEF)
//   82 
//   83 /* I2C NOSTRETCH mask */
//   84 #define CR1_NOSTRETCH_Set       ((uint16_t)0x0080)
//   85 #define CR1_NOSTRETCH_Reset     ((uint16_t)0xFF7F)
//   86 
//   87 /* I2C registers Masks */
//   88 #define CR1_CLEAR_Mask          ((uint16_t)0xFBF5)
//   89 
//   90 /* I2C DMAEN mask */
//   91 #define CR2_DMAEN_Set           ((uint16_t)0x0800)
//   92 #define CR2_DMAEN_Reset         ((uint16_t)0xF7FF)
//   93 
//   94 /* I2C LAST mask */
//   95 #define CR2_LAST_Set            ((uint16_t)0x1000)
//   96 #define CR2_LAST_Reset          ((uint16_t)0xEFFF)
//   97 
//   98 /* I2C FREQ mask */
//   99 #define CR2_FREQ_Reset          ((uint16_t)0xFFC0)
//  100 
//  101 /* I2C ADD0 mask */
//  102 #define OAR1_ADD0_Set           ((uint16_t)0x0001)
//  103 #define OAR1_ADD0_Reset         ((uint16_t)0xFFFE)
//  104 
//  105 /* I2C ENDUAL mask */
//  106 #define OAR2_ENDUAL_Set         ((uint16_t)0x0001)
//  107 #define OAR2_ENDUAL_Reset       ((uint16_t)0xFFFE)
//  108 
//  109 /* I2C ADD2 mask */
//  110 #define OAR2_ADD2_Reset         ((uint16_t)0xFF01)
//  111 
//  112 /* I2C F/S mask */
//  113 #define CCR_FS_Set              ((uint16_t)0x8000)
//  114 
//  115 /* I2C CCR mask */
//  116 #define CCR_CCR_Set             ((uint16_t)0x0FFF)
//  117 
//  118 /* I2C FLAG mask */
//  119 #define FLAG_Mask               ((uint32_t)0x00FFFFFF)
//  120 
//  121 /* I2C Interrupt Enable mask */
//  122 #define ITEN_Mask               ((uint32_t)0x07000000)
//  123 
//  124 /**
//  125   * @}
//  126   */
//  127 
//  128 /** @defgroup I2C_Private_Macros
//  129   * @{
//  130   */
//  131 
//  132 /**
//  133   * @}
//  134   */
//  135 
//  136 /** @defgroup I2C_Private_Variables
//  137   * @{
//  138   */
//  139 
//  140 /**
//  141   * @}
//  142   */
//  143 
//  144 /** @defgroup I2C_Private_FunctionPrototypes
//  145   * @{
//  146   */
//  147 
//  148 /**
//  149   * @}
//  150   */
//  151 
//  152 /** @defgroup I2C_Private_Functions
//  153   * @{
//  154   */
//  155 
//  156 /**
//  157   * @brief  Deinitializes the I2Cx peripheral registers to their default
//  158   *   reset values.
//  159   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  160   * @retval : None
//  161   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  162 void I2C_DeInit(I2C_TypeDef* I2Cx)
//  163 {
I2C_DeInit:
        PUSH     {R7,LR}
//  164   /* Check the parameters */
//  165   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  166   switch (*(uint32_t*)&I2Cx)
        LDR.N    R1,??I2C_DeInit_0  ;; 0x40005400
        SUBS     R0,R0,R1
        BEQ.N    ??I2C_DeInit_1
        MOV      R1,#+1024
        SUBS     R0,R0,R1
        BEQ.N    ??I2C_DeInit_2
        POP      {R0,PC}
//  167   {
//  168     case I2C1_BASE:
//  169       /* Enable I2C1 reset state */
//  170       RCC_APB1PeriphResetCmd(RCC_APB1Periph_I2C1, ENABLE);
??I2C_DeInit_1:
        MOVS     R1,#+1
        MOV      R0,#+2097152
        BL       RCC_APB1PeriphResetCmd
//  171       /* Release I2C1 from reset state */
//  172       RCC_APB1PeriphResetCmd(RCC_APB1Periph_I2C1, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+2097152
        B.N      ??I2C_DeInit_3
//  173       break;
//  174     case I2C2_BASE:
//  175       /* Enable I2C2 reset state */
//  176       RCC_APB1PeriphResetCmd(RCC_APB1Periph_I2C2, ENABLE);
??I2C_DeInit_2:
        MOVS     R1,#+1
        MOV      R0,#+4194304
        BL       RCC_APB1PeriphResetCmd
//  177       /* Release I2C2 from reset state */
//  178       RCC_APB1PeriphResetCmd(RCC_APB1Periph_I2C2, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+4194304
??I2C_DeInit_3:
        POP      {R2,LR}
        B.W      RCC_APB1PeriphResetCmd
        DATA
??I2C_DeInit_0:
        DC32     0x40005400
//  179       break;
//  180     default:
//  181       break;
//  182   }
//  183 }
//  184 
//  185 /**
//  186   * @brief  Initializes the I2Cx peripheral according to the specified 
//  187   *   parameters in the I2C_InitStruct.
//  188   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  189   * @param I2C_InitStruct: pointer to a I2C_InitTypeDef structure that
//  190   *   contains the configuration information for the specified
//  191   *   I2C peripheral.
//  192   * @retval : None
//  193   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  194 void I2C_Init(I2C_TypeDef* I2Cx, I2C_InitTypeDef* I2C_InitStruct)
//  195 {
I2C_Init:
        PUSH     {R4-R6,LR}
        SUB      SP,SP,#+24
        MOV      R5,R0
        MOV      R4,R1
//  196   uint16_t tmpreg = 0, freqrange = 0;
//  197   uint16_t result = 0x04;
//  198   uint32_t pclk1 = 8000000;
//  199   RCC_ClocksTypeDef  rcc_clocks;
//  200   /* Check the parameters */
//  201   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  202   assert_param(IS_I2C_MODE(I2C_InitStruct->I2C_Mode));
//  203   assert_param(IS_I2C_DUTY_CYCLE(I2C_InitStruct->I2C_DutyCycle));
//  204   assert_param(IS_I2C_OWN_ADDRESS1(I2C_InitStruct->I2C_OwnAddress1));
//  205   assert_param(IS_I2C_ACK_STATE(I2C_InitStruct->I2C_Ack));
//  206   assert_param(IS_I2C_ACKNOWLEDGE_ADDRESS(I2C_InitStruct->I2C_AcknowledgedAddress));
//  207   assert_param(IS_I2C_CLOCK_SPEED(I2C_InitStruct->I2C_ClockSpeed));
//  208 /*---------------------------- I2Cx CR2 Configuration ------------------------*/
//  209   /* Get the I2Cx CR2 value */
//  210   tmpreg = I2Cx->CR2;
        LDRH     R6,[R5, #+4]
//  211   /* Clear frequency FREQ[5:0] bits */
//  212   tmpreg &= CR2_FREQ_Reset;
//  213   /* Get pclk1 frequency value */
//  214   RCC_GetClocksFreq(&rcc_clocks);
        ADD      R0,SP,#+0
        BL       RCC_GetClocksFreq
//  215   pclk1 = rcc_clocks.PCLK1_Frequency;
        LDR      R1,[SP, #+8]
//  216   /* Set frequency bits depending on pclk1 value */
//  217   freqrange = (uint16_t)(pclk1 / 1000000);
        LDR.N    R0,??I2C_Init_0  ;; 0xf4240
        UDIV     R0,R1,R0
        UXTH     R0,R0
//  218   tmpreg |= freqrange;
//  219   /* Write to I2Cx CR2 */
//  220   I2Cx->CR2 = tmpreg;
        MOVW     R2,#+65472
        ANDS     R2,R2,R6
        ORRS     R2,R0,R2
        STRH     R2,[R5, #+4]
//  221 /*---------------------------- I2Cx CCR Configuration ------------------------*/
//  222   /* Disable the selected I2C peripheral to configure TRISE */
//  223   I2Cx->CR1 &= CR1_PE_Reset;
        LDRH     R2,[R5, #+0]
        MOVW     R3,#+65534
        ANDS     R2,R3,R2
        STRH     R2,[R5, #+0]
//  224   /* Reset tmpreg value */
//  225   /* Clear F/S, DUTY and CCR[11:0] bits */
//  226   tmpreg = 0;
//  227   /* Configure speed in standard mode */
//  228   if (I2C_InitStruct->I2C_ClockSpeed <= 100000)
        LDR      R2,[R4, #+12]
        LDR.N    R3,??I2C_Init_0+0x4  ;; 0x186a1
        CMP      R2,R3
        BCS.N    ??I2C_Init_1
//  229   {
//  230     /* Standard mode speed calculate */
//  231     result = (uint16_t)(pclk1 / (I2C_InitStruct->I2C_ClockSpeed << 1));
        LSLS     R2,R2,#+1
        UDIV     R1,R1,R2
//  232     /* Test if CCR value is under 0x4*/
//  233     if (result < 0x04)
        UXTH     R1,R1
        CMP      R1,#+4
        BCS.N    ??I2C_Init_2
//  234     {
//  235       /* Set minimum allowed value */
//  236       result = 0x04;  
        MOVS     R1,#+4
//  237     }
//  238     /* Set speed value for standard mode */
//  239     tmpreg |= result;	  
//  240     /* Set Maximum Rise Time for standard mode */
//  241     I2Cx->TRISE = freqrange + 1; 
        B.N      ??I2C_Init_2
//  242   }
//  243   /* Configure speed in fast mode */
//  244   else /*(I2C_InitStruct->I2C_ClockSpeed <= 400000)*/
//  245   {
//  246     if (I2C_InitStruct->I2C_DutyCycle == I2C_DutyCycle_2)
??I2C_Init_1:
        LDRH     R3,[R4, #+2]
        MOVW     R6,#+49151
        CMP      R3,R6
        BNE.N    ??I2C_Init_3
//  247     {
//  248       /* Fast mode speed calculate: Tlow/Thigh = 2 */
//  249       result = (uint16_t)(pclk1 / (I2C_InitStruct->I2C_ClockSpeed * 3));
        ADD      R2,R2,R2, LSL #+1
        UDIV     R1,R1,R2
        B.N      ??I2C_Init_4
//  250     }
//  251     else /*I2C_InitStruct->I2C_DutyCycle == I2C_DutyCycle_16_9*/
//  252     {
//  253       /* Fast mode speed calculate: Tlow/Thigh = 16/9 */
//  254       result = (uint16_t)(pclk1 / (I2C_InitStruct->I2C_ClockSpeed * 25));
//  255       /* Set DUTY bit */
//  256       result |= I2C_DutyCycle_16_9;
??I2C_Init_3:
        MOVS     R3,#+25
        MULS     R2,R3,R2
        UDIV     R1,R1,R2
        ORR      R1,R1,#0x4000
//  257     }
//  258     /* Test if CCR value is under 0x1*/
//  259     if ((result & CCR_CCR_Set) == 0)
??I2C_Init_4:
        LSLS     R2,R1,#+20
        BNE.N    ??I2C_Init_5
//  260     {
//  261       /* Set minimum allowed value */
//  262       result |= (uint16_t)0x0001;  
        ORR      R1,R1,#0x1
//  263     }
//  264     /* Set speed value and set F/S bit for fast mode */
//  265     tmpreg |= result | CCR_FS_Set;
??I2C_Init_5:
        ORR      R1,R1,#0x8000
//  266     /* Set Maximum Rise Time for fast mode */
//  267     I2Cx->TRISE = (uint16_t)(((freqrange * 300) / 1000) + 1);  
        MOV      R2,#+300
        MULS     R0,R2,R0
        MOV      R2,#+1000
        SDIV     R0,R0,R2
??I2C_Init_2:
        ADDS     R0,R0,#+1
        STRH     R0,[R5, #+32]
//  268   }
//  269   /* Write to I2Cx CCR */
//  270   I2Cx->CCR = tmpreg;
        STRH     R1,[R5, #+28]
//  271   /* Enable the selected I2C peripheral */
//  272   I2Cx->CR1 |= CR1_PE_Set;
        LDRH     R0,[R5, #+0]
        ORR      R0,R0,#0x1
        STRH     R0,[R5, #+0]
//  273 /*---------------------------- I2Cx CR1 Configuration ------------------------*/
//  274   /* Get the I2Cx CR1 value */
//  275   tmpreg = I2Cx->CR1;
//  276   /* Clear ACK, SMBTYPE and  SMBUS bits */
//  277   tmpreg &= CR1_CLEAR_Mask;
//  278   /* Configure I2Cx: mode and acknowledgement */
//  279   /* Set SMBTYPE and SMBUS bits according to I2C_Mode value */
//  280   /* Set ACK bit according to I2C_Ack value */
//  281   tmpreg |= (uint16_t)((uint32_t)I2C_InitStruct->I2C_Mode | I2C_InitStruct->I2C_Ack);
//  282   /* Write to I2Cx CR1 */
//  283   I2Cx->CR1 = tmpreg;
        LDRH     R0,[R5, #+0]
        MOVW     R1,#+64501
        ANDS     R0,R1,R0
        LDRH     R1,[R4, #+0]
        ORRS     R0,R1,R0
        LDRH     R1,[R4, #+6]
        ORRS     R0,R1,R0
        STRH     R0,[R5, #+0]
//  284 /*---------------------------- I2Cx OAR1 Configuration -----------------------*/
//  285   /* Set I2Cx Own Address1 and acknowledged address */
//  286   I2Cx->OAR1 = (I2C_InitStruct->I2C_AcknowledgedAddress | I2C_InitStruct->I2C_OwnAddress1);
        LDRH     R0,[R4, #+8]
        LDRH     R1,[R4, #+4]
        ORRS     R0,R1,R0
        STRH     R0,[R5, #+8]
//  287 }
        ADD      SP,SP,#+24
        POP      {R4-R6,PC}       ;; return
        DATA
??I2C_Init_0:
        DC32     0xf4240
        DC32     0x186a1
//  288 
//  289 /**
//  290   * @brief  Fills each I2C_InitStruct member with its default value.
//  291   * @param I2C_InitStruct: pointer to an I2C_InitTypeDef structure
//  292   *   which will be initialized.
//  293   * @retval : None
//  294   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  295 void I2C_StructInit(I2C_InitTypeDef* I2C_InitStruct)
//  296 {
//  297 /*---------------- Reset I2C init structure parameters values ----------------*/
//  298   /* Initialize the I2C_Mode member */
//  299   I2C_InitStruct->I2C_Mode = I2C_Mode_I2C;
I2C_StructInit:
        MOVS     R1,#+0
        STRH     R1,[R0, #+0]
//  300   /* Initialize the I2C_DutyCycle member */
//  301   I2C_InitStruct->I2C_DutyCycle = I2C_DutyCycle_2;
        MOVW     R1,#+49151
        STRH     R1,[R0, #+2]
//  302   /* Initialize the I2C_OwnAddress1 member */
//  303   I2C_InitStruct->I2C_OwnAddress1 = 0;
        MOVS     R1,#+0
        STRH     R1,[R0, #+4]
//  304   /* Initialize the I2C_Ack member */
//  305   I2C_InitStruct->I2C_Ack = I2C_Ack_Disable;
        STRH     R1,[R0, #+6]
//  306   /* Initialize the I2C_AcknowledgedAddress member */
//  307   I2C_InitStruct->I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
        MOV      R1,#+16384
        STRH     R1,[R0, #+8]
//  308   /* initialize the I2C_ClockSpeed member */
//  309   I2C_InitStruct->I2C_ClockSpeed = 5000;
        MOVW     R1,#+5000
        STR      R1,[R0, #+12]
//  310 }
        BX       LR               ;; return
//  311 
//  312 /**
//  313   * @brief  Enables or disables the specified I2C peripheral.
//  314   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  315   * @param NewState: new state of the I2Cx peripheral. This parameter
//  316   *   can be: ENABLE or DISABLE.
//  317   * @retval : None
//  318   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  319 void I2C_Cmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  320 {
//  321   /* Check the parameters */
//  322   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  323   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  324   if (NewState != DISABLE)
I2C_Cmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x1
        MOVWEQ   R2,#+65534
        ANDEQ    R1,R2,R1
//  325   {
//  326     /* Enable the selected I2C peripheral */
//  327     I2Cx->CR1 |= CR1_PE_Set;
//  328   }
//  329   else
//  330   {
//  331     /* Disable the selected I2C peripheral */
//  332     I2Cx->CR1 &= CR1_PE_Reset;
        STRH     R1,[R0, #+0]
//  333   }
//  334 }
        BX       LR               ;; return
//  335 
//  336 /**
//  337   * @brief  Enables or disables the specified I2C DMA requests.
//  338   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  339   * @param NewState: new state of the I2C DMA transfer.
//  340   *   This parameter can be: ENABLE or DISABLE.
//  341   * @retval : None
//  342   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  343 void I2C_DMACmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  344 {
//  345   /* Check the parameters */
//  346   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  347   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  348   if (NewState != DISABLE)
I2C_DMACmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+4]
        ITEE     NE 
        ORRNE    R1,R1,#0x800
        MOVWEQ   R2,#+63487
        ANDEQ    R1,R2,R1
//  349   {
//  350     /* Enable the selected I2C DMA requests */
//  351     I2Cx->CR2 |= CR2_DMAEN_Set;
//  352   }
//  353   else
//  354   {
//  355     /* Disable the selected I2C DMA requests */
//  356     I2Cx->CR2 &= CR2_DMAEN_Reset;
        STRH     R1,[R0, #+4]
//  357   }
//  358 }
        BX       LR               ;; return
//  359 
//  360 /**
//  361   * @brief  Specifies that the next DMA transfer is the last one.
//  362   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  363   * @param NewState: new state of the I2C DMA last transfer.
//  364   *   This parameter can be: ENABLE or DISABLE.
//  365   * @retval : None
//  366   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  367 void I2C_DMALastTransferCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  368 {
//  369   /* Check the parameters */
//  370   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  371   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  372   if (NewState != DISABLE)
I2C_DMALastTransferCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+4]
        ITEE     NE 
        ORRNE    R1,R1,#0x1000
        MOVWEQ   R2,#+61439
        ANDEQ    R1,R2,R1
//  373   {
//  374     /* Next DMA transfer is the last transfer */
//  375     I2Cx->CR2 |= CR2_LAST_Set;
//  376   }
//  377   else
//  378   {
//  379     /* Next DMA transfer is not the last transfer */
//  380     I2Cx->CR2 &= CR2_LAST_Reset;
        STRH     R1,[R0, #+4]
//  381   }
//  382 }
        BX       LR               ;; return
//  383 
//  384 /**
//  385   * @brief  Generates I2Cx communication START condition.
//  386   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  387   * @param NewState: new state of the I2C START condition generation.
//  388   *   This parameter can be: ENABLE or DISABLE.
//  389   * @retval : None.
//  390   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  391 void I2C_GenerateSTART(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  392 {
//  393   /* Check the parameters */
//  394   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  395   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  396   if (NewState != DISABLE)
I2C_GenerateSTART:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITTEE    NE 
        MOVNE    R2,#+256
        ORRNE    R1,R2,R1
        MOVWEQ   R2,#+65279
        ANDEQ    R1,R2,R1
//  397   {
//  398     /* Generate a START condition */
//  399     I2Cx->CR1 |= CR1_START_Set;
//  400   }
//  401   else
//  402   {
//  403     /* Disable the START condition generation */
//  404     I2Cx->CR1 &= CR1_START_Reset;
        STRH     R1,[R0, #+0]
//  405   }
//  406 }
        BX       LR               ;; return
//  407 
//  408 /**
//  409   * @brief  Generates I2Cx communication STOP condition.
//  410   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  411   * @param NewState: new state of the I2C STOP condition generation.
//  412   *   This parameter can be: ENABLE or DISABLE.
//  413   * @retval : None.
//  414   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  415 void I2C_GenerateSTOP(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  416 {
//  417   /* Check the parameters */
//  418   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  419   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  420   if (NewState != DISABLE)
I2C_GenerateSTOP:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITTEE    NE 
        MOVNE    R2,#+512
        ORRNE    R1,R2,R1
        MOVWEQ   R2,#+65023
        ANDEQ    R1,R2,R1
//  421   {
//  422     /* Generate a STOP condition */
//  423     I2Cx->CR1 |= CR1_STOP_Set;
//  424   }
//  425   else
//  426   {
//  427     /* Disable the STOP condition generation */
//  428     I2Cx->CR1 &= CR1_STOP_Reset;
        STRH     R1,[R0, #+0]
//  429   }
//  430 }
        BX       LR               ;; return
//  431 
//  432 /**
//  433   * @brief  Enables or disables the specified I2C acknowledge feature.
//  434   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  435   * @param NewState: new state of the I2C Acknowledgement.
//  436   *   This parameter can be: ENABLE or DISABLE.
//  437   * @retval : None.
//  438   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  439 void I2C_AcknowledgeConfig(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  440 {
//  441   /* Check the parameters */
//  442   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  443   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  444   if (NewState != DISABLE)
I2C_AcknowledgeConfig:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x400
        MOVWEQ   R2,#+64511
        ANDEQ    R1,R2,R1
//  445   {
//  446     /* Enable the acknowledgement */
//  447     I2Cx->CR1 |= CR1_ACK_Set;
//  448   }
//  449   else
//  450   {
//  451     /* Disable the acknowledgement */
//  452     I2Cx->CR1 &= CR1_ACK_Reset;
        STRH     R1,[R0, #+0]
//  453   }
//  454 }
        BX       LR               ;; return
//  455 
//  456 /**
//  457   * @brief  Configures the specified I2C own address2.
//  458   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  459   * @param Address: specifies the 7bit I2C own address2.
//  460   * @retval : None.
//  461   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  462 void I2C_OwnAddress2Config(I2C_TypeDef* I2Cx, uint8_t Address)
//  463 {
//  464   uint16_t tmpreg = 0;
//  465   /* Check the parameters */
//  466   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  467   /* Get the old register value */
//  468   tmpreg = I2Cx->OAR2;
//  469   /* Reset I2Cx Own address2 bit [7:1] */
//  470   tmpreg &= OAR2_ADD2_Reset;
//  471   /* Set I2Cx Own address2 */
//  472   tmpreg |= (uint16_t)(Address & (uint16_t)0x00FE);
//  473   /* Store the new register value */
//  474   I2Cx->OAR2 = tmpreg;
I2C_OwnAddress2Config:
        LDRH     R2,[R0, #+12]
        MOVW     R3,#+65281
        ANDS     R2,R3,R2
        AND      R1,R1,#0xFE
        ORRS     R1,R1,R2
        STRH     R1,[R0, #+12]
//  475 }
        BX       LR               ;; return
//  476 
//  477 /**
//  478   * @brief  Enables or disables the specified I2C dual addressing mode.
//  479   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  480   * @param NewState: new state of the I2C dual addressing mode.
//  481   *   This parameter can be: ENABLE or DISABLE.
//  482   * @retval : None
//  483   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  484 void I2C_DualAddressCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  485 {
//  486   /* Check the parameters */
//  487   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  488   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  489   if (NewState != DISABLE)
I2C_DualAddressCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+12]
        ITEE     NE 
        ORRNE    R1,R1,#0x1
        MOVWEQ   R2,#+65534
        ANDEQ    R1,R2,R1
//  490   {
//  491     /* Enable dual addressing mode */
//  492     I2Cx->OAR2 |= OAR2_ENDUAL_Set;
//  493   }
//  494   else
//  495   {
//  496     /* Disable dual addressing mode */
//  497     I2Cx->OAR2 &= OAR2_ENDUAL_Reset;
        STRH     R1,[R0, #+12]
//  498   }
//  499 }
        BX       LR               ;; return
//  500 
//  501 /**
//  502   * @brief  Enables or disables the specified I2C general call feature.
//  503   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  504   * @param NewState: new state of the I2C General call.
//  505   *   This parameter can be: ENABLE or DISABLE.
//  506   * @retval : None
//  507   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  508 void I2C_GeneralCallCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  509 {
//  510   /* Check the parameters */
//  511   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  512   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  513   if (NewState != DISABLE)
I2C_GeneralCallCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x40
        MOVWEQ   R2,#+65471
        ANDEQ    R1,R2,R1
//  514   {
//  515     /* Enable generall call */
//  516     I2Cx->CR1 |= CR1_ENGC_Set;
//  517   }
//  518   else
//  519   {
//  520     /* Disable generall call */
//  521     I2Cx->CR1 &= CR1_ENGC_Reset;
        STRH     R1,[R0, #+0]
//  522   }
//  523 }
        BX       LR               ;; return
//  524 
//  525 /**
//  526   * @brief  Enables or disables the specified I2C interrupts.
//  527   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  528   * @param I2C_IT: specifies the I2C interrupts sources to be enabled
//  529   *   or disabled. 
//  530   *   This parameter can be any combination of the following values:
//  531   * @arg I2C_IT_BUF: Buffer interrupt mask
//  532   * @arg I2C_IT_EVT: Event interrupt mask
//  533   * @arg I2C_IT_ERR: Error interrupt mask
//  534   * @param NewState: new state of the specified I2C interrupts.
//  535   *   This parameter can be: ENABLE or DISABLE.
//  536   * @retval : None
//  537   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  538 void I2C_ITConfig(I2C_TypeDef* I2Cx, uint16_t I2C_IT, FunctionalState NewState)
//  539 {
//  540   /* Check the parameters */
//  541   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  542   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  543   assert_param(IS_I2C_CONFIG_IT(I2C_IT));
//  544   
//  545   if (NewState != DISABLE)
I2C_ITConfig:
        CMP      R2,#+0
        LDRH     R2,[R0, #+4]
        ITE      NE 
        ORRNE    R1,R1,R2
        BICEQ    R1,R2,R1
//  546   {
//  547     /* Enable the selected I2C interrupts */
//  548     I2Cx->CR2 |= I2C_IT;
//  549   }
//  550   else
//  551   {
//  552     /* Disable the selected I2C interrupts */
//  553     I2Cx->CR2 &= (uint16_t)~I2C_IT;
        STRH     R1,[R0, #+4]
//  554   }
//  555 }
        BX       LR               ;; return
//  556 
//  557 /**
//  558   * @brief  Sends a data byte through the I2Cx peripheral.
//  559   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  560   * @param Data: Byte to be transmitted..
//  561   * @retval : None
//  562   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  563 void I2C_SendData(I2C_TypeDef* I2Cx, uint8_t Data)
//  564 {
//  565   /* Check the parameters */
//  566   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  567   /* Write in the DR register the data to be sent */
//  568   I2Cx->DR = Data;
I2C_SendData:
        STRH     R1,[R0, #+16]
//  569 }
        BX       LR               ;; return
//  570 
//  571 /**
//  572   * @brief  Returns the most recent received data by the I2Cx peripheral.
//  573   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  574   * @retval : The value of the received data.
//  575   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  576 uint8_t I2C_ReceiveData(I2C_TypeDef* I2Cx)
//  577 {
//  578   /* Check the parameters */
//  579   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  580   /* Return the data in the DR register */
//  581   return (uint8_t)I2Cx->DR;
I2C_ReceiveData:
        LDRH     R0,[R0, #+16]
        UXTB     R0,R0
        BX       LR               ;; return
//  582 }
//  583 
//  584 /**
//  585   * @brief  Transmits the address byte to select the slave device.
//  586   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  587   * @param Address: specifies the slave address which will be transmitted
//  588   * @param I2C_Direction: specifies whether the I2C device will be a
//  589   *   Transmitter or a Receiver. 
//  590   *   This parameter can be one of the following values
//  591   * @arg I2C_Direction_Transmitter: Transmitter mode
//  592   * @arg I2C_Direction_Receiver: Receiver mode
//  593   * @retval : None.
//  594   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  595 void I2C_Send7bitAddress(I2C_TypeDef* I2Cx, uint8_t Address, uint8_t I2C_Direction)
//  596 {
//  597   /* Check the parameters */
//  598   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  599   assert_param(IS_I2C_DIRECTION(I2C_Direction));
//  600   /* Test on the direction to set/reset the read/write bit */
//  601   if (I2C_Direction != I2C_Direction_Transmitter)
I2C_Send7bitAddress:
        CMP      R2,#+0
        ITE      NE 
        ORRNE    R1,R1,#0x1
        ANDEQ    R1,R1,#0xFE
//  602   {
//  603     /* Set the address bit0 for read */
//  604     Address |= OAR1_ADD0_Set;
//  605   }
//  606   else
//  607   {
//  608     /* Reset the address bit0 for write */
//  609     Address &= OAR1_ADD0_Reset;
//  610   }
//  611   /* Send the address */
//  612   I2Cx->DR = Address;
        STRH     R1,[R0, #+16]
//  613 }
        BX       LR               ;; return
//  614 
//  615 /**
//  616   * @brief  Reads the specified I2C register and returns its value.
//  617   * @param I2C_Register: specifies the register to read.
//  618   *   This parameter can be one of the following values:
//  619   * @arg I2C_Register_CR1:  CR1 register.
//  620   * @arg I2C_Register_CR2:   CR2 register.
//  621   * @arg I2C_Register_OAR1:  OAR1 register.
//  622   * @arg I2C_Register_OAR2:  OAR2 register.
//  623   * @arg I2C_Register_DR:    DR register.
//  624   * @arg I2C_Register_SR1:   SR1 register.
//  625   * @arg I2C_Register_SR2:   SR2 register.
//  626   * @arg I2C_Register_CCR:   CCR register.
//  627   * @arg I2C_Register_TRISE: TRISE register.
//  628   * @retval : The value of the read register.
//  629   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  630 uint16_t I2C_ReadRegister(I2C_TypeDef* I2Cx, uint8_t I2C_Register)
//  631 {
//  632   /* Check the parameters */
//  633   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  634   assert_param(IS_I2C_REGISTER(I2C_Register));
//  635   /* Return the selected register value */
//  636   return (*(__IO uint16_t *)(*((__IO uint32_t *)&I2Cx) + I2C_Register));
I2C_ReadRegister:
        LDRH     R0,[R1, R0]
        BX       LR               ;; return
//  637 }
//  638 
//  639 /**
//  640   * @brief  Enables or disables the specified I2C software reset.
//  641   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  642   * @param NewState: new state of the I2C software reset.
//  643   *   This parameter can be: ENABLE or DISABLE.
//  644   * @retval : None
//  645   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  646 void I2C_SoftwareResetCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  647 {
//  648   /* Check the parameters */
//  649   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  650   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  651   if (NewState != DISABLE)
I2C_SoftwareResetCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x8000
        LSLEQ    R1,R1,#+17
        LSREQ    R1,R1,#+17
//  652   {
//  653     /* Peripheral under reset */
//  654     I2Cx->CR1 |= CR1_SWRST_Set;
//  655   }
//  656   else
//  657   {
//  658     /* Peripheral not under reset */
//  659     I2Cx->CR1 &= CR1_SWRST_Reset;
        STRH     R1,[R0, #+0]
//  660   }
//  661 }
        BX       LR               ;; return
//  662 
//  663 /**
//  664   * @brief  Drives the SMBusAlert pin high or low for the specified I2C.
//  665   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  666   * @param I2C_SMBusAlert: specifies SMBAlert pin level. 
//  667   *   This parameter can be one of the following values:
//  668   * @arg I2C_SMBusAlert_Low: SMBAlert pin driven low
//  669   * @arg I2C_SMBusAlert_High: SMBAlert pin driven high
//  670   * @retval : None
//  671   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  672 void I2C_SMBusAlertConfig(I2C_TypeDef* I2Cx, uint16_t I2C_SMBusAlert)
//  673 {
//  674   /* Check the parameters */
//  675   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  676   assert_param(IS_I2C_SMBUS_ALERT(I2C_SMBusAlert));
//  677   if (I2C_SMBusAlert == I2C_SMBusAlert_Low)
I2C_SMBusAlertConfig:
        CMP      R1,#+8192
        LDRH     R1,[R0, #+0]
        ITEE     EQ 
        ORREQ    R1,R1,#0x2000
        MOVWNE   R2,#+57343
        ANDNE    R1,R2,R1
//  678   {
//  679     /* Drive the SMBusAlert pin Low */
//  680     I2Cx->CR1 |= I2C_SMBusAlert_Low;
//  681   }
//  682   else
//  683   {
//  684     /* Drive the SMBusAlert pin High  */
//  685     I2Cx->CR1 &= I2C_SMBusAlert_High;
        STRH     R1,[R0, #+0]
//  686   }
//  687 }
        BX       LR               ;; return
//  688 
//  689 /**
//  690   * @brief  Enables or disables the specified I2C PEC transfer.
//  691   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  692   * @param NewState: new state of the I2C PEC transmission.
//  693   *   This parameter can be: ENABLE or DISABLE.
//  694   * @retval : None
//  695   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  696 void I2C_TransmitPEC(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  697 {
//  698   /* Check the parameters */
//  699   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  700   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  701   if (NewState != DISABLE)
I2C_TransmitPEC:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x1000
        MOVWEQ   R2,#+61439
        ANDEQ    R1,R2,R1
//  702   {
//  703     /* Enable the selected I2C PEC transmission */
//  704     I2Cx->CR1 |= CR1_PEC_Set;
//  705   }
//  706   else
//  707   {
//  708     /* Disable the selected I2C PEC transmission */
//  709     I2Cx->CR1 &= CR1_PEC_Reset;
        STRH     R1,[R0, #+0]
//  710   }
//  711 }
        BX       LR               ;; return
//  712 
//  713 /**
//  714   * @brief  Selects the specified I2C PEC position.
//  715   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  716   * @param I2C_PECPosition: specifies the PEC position. 
//  717   *   This parameter can be one of the following values:
//  718   * @arg I2C_PECPosition_Next: indicates that the next
//  719   *   byte is PEC
//  720   * @arg I2C_PECPosition_Current: indicates that current
//  721   *   byte is PEC
//  722   * @retval : None
//  723   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  724 void I2C_PECPositionConfig(I2C_TypeDef* I2Cx, uint16_t I2C_PECPosition)
//  725 {
//  726   /* Check the parameters */
//  727   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  728   assert_param(IS_I2C_PEC_POSITION(I2C_PECPosition));
//  729   if (I2C_PECPosition == I2C_PECPosition_Next)
I2C_PECPositionConfig:
        CMP      R1,#+2048
        LDRH     R1,[R0, #+0]
        ITEE     EQ 
        ORREQ    R1,R1,#0x800
        MOVWNE   R2,#+63487
        ANDNE    R1,R2,R1
//  730   {
//  731     /* Next byte in shift register is PEC */
//  732     I2Cx->CR1 |= I2C_PECPosition_Next;
//  733   }
//  734   else
//  735   {
//  736     /* Current byte in shift register is PEC */
//  737     I2Cx->CR1 &= I2C_PECPosition_Current;
        STRH     R1,[R0, #+0]
//  738   }
//  739 }
        BX       LR               ;; return
//  740 
//  741 /**
//  742   * @brief  Enables or disables the PEC value calculation of the
//  743   *   transfered bytes.
//  744   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  745   * @param NewState: new state of the I2Cx PEC value calculation.
//  746   *   This parameter can be: ENABLE or DISABLE.
//  747   * @retval : None
//  748   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  749 void I2C_CalculatePEC(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  750 {
//  751   /* Check the parameters */
//  752   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  753   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  754   if (NewState != DISABLE)
I2C_CalculatePEC:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x20
        MOVWEQ   R2,#+65503
        ANDEQ    R1,R2,R1
//  755   {
//  756     /* Enable the selected I2C PEC calculation */
//  757     I2Cx->CR1 |= CR1_ENPEC_Set;
//  758   }
//  759   else
//  760   {
//  761     /* Disable the selected I2C PEC calculation */
//  762     I2Cx->CR1 &= CR1_ENPEC_Reset;
        STRH     R1,[R0, #+0]
//  763   }
//  764 }
        BX       LR               ;; return
//  765 
//  766 /**
//  767   * @brief  Returns the PEC value for the specified I2C.
//  768   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  769   * @retval : The PEC value.
//  770   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  771 uint8_t I2C_GetPEC(I2C_TypeDef* I2Cx)
//  772 {
//  773   /* Check the parameters */
//  774   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  775   /* Return the selected I2C PEC value */
//  776   return ((I2Cx->SR2) >> 8);
I2C_GetPEC:
        LDRH     R0,[R0, #+24]
        LSRS     R0,R0,#+8
        BX       LR               ;; return
//  777 }
//  778 
//  779 /**
//  780   * @brief  Enables or disables the specified I2C ARP.
//  781   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  782   * @param NewState: new state of the I2Cx ARP. 
//  783   *   This parameter can be: ENABLE or DISABLE.
//  784   * @retval : None
//  785   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  786 void I2C_ARPCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  787 {
//  788   /* Check the parameters */
//  789   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  790   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  791   if (NewState != DISABLE)
I2C_ARPCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     NE 
        ORRNE    R1,R1,#0x10
        MOVWEQ   R2,#+65519
        ANDEQ    R1,R2,R1
//  792   {
//  793     /* Enable the selected I2C ARP */
//  794     I2Cx->CR1 |= CR1_ENARP_Set;
//  795   }
//  796   else
//  797   {
//  798     /* Disable the selected I2C ARP */
//  799     I2Cx->CR1 &= CR1_ENARP_Reset;
        STRH     R1,[R0, #+0]
//  800   }
//  801 }
        BX       LR               ;; return
//  802 
//  803 /**
//  804   * @brief  Enables or disables the specified I2C Clock stretching.
//  805   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  806   * @param NewState: new state of the I2Cx Clock stretching.
//  807   *   This parameter can be: ENABLE or DISABLE.
//  808   * @retval : None
//  809   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  810 void I2C_StretchClockCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
//  811 {
//  812   /* Check the parameters */
//  813   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  814   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  815   if (NewState == DISABLE)
I2C_StretchClockCmd:
        CMP      R1,#+0
        LDRH     R1,[R0, #+0]
        ITEE     EQ 
        ORREQ    R1,R1,#0x80
        MOVWNE   R2,#+65407
        ANDNE    R1,R2,R1
//  816   {
//  817     /* Enable the selected I2C Clock stretching */
//  818     I2Cx->CR1 |= CR1_NOSTRETCH_Set;
//  819   }
//  820   else
//  821   {
//  822     /* Disable the selected I2C Clock stretching */
//  823     I2Cx->CR1 &= CR1_NOSTRETCH_Reset;
        STRH     R1,[R0, #+0]
//  824   }
//  825 }
        BX       LR               ;; return
//  826 
//  827 /**
//  828   * @brief  Selects the specified I2C fast mode duty cycle.
//  829   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  830   * @param I2C_DutyCycle: specifies the fast mode duty cycle.
//  831   *   This parameter can be one of the following values:
//  832   * @arg I2C_DutyCycle_2: I2C fast mode Tlow/Thigh = 2
//  833   * @arg I2C_DutyCycle_16_9: I2C fast mode Tlow/Thigh = 16/9
//  834   * @retval : None
//  835   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  836 void I2C_FastModeDutyCycleConfig(I2C_TypeDef* I2Cx, uint16_t I2C_DutyCycle)
//  837 {
//  838   /* Check the parameters */
//  839   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  840   assert_param(IS_I2C_DUTY_CYCLE(I2C_DutyCycle));
//  841   if (I2C_DutyCycle != I2C_DutyCycle_16_9)
I2C_FastModeDutyCycleConfig:
        CMP      R1,#+16384
        LDRH     R1,[R0, #+28]
        ITTE     NE 
        MOVWNE   R2,#+49151
        ANDNE    R1,R2,R1
        ORREQ    R1,R1,#0x4000
//  842   {
//  843     /* I2C fast mode Tlow/Thigh=2 */
//  844     I2Cx->CCR &= I2C_DutyCycle_2;
//  845   }
//  846   else
//  847   {
//  848     /* I2C fast mode Tlow/Thigh=16/9 */
//  849     I2Cx->CCR |= I2C_DutyCycle_16_9;
        STRH     R1,[R0, #+28]
//  850   }
//  851 }
        BX       LR               ;; return
//  852 
//  853 /**
//  854   * @brief  Returns the last I2Cx Event.
//  855   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  856   * @retval : The last event
//  857   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  858 uint32_t I2C_GetLastEvent(I2C_TypeDef* I2Cx)
//  859 {
//  860   uint32_t lastevent = 0;
//  861   uint32_t flag1 = 0, flag2 = 0;
//  862   /* Check the parameters */
//  863   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  864   /* Read the I2Cx status register */
//  865   flag1 = I2Cx->SR1;
I2C_GetLastEvent:
        LDRH     R1,[R0, #+20]
//  866   flag2 = I2Cx->SR2;
        LDRH     R0,[R0, #+24]
//  867   flag2 = flag2 << 16;
//  868   /* Get the last event value from I2C status register */
//  869   lastevent = (flag1 | flag2) & FLAG_Mask;
//  870   /* Return status */
//  871   return lastevent;
        ORR      R0,R1,R0, LSL #+16
        LSLS     R0,R0,#+8
        LSRS     R0,R0,#+8
        BX       LR               ;; return
//  872 }
//  873 
//  874 /**
//  875   * @brief  Checks whether the last I2Cx Event is equal to the one passed
//  876   *   as parameter.
//  877   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  878   * @param I2C_EVENT: specifies the event to be checked. 
//  879   *   This parameter can be one of the following values:
//  880   * @arg I2C_EVENT_SLAVE_ADDRESS_MATCHED   : EV1
//  881   * @arg I2C_EVENT_SLAVE_BYTE_RECEIVED     : EV2
//  882   * @arg I2C_EVENT_SLAVE_BYTE_TRANSMITTED  : EV3
//  883   * @arg I2C_EVENT_SLAVE_ACK_FAILURE       : EV3-2
//  884   * @arg I2C_EVENT_MASTER_MODE_SELECT      : EV5
//  885   * @arg I2C_EVENT_MASTER_MODE_SELECTED    : EV6
//  886   * @arg I2C_EVENT_MASTER_BYTE_RECEIVED    : EV7
//  887   * @arg I2C_EVENT_MASTER_BYTE_TRANSMITTED : EV8
//  888   * @arg I2C_EVENT_MASTER_MODE_ADDRESS10   : EV9
//  889   * @arg I2C_EVENT_SLAVE_STOP_DETECTED     : EV4
//  890   * @retval : An ErrorStatus enumuration value:
//  891   * - SUCCESS: Last event is equal to the I2C_EVENT
//  892   * - ERROR: Last event is different from the I2C_EVENT
//  893   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  894 ErrorStatus I2C_CheckEvent(I2C_TypeDef* I2Cx, uint32_t I2C_EVENT)
//  895 {
//  896   uint32_t lastevent = 0;
//  897   uint32_t flag1 = 0, flag2 = 0;
//  898   ErrorStatus status = ERROR;
//  899   /* Check the parameters */
//  900   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  901   assert_param(IS_I2C_EVENT(I2C_EVENT));
//  902   /* Read the I2Cx status register */
//  903   flag1 = I2Cx->SR1;
I2C_CheckEvent:
        LDRH     R2,[R0, #+20]
//  904   flag2 = I2Cx->SR2;
        LDRH     R0,[R0, #+24]
//  905   flag2 = flag2 << 16;
//  906   /* Get the last event value from I2C status register */
//  907   lastevent = (flag1 | flag2) & FLAG_Mask;
//  908   /* Check whether the last event is equal to I2C_EVENT */
//  909   if (lastevent == I2C_EVENT )
        ORR      R0,R2,R0, LSL #+16
        LSLS     R0,R0,#+8
        LSRS     R0,R0,#+8
        CMP      R0,R1
        BNE.N    ??I2C_CheckEvent_0
//  910   {
//  911     /* SUCCESS: last event is equal to I2C_EVENT */
//  912     status = SUCCESS;
        MOVS     R0,#+1
        BX       LR
//  913   }
//  914   else
//  915   {
//  916     /* ERROR: last event is different from I2C_EVENT */
//  917     status = ERROR;
??I2C_CheckEvent_0:
        MOVS     R0,#+0
//  918   }
//  919   /* Return status */
//  920   return status;
        BX       LR               ;; return
//  921 }
//  922 
//  923 /**
//  924   * @brief  Checks whether the specified I2C flag is set or not.
//  925   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  926   * @param I2C_FLAG: specifies the flag to check. 
//  927   *   This parameter can be one of the following values:
//  928   * @arg I2C_FLAG_DUALF: Dual flag (Slave mode)
//  929   * @arg I2C_FLAG_SMBHOST: SMBus host header (Slave mode)
//  930   * @arg I2C_FLAG_SMBDEFAULT: SMBus default header (Slave mode)
//  931   * @arg I2C_FLAG_GENCALL: General call header flag (Slave mode)
//  932   * @arg I2C_FLAG_TRA: Transmitter/Receiver flag
//  933   * @arg I2C_FLAG_BUSY: Bus busy flag
//  934   * @arg I2C_FLAG_MSL: Master/Slave flag
//  935   * @arg I2C_FLAG_SMBALERT: SMBus Alert flag
//  936   * @arg I2C_FLAG_TIMEOUT: Timeout or Tlow error flag
//  937   * @arg I2C_FLAG_PECERR: PEC error in reception flag
//  938   * @arg I2C_FLAG_OVR: Overrun/Underrun flag (Slave mode)
//  939   * @arg I2C_FLAG_AF: Acknowledge failure flag
//  940   * @arg I2C_FLAG_ARLO: Arbitration lost flag (Master mode)
//  941   * @arg I2C_FLAG_BERR: Bus error flag
//  942   * @arg I2C_FLAG_TXE: Data register empty flag (Transmitter)
//  943   * @arg I2C_FLAG_RXNE: Data register not empty (Receiver) flag
//  944   * @arg I2C_FLAG_STOPF: Stop detection flag (Slave mode)
//  945   * @arg I2C_FLAG_ADD10: 10-bit header sent flag (Master mode)
//  946   * @arg I2C_FLAG_BTF: Byte transfer finished flag
//  947   * @arg I2C_FLAG_ADDR: Address sent flag (Master mode) ADSL
//  948   *   Address matched flag (Slave mode)ENDAD
//  949   * @arg I2C_FLAG_SB: Start bit flag (Master mode)
//  950   * @retval : The new state of I2C_FLAG (SET or RESET).
//  951   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  952 FlagStatus I2C_GetFlagStatus(I2C_TypeDef* I2Cx, uint32_t I2C_FLAG)
//  953 {
I2C_GetFlagStatus:
        SUB      SP,SP,#+8
//  954   FlagStatus bitstatus = RESET;
//  955   __IO uint32_t i2creg = 0, i2cxbase = 0;
        MOVS     R2,#+0
        STR      R2,[SP, #+4]
        STR      R2,[SP, #+0]
//  956   /* Check the parameters */
//  957   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
//  958   assert_param(IS_I2C_GET_FLAG(I2C_FLAG));
//  959   /* Get the I2Cx peripheral base address */
//  960   i2cxbase = (*(uint32_t*)&(I2Cx));
        STR      R0,[SP, #+0]
//  961   
//  962   /* Read flag register index */
//  963   i2creg = I2C_FLAG >> 28;
        LSRS     R0,R1,#+28
        STR      R0,[SP, #+4]
//  964   
//  965   /* Get bit[23:0] of the flag */
//  966   I2C_FLAG &= FLAG_Mask;
        LSLS     R0,R1,#+8
        LSRS     R0,R0,#+8
//  967   
//  968   if(i2creg != 0)
        LDR      R1,[SP, #+4]
        CBZ      R1,??I2C_GetFlagStatus_0
//  969   {
//  970     /* Get the I2Cx SR1 register address */
//  971     i2cxbase += 0x14;
        LDR      R1,[SP, #+0]
        ADDS     R1,R1,#+20
        B.N      ??I2C_GetFlagStatus_1
//  972   }
//  973   else
//  974   {
//  975     /* Flag in I2Cx SR2 Register */
//  976     I2C_FLAG = (uint32_t)(I2C_FLAG >> 16);
??I2C_GetFlagStatus_0:
        LSRS     R0,R0,#+16
//  977     /* Get the I2Cx SR2 register address */
//  978     i2cxbase += 0x18;
        LDR      R1,[SP, #+0]
        ADDS     R1,R1,#+24
??I2C_GetFlagStatus_1:
        STR      R1,[SP, #+0]
//  979   }
//  980   
//  981   if(((*(__IO uint32_t *)i2cxbase) & I2C_FLAG) != (uint32_t)RESET)
        LDR      R1,[SP, #+0]
        LDR      R1,[R1, #+0]
        ANDS     R0,R0,R1
        BEQ.N    ??I2C_GetFlagStatus_2
        MOVS     R0,#+1
//  982   {
//  983     /* I2C_FLAG is set */
//  984     bitstatus = SET;
//  985   }
//  986   else
//  987   {
//  988     /* I2C_FLAG is reset */
//  989     bitstatus = RESET;
//  990   }
//  991   
//  992   /* Return the I2C_FLAG status */
//  993   return  bitstatus;
??I2C_GetFlagStatus_2:
        UXTB     R0,R0
        ADD      SP,SP,#+8
        BX       LR               ;; return
//  994 }
//  995 
//  996 /**
//  997   * @brief  Clears the I2Cx's pending flags.
//  998   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
//  999   * @param I2C_FLAG: specifies the flag to clear. 
// 1000   *   This parameter can be any combination of the following values:
// 1001   * @arg I2C_FLAG_SMBALERT: SMBus Alert flag
// 1002   * @arg I2C_FLAG_TIMEOUT: Timeout or Tlow error flag
// 1003   * @arg I2C_FLAG_PECERR: PEC error in reception flag
// 1004   * @arg I2C_FLAG_OVR: Overrun/Underrun flag (Slave mode)
// 1005   * @arg I2C_FLAG_AF: Acknowledge failure flag
// 1006   * @arg I2C_FLAG_ARLO: Arbitration lost flag (Master mode)
// 1007   * @arg I2C_FLAG_BERR: Bus error flag
// 1008   *   
// 1009   * @note
// 1010   *   - STOPF (STOP detection) is cleared by software sequence: a read operation 
// 1011   *     to I2C_SR1 register (I2C_GetFlagStatus()) followed by a write operation 
// 1012   *     to I2C_CR1 register (I2C_Cmd() to re-enable the I2C peripheral).
// 1013   *   - ADD10 (10-bit header sent) is cleared by software sequence: a read 
// 1014   *     operation to I2C_SR1 (I2C_GetFlagStatus()) followed by writing the 
// 1015   *     second byte of the address in DR register.
// 1016   *   - BTF (Byte Transfer Finished) is cleared by software sequence: a read 
// 1017   *     operation to I2C_SR1 register (I2C_GetFlagStatus()) followed by a 
// 1018   *     read/write to I2C_DR register (I2C_SendData()).
// 1019   *   - ADDR (Address sent) is cleared by software sequence: a read operation to 
// 1020   *     I2C_SR1 register (I2C_GetFlagStatus()) followed by a read operation to 
// 1021   *     I2C_SR2 register ((void)(I2Cx->SR2)).
// 1022   *   - SB (Start Bit) is cleared software sequence: a read operation to I2C_SR1
// 1023   *     register (I2C_GetFlagStatus()) followed by a write operation to I2C_DR
// 1024   *     register  (I2C_SendData()).
// 1025   * @retval : None
// 1026   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
// 1027 void I2C_ClearFlag(I2C_TypeDef* I2Cx, uint32_t I2C_FLAG)
// 1028 {
// 1029   uint32_t flagpos = 0;
// 1030   /* Check the parameters */
// 1031   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
// 1032   assert_param(IS_I2C_CLEAR_FLAG(I2C_FLAG));
// 1033   /* Get the I2C flag position */
// 1034   flagpos = I2C_FLAG & FLAG_Mask;
// 1035   /* Clear the selected I2C flag */
// 1036   I2Cx->SR1 = (uint16_t)~flagpos;
I2C_ClearFlag:
        B.N      ?Subroutine0
// 1037 }
// 1038 
// 1039 /**
// 1040   * @brief  Checks whether the specified I2C interrupt has occurred or not.
// 1041   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
// 1042   * @param I2C_IT: specifies the interrupt source to check. 
// 1043   *   This parameter can be one of the following values:
// 1044   * @arg I2C_IT_SMBALERT: SMBus Alert flag
// 1045   * @arg I2C_IT_TIMEOUT: Timeout or Tlow error flag
// 1046   * @arg I2C_IT_PECERR: PEC error in reception flag
// 1047   * @arg I2C_IT_OVR: Overrun/Underrun flag (Slave mode)
// 1048   * @arg I2C_IT_AF: Acknowledge failure flag
// 1049   * @arg I2C_IT_ARLO: Arbitration lost flag (Master mode)
// 1050   * @arg I2C_IT_BERR: Bus error flag
// 1051   * @arg I2C_IT_TXE: Data register empty flag (Transmitter)
// 1052   * @arg I2C_IT_RXNE: Data register not empty (Receiver) flag
// 1053   * @arg I2C_IT_STOPF: Stop detection flag (Slave mode)
// 1054   * @arg I2C_IT_ADD10: 10-bit header sent flag (Master mode)
// 1055   * @arg I2C_IT_BTF: Byte transfer finished flag
// 1056   * @arg I2C_IT_ADDR: Address sent flag (Master mode) ADSL
// 1057   *   Address matched flag (Slave mode)ENDAD
// 1058   * @arg I2C_IT_SB: Start bit flag (Master mode)
// 1059   * @retval : The new state of I2C_IT (SET or RESET).
// 1060   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
// 1061 ITStatus I2C_GetITStatus(I2C_TypeDef* I2Cx, uint32_t I2C_IT)
// 1062 {
// 1063   ITStatus bitstatus = RESET;
// 1064   uint32_t enablestatus = 0;
// 1065   /* Check the parameters */
// 1066   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
// 1067   assert_param(IS_I2C_GET_IT(I2C_IT));
// 1068   /* Check if the interrupt source is enabled or not */
// 1069   enablestatus = (uint32_t)(((I2C_IT & ITEN_Mask) >> 16) & (I2Cx->CR2)) ;  
I2C_GetITStatus:
        AND      R2,R1,#0x7000000
        LDRH     R3,[R0, #+4]
        AND      R2,R3,R2, LSR #+16
// 1070   /* Get bit[23:0] of the flag */
// 1071   I2C_IT &= FLAG_Mask;
// 1072   /* Check the status of the specified I2C flag */
// 1073   if (((I2Cx->SR1 & I2C_IT) != (uint32_t)RESET) && enablestatus)
        LDRH     R0,[R0, #+20]
        TST      R0,R1
        BEQ.N    ??I2C_GetITStatus_0
        MOVS     R0,R2
        BEQ.N    ??I2C_GetITStatus_1
        MOVS     R0,#+1
        B.N      ??I2C_GetITStatus_1
// 1074   {
// 1075     /* I2C_IT is set */
// 1076     bitstatus = SET;
// 1077   }
// 1078   else
// 1079   {
// 1080     /* I2C_IT is reset */
// 1081     bitstatus = RESET;
??I2C_GetITStatus_0:
        MOVS     R0,#+0
// 1082   }
// 1083   /* Return the I2C_IT status */
// 1084   return  bitstatus;
??I2C_GetITStatus_1:
        UXTB     R0,R0
        BX       LR               ;; return
// 1085 }
// 1086 
// 1087 /**
// 1088   * @brief  Clears the I2Cxs interrupt pending bits.
// 1089   * @param I2Cx: where x can be 1 or 2 to select the I2C peripheral.
// 1090   * @param I2C_IT: specifies the interrupt pending bit to clear. 
// 1091   *   This parameter can be any combination of the following values:
// 1092   * @arg I2C_IT_SMBALERT: SMBus Alert interrupt
// 1093   * @arg I2C_IT_TIMEOUT: Timeout or Tlow error interrupt
// 1094   * @arg I2C_IT_PECERR: PEC error in reception  interrupt
// 1095   * @arg I2C_IT_OVR: Overrun/Underrun interrupt (Slave mode)
// 1096   * @arg I2C_IT_AF: Acknowledge failure interrupt
// 1097   * @arg I2C_IT_ARLO: Arbitration lost interrupt (Master mode)
// 1098   * @arg I2C_IT_BERR: Bus error interrupt
// 1099   *   
// 1100   * @note
// 1101   *   - STOPF (STOP detection) is cleared by software sequence: a read operation 
// 1102   *     to I2C_SR1 register (I2C_GetITStatus()) followed by a write operation to 
// 1103   *     I2C_CR1 register (I2C_Cmd() to re-enable the I2C peripheral).
// 1104   *   - ADD10 (10-bit header sent) is cleared by software sequence: a read 
// 1105   *     operation to I2C_SR1 (I2C_GetITStatus()) followed by writing the second 
// 1106   *     byte of the address in I2C_DR register.
// 1107   *   - BTF (Byte Transfer Finished) is cleared by software sequence: a read 
// 1108   *     operation to I2C_SR1 register (I2C_GetITStatus()) followed by a 
// 1109   *     read/write to I2C_DR register (I2C_SendData()).
// 1110   *   - ADDR (Address sent) is cleared by software sequence: a read operation to 
// 1111   *     I2C_SR1 register (I2C_GetITStatus()) followed by a read operation to 
// 1112   *     I2C_SR2 register ((void)(I2Cx->SR2)).
// 1113   *   - SB (Start Bit) is cleared by software sequence: a read operation to 
// 1114   *     I2C_SR1 register (I2C_GetITStatus()) followed by a write operation to 
// 1115   *     I2C_DR register (I2C_SendData()).
// 1116   * @retval : None
// 1117   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
// 1118 void I2C_ClearITPendingBit(I2C_TypeDef* I2Cx, uint32_t I2C_IT)
// 1119 {
// 1120   uint32_t flagpos = 0;
// 1121   /* Check the parameters */
// 1122   assert_param(IS_I2C_ALL_PERIPH(I2Cx));
// 1123   assert_param(IS_I2C_CLEAR_IT(I2C_IT));
// 1124   /* Get the I2C flag position */
// 1125   flagpos = I2C_IT & FLAG_Mask;
// 1126   /* Clear the selected I2C flag */
// 1127   I2Cx->SR1 = (uint16_t)~flagpos;
I2C_ClearITPendingBit:
        REQUIRE ?Subroutine0
        ;; // Fall through to label ?Subroutine0

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine0:
        MVNS     R1,R1
        STRH     R1,[R0, #+20]
        BX       LR               ;; return

        END
// 1128 }
// 1129 
// 1130 /**
// 1131   * @}
// 1132   */ 
// 1133 
// 1134 /**
// 1135   * @}
// 1136   */ 
// 1137 
// 1138 /**
// 1139   * @}
// 1140   */ 
// 1141 
// 1142 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
// 800 bytes in section .text
// 
// 800 bytes of CODE memory
//
//Errors: none
//Warnings: none
