///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:51 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Project\Template\stm32f10x_it.c               /
//    Command line =  C:\My_App\Project\Template\stm32f10x_it.c -D            /
//                    USE_STDPERIPH_DRIVER -D STM32F10X_HD -D                 /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\s /
//                    tm32f10x_it.s                                           /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME stm32f10x_it

        PUBLIC BusFault_Handler
        PUBLIC DebugMon_Handler
        PUBLIC HardFault_Handler
        PUBLIC MemManage_Handler
        PUBLIC NMI_Handler
        PUBLIC PendSV_Handler
        PUBLIC SVC_Handler
        PUBLIC SysTick_Handler
        PUBLIC UsageFault_Handler

// C:\My_App\Project\Template\stm32f10x_it.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file I2C/M24C08_EEPROM/stm32f10x_it.c 
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  Main Interrupt Service Routines.
//    8   *         This file provides template for all exceptions handler and 
//    9   *         peripherals interrupt service routine.
//   10   ******************************************************************************
//   11   * @copy
//   12   *
//   13   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   14   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   15   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   16   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   17   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   18   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   19   *
//   20   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   21   */ 
//   22 
//   23 /* Includes ------------------------------------------------------------------*/
//   24 #include "stm32f10x_it.h"
//   25 
//   26 /** @addtogroup StdPeriph_Examples
//   27   * @{
//   28   */
//   29 
//   30 /** @addtogroup I2C_M24C08_EEPROM
//   31   * @{
//   32   */ 
//   33 
//   34 /* Private typedef -----------------------------------------------------------*/
//   35 /* Private define ------------------------------------------------------------*/
//   36 /* Private macro -------------------------------------------------------------*/
//   37 /* Private variables ---------------------------------------------------------*/
//   38 /* Private function prototypes -----------------------------------------------*/
//   39 /* Private functions ---------------------------------------------------------*/
//   40 
//   41 /******************************************************************************/
//   42 /*            Cortex-M3 Processor Exceptions Handlers                         */
//   43 /******************************************************************************/
//   44 
//   45 /**
//   46   * @brief  This function handles NMI exception.
//   47   * @param  None
//   48   * @retval : None
//   49   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   50 void NMI_Handler(void)
//   51 {
//   52 }
NMI_Handler:
        BX       LR               ;; return
//   53 
//   54 /**
//   55   * @brief  This function handles Hard Fault exception.
//   56   * @param  None
//   57   * @retval : None
//   58   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   59 void HardFault_Handler(void)
//   60 {
//   61   /* Go to infinite loop when Hard Fault exception occurs */
//   62   while (1)
HardFault_Handler:
??HardFault_Handler_0:
        B.N      ??HardFault_Handler_0
//   63   {
//   64   }
//   65 }
//   66 
//   67 /**
//   68   * @brief  This function handles Memory Manage exception.
//   69   * @param  None
//   70   * @retval : None
//   71   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   72 void MemManage_Handler(void)
//   73 {
//   74   /* Go to infinite loop when Memory Manage exception occurs */
//   75   while (1)
MemManage_Handler:
??MemManage_Handler_0:
        B.N      ??MemManage_Handler_0
//   76   {
//   77   }
//   78 }
//   79 
//   80 /**
//   81   * @brief  This function handles Bus Fault exception.
//   82   * @param  None
//   83   * @retval : None
//   84   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   85 void BusFault_Handler(void)
//   86 {
//   87   /* Go to infinite loop when Bus Fault exception occurs */
//   88   while (1)
BusFault_Handler:
??BusFault_Handler_0:
        B.N      ??BusFault_Handler_0
//   89   {
//   90   }
//   91 }
//   92 
//   93 /**
//   94   * @brief  This function handles Usage Fault exception.
//   95   * @param  None
//   96   * @retval : None
//   97   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   98 void UsageFault_Handler(void)
//   99 {
//  100   /* Go to infinite loop when Usage Fault exception occurs */
//  101   while (1)
UsageFault_Handler:
??UsageFault_Handler_0:
        B.N      ??UsageFault_Handler_0
//  102   {
//  103   }
//  104 }
//  105 
//  106 /**
//  107   * @brief  This function handles SVCall exception.
//  108   * @param  None
//  109   * @retval : None
//  110   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  111 void SVC_Handler(void)
//  112 {
//  113 }
SVC_Handler:
        BX       LR               ;; return
//  114 
//  115 /**
//  116   * @brief  This function handles Debug Monitor exception.
//  117   * @param  None
//  118   * @retval : None
//  119   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  120 void DebugMon_Handler(void)
//  121 {
//  122 }
DebugMon_Handler:
        BX       LR               ;; return
//  123 
//  124 /**
//  125   * @brief  This function handles PendSV_Handler exception.
//  126   * @param  None
//  127   * @retval : None
//  128   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  129 void PendSV_Handler(void)
//  130 {
//  131 }
PendSV_Handler:
        BX       LR               ;; return
//  132 
//  133 /**
//  134   * @brief  This function handles SysTick Handler.
//  135   * @param  None
//  136   * @retval : None
//  137   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  138 void SysTick_Handler(void)
//  139 {
//  140 }
SysTick_Handler:
        BX       LR               ;; return

        END
//  141 
//  142 /******************************************************************************/
//  143 /*                 STM32F10x Peripherals Interrupt Handlers                   */
//  144 /*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
//  145 /*  available peripheral interrupt handler's name please refer to the startup */
//  146 /*  file (startup_stm32f10x_xx.s).                                            */
//  147 /******************************************************************************/
//  148 
//  149 /**
//  150   * @brief  This function handles PPP interrupt request.
//  151   * @param  None
//  152   * @retval : None
//  153   */
//  154 /*void PPP_IRQHandler(void)
//  155 {
//  156 }*/
//  157 
//  158 /**
//  159   * @}
//  160   */ 
//  161 
//  162 /**
//  163   * @}
//  164   */ 
//  165 
//  166 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
// 18 bytes in section .text
// 
// 18 bytes of CODE memory
//
//Errors: none
//Warnings: none
